/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ee=function($){for(var t=[],C=0,I=$.length;C<I;C++)t[C]=Z[$[C]];return t};define(Z[68],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.ok=void 0;function C(w,R){if(!w)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}t.ok=C;function I(w,R="Unreachable"){throw new Error(R)}t.assertNever=I}),define(Z[49],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(A){return(v,c,d)=>{let D=null,P=null;if(typeof d.value=="function"?(D="value",P=d.value):typeof d.get=="function"&&(D="get",P=d.get),!P)throw new Error("not supported");d[D]=A(P,c)}}t.createDecorator=C;function I(A,v,c){let d=null,D=null;if(typeof c.value=="function"?(d="value",D=c.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",D=c.get),!D)throw new Error("not supported");const P=`$memoize$${v}`;c[d]=function(...h){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,h)}),this[P]}}t.memoize=I;function w(A,v,c){return C((d,D)=>{const P=`$debounce$${D}`,h=`$debounce$result$${D}`;return function(...S){this[h]||(this[h]=c?c():void 0),clearTimeout(this[P]),v&&(this[h]=v(this[h],...S),S=[this[h]]),this[P]=setTimeout(()=>{d.apply(this,S),this[h]=c?c():void 0},A)}})}t.debounce=w;function R(A,v,c){return C((d,D)=>{const P=`$throttle$timer$${D}`,h=`$throttle$result$${D}`,S=`$throttle$lastRun$${D}`,f=`$throttle$pending$${D}`;return function(...m){if(this[h]||(this[h]=c?c():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),v&&(this[h]=v(this[h],...m)),this[f])return;const E=this[S]+A;E<=Date.now()?(this[S]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0):(this[f]=!0,this[P]=setTimeout(()=>{this[f]=!1,this[S]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0},E-Date.now()))}})}t.throttle=R}),define(Z[50],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var I;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(I=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function A(i,n=!1){let e=0;const r=i.length;let o="",p=0,y=16,b=0;function k(re){let ge=0,ae=0;for(;ge<re;){const N=i.charCodeAt(e);if(N>=48&&N<=57)ae=ae*16+N-48;else if(N>=65&&N<=70)ae=ae*16+N-65+10;else if(N>=97&&N<=102)ae=ae*16+N-97+10;else break;e++,ge++}return ge<re&&(ae=-1),ae}function x(re){e=re,o="",p=0,y=16,b=0}function _(){const re=e;if(i.charCodeAt(e)===48)e++;else for(e++;e<i.length&&d(i.charCodeAt(e));)e++;if(e<i.length&&i.charCodeAt(e)===46)if(e++,e<i.length&&d(i.charCodeAt(e)))for(e++;e<i.length&&d(i.charCodeAt(e));)e++;else return b=3,i.substring(re,e);let ge=e;if(e<i.length&&(i.charCodeAt(e)===69||i.charCodeAt(e)===101))if(e++,(e<i.length&&i.charCodeAt(e)===43||i.charCodeAt(e)===45)&&e++,e<i.length&&d(i.charCodeAt(e))){for(e++;e<i.length&&d(i.charCodeAt(e));)e++;ge=e}else b=3;return i.substring(re,ge)}function G(){let re="",ge=e;for(;;){if(e>=r){re+=i.substring(ge,e),b=2;break}const ae=i.charCodeAt(e);if(ae===34){re+=i.substring(ge,e),e++;break}if(ae===92){if(re+=i.substring(ge,e),e++,e>=r){b=2;break}switch(i.charCodeAt(e++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=k(4);B>=0?re+=String.fromCharCode(B):b=4;break}default:b=5}ge=e;continue}if(ae>=0&&ae<=31)if(c(ae)){re+=i.substring(ge,e),b=2;break}else b=6;e++}return re}function Q(){if(o="",b=0,p=e,e>=r)return p=r,y=17;let re=i.charCodeAt(e);if(v(re)){do e++,o+=String.fromCharCode(re),re=i.charCodeAt(e);while(v(re));return y=15}if(c(re))return e++,o+=String.fromCharCode(re),re===13&&i.charCodeAt(e)===10&&(e++,o+=`
`),y=14;switch(re){case 123:return e++,y=1;case 125:return e++,y=2;case 91:return e++,y=3;case 93:return e++,y=4;case 58:return e++,y=6;case 44:return e++,y=5;case 34:return e++,o=G(),y=10;case 47:{const ge=e-1;if(i.charCodeAt(e+1)===47){for(e+=2;e<r&&!c(i.charCodeAt(e));)e++;return o=i.substring(ge,e),y=12}if(i.charCodeAt(e+1)===42){e+=2;const ae=r-1;let N=!1;for(;e<ae;){if(i.charCodeAt(e)===42&&i.charCodeAt(e+1)===47){e+=2,N=!0;break}e++}return N||(e++,b=1),o=i.substring(ge,e),y=13}return o+=String.fromCharCode(re),e++,y=16}case 45:if(o+=String.fromCharCode(re),e++,e===r||!d(i.charCodeAt(e)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),y=11;default:for(;e<r&&ne(re);)e++,re=i.charCodeAt(e);if(p!==e){switch(o=i.substring(p,e),o){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return o+=String.fromCharCode(re),e++,y=16}}function ne(re){if(v(re)||c(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let re;do re=Q();while(re>=12&&re<=15);return re}return{setPosition:x,getPosition:()=>e,scan:n?ce:Q,getToken:()=>y,getTokenValue:()=>o,getTokenOffset:()=>p,getTokenLength:()=>e-p,getTokenError:()=>b}}t.createScanner=A;function v(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function c(i){return i===10||i===13||i===8232||i===8233}function d(i){return i>=48&&i<=57}var D;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(D||(D={}));function P(i,n){const e=[],r=new Object;let o;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function b(k,x,_,G){p.value=k,p.offset=x,p.length=_,p.type=G,p.colonOffset=void 0,o=p}try{g(i,{onObjectBegin:(k,x)=>{if(n<=k)throw r;o=void 0,y=n>k,e.push("")},onObjectProperty:(k,x,_)=>{if(n<x||(b(k,x,_,"property"),e[e.length-1]=k,n<=x+_))throw r},onObjectEnd:(k,x)=>{if(n<=k)throw r;o=void 0,e.pop()},onArrayBegin:(k,x)=>{if(n<=k)throw r;o=void 0,e.push(0)},onArrayEnd:(k,x)=>{if(n<=k)throw r;o=void 0,e.pop()},onLiteralValue:(k,x,_)=>{if(n<x||(b(k,x,_,s(k)),n<=x+_))throw r},onSeparator:(k,x,_)=>{if(n<=x)throw r;if(k===":"&&o&&o.type==="property")o.colonOffset=x,y=!1,o=void 0;else if(k===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(y=!0,e[e.length-1]=""),o=void 0}}})}catch(k){if(k!==r)throw k}return{path:e,previousNode:o,isAtPropertyKey:y,matches:k=>{let x=0;for(let _=0;x<k.length&&_<e.length;_++)if(k[x]===e[_]||k[x]==="*")x++;else if(k[x]!=="**")return!1;return x===k.length}}}t.getLocation=P;function h(i,n=[],e=R.DEFAULT){let r=null,o=[];const p=[];function y(k){Array.isArray(o)?o.push(k):r!==null&&(o[r]=k)}return g(i,{onObjectBegin:()=>{const k={};y(k),p.push(o),o=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const k=[];y(k),p.push(o),o=k,r=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:y,onError:(k,x,_)=>{n.push({error:k,offset:x,length:_})}},e),o[0]}t.parse=h;function S(i,n=[],e=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){r.type==="property"&&(r.length=k-r.offset,r=r.parent)}function p(k){return r.children.push(k),k}g(i,{onObjectBegin:k=>{r=p({type:"object",offset:k,length:-1,parent:r,children:[]})},onObjectProperty:(k,x,_)=>{r=p({type:"property",offset:x,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:k,offset:x,length:_,parent:r})},onObjectEnd:(k,x)=>{r.length=k+x-r.offset,r=r.parent,o(k+x)},onArrayBegin:(k,x)=>{r=p({type:"array",offset:k,length:-1,parent:r,children:[]})},onArrayEnd:(k,x)=>{r.length=k+x-r.offset,r=r.parent,o(k+x)},onLiteralValue:(k,x,_)=>{p({type:s(k),offset:x,length:_,parent:r,value:k}),o(x+_)},onSeparator:(k,x,_)=>{r.type==="property"&&(k===":"?r.colonOffset=x:k===","&&o(x))},onError:(k,x,_)=>{n.push({error:k,offset:x,length:_})}},e);const b=r.children[0];return b&&delete b.parent,b}t.parseTree=S;function f(i,n){if(!i)return;let e=i;for(const r of n)if(typeof r=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const p of e.children)if(Array.isArray(p.children)&&p.children[0].value===r){e=p.children[1],o=!0;break}if(!o)return}else{const o=r;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}t.findNodeAtLocation=f;function m(i){if(!i.parent||!i.parent.children)return[];const n=m(i.parent);if(i.parent.type==="property"){const e=i.parent.children[0].value;n.push(e)}else if(i.parent.type==="array"){const e=i.parent.children.indexOf(i);e!==-1&&n.push(e)}return n}t.getNodePath=m;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const n=Object.create(null);for(const e of i.children){const r=e.children[1];r&&(n[e.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}t.getNodeValue=E;function l(i,n,e=!1){return n>=i.offset&&n<i.offset+i.length||e&&n===i.offset+i.length}t.contains=l;function u(i,n,e=!1){if(l(i,n,e)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const p=u(r[o],n,e);if(p)return p}return i}}t.findNodeAtOffset=u;function g(i,n,e=R.DEFAULT){const r=A(i,!1);function o(T){return T?()=>T(r.getTokenOffset(),r.getTokenLength()):()=>!0}function p(T){return T?z=>T(z,r.getTokenOffset(),r.getTokenLength()):()=>!0}const y=o(n.onObjectBegin),b=p(n.onObjectProperty),k=o(n.onObjectEnd),x=o(n.onArrayBegin),_=o(n.onArrayEnd),G=p(n.onLiteralValue),Q=p(n.onSeparator),ne=o(n.onComment),ce=p(n.onError),re=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function ae(){for(;;){const T=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:re||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(T){case 12:case 13:re?N(10):ne();break;case 16:N(1);break;case 15:case 14:break;default:return T}}}function N(T,z=[],O=[]){if(ce(T),z.length+O.length>0){let L=r.getToken();for(;L!==17;){if(z.indexOf(L)!==-1){ae();break}else if(O.indexOf(L)!==-1)break;L=ae()}}}function B(T){const z=r.getTokenValue();return T?G(z):b(z),ae(),!0}function M(){switch(r.getToken()){case 11:{let T=0;try{T=JSON.parse(r.getTokenValue()),typeof T!="number"&&(N(2),T=0)}catch{N(2)}G(T);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return ae(),!0}function F(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(Q(":"),ae(),Y()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){y(),ae();let T=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(T||N(4,[],[]),Q(","),ae(),r.getToken()===2&&ge)break}else T&&N(6,[],[]);F()||N(4,[],[2,5]),T=!0}return k(),r.getToken()!==2?N(7,[2],[]):ae(),!0}function q(){x(),ae();let T=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(T||N(4,[],[]),Q(","),ae(),r.getToken()===4&&ge)break}else T&&N(6,[],[]);Y()||N(4,[],[4,5]),T=!0}return _(),r.getToken()!==4?N(8,[4],[]):ae(),!0}function Y(){switch(r.getToken()){case 3:return q();case 1:return W();case 10:return B(!0);default:return M()}}return ae(),r.getToken()===17?e.allowEmptyContent?!0:(N(4,[],[]),!1):Y()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}t.visit=g;function a(i,n){const e=A(i),r=[];let o,p=0,y;do switch(y=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:p!==y&&r.push(i.substring(p,y)),n!==void 0&&r.push(e.getTokenValue().replace(/[^\r\n]/g,n)),p=e.getPosition();break}while(o!==17);return r.join("")}t.stripComments=a;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(w){const R=[];typeof w=="number"&&R.push("code/timeOrigin",w);function A(c){R.push(c,Date.now())}function v(){const c=[];for(let d=0;d<R.length;d+=2)c.push({name:R[d],startTime:R[d+1]});return c}return{mark:A,getMarks:v}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(w+A.startTime)});return R}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function C(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var I in C)(typeof exports=="object"?exports:$)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function C(I){if(t[I])return t[I].exports;var w=t[I]={i:I,l:!1,exports:{}};return $[I].call(w.exports,w,w.exports,C),w.l=!0,w.exports}return C.m=$,C.c=t,C.d=function(I,w,R){C.o(I,w)||Object.defineProperty(I,w,{enumerable:!0,get:R})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,w){if(1&w&&(I=C(I)),8&w||4&w&&typeof I=="object"&&I&&I.__esModule)return I;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:I}),2&w&&typeof I!="string")for(var A in I)C.d(R,A,function(v){return I[v]}.bind(null,A));return R},C.n=function(I){var w=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(w,"a",w),w},C.o=function(I,w){return Object.prototype.hasOwnProperty.call(I,w)},C.p="",C(C.s=0)}([function($,t,C){(function(I){var w;t=$.exports=O,w=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=t.re=[],c=t.src=[],d=0,D=d++;c[D]="0|[1-9]\\d*";var P=d++;c[P]="[0-9]+";var h=d++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=d++;c[S]="("+c[D]+")\\.("+c[D]+")\\.("+c[D]+")";var f=d++;c[f]="("+c[P]+")\\.("+c[P]+")\\.("+c[P]+")";var m=d++;c[m]="(?:"+c[D]+"|"+c[h]+")";var E=d++;c[E]="(?:"+c[P]+"|"+c[h]+")";var l=d++;c[l]="(?:-("+c[m]+"(?:\\."+c[m]+")*))";var u=d++;c[u]="(?:-?("+c[E]+"(?:\\."+c[E]+")*))";var g=d++;c[g]="[0-9A-Za-z-]+";var a=d++;c[a]="(?:\\+("+c[g]+"(?:\\."+c[g]+")*))";var s=d++,i="v?"+c[S]+c[l]+"?"+c[a]+"?";c[s]="^"+i+"$";var n="[v=\\s]*"+c[f]+c[u]+"?"+c[a]+"?",e=d++;c[e]="^"+n+"$";var r=d++;c[r]="((?:<|>)?=?)";var o=d++;c[o]=c[P]+"|x|X|\\*";var p=d++;c[p]=c[D]+"|x|X|\\*";var y=d++;c[y]="[v=\\s]*("+c[p]+")(?:\\.("+c[p]+")(?:\\.("+c[p]+")(?:"+c[l]+")?"+c[a]+"?)?)?";var b=d++;c[b]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[u]+")?"+c[a]+"?)?)?";var k=d++;c[k]="^"+c[r]+"\\s*"+c[y]+"$";var x=d++;c[x]="^"+c[r]+"\\s*"+c[b]+"$";var _=d++;c[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=d++;c[G]="(?:~>?)";var Q=d++;c[Q]="(\\s*)"+c[G]+"\\s+",v[Q]=new RegExp(c[Q],"g");var ne=d++;c[ne]="^"+c[G]+c[y]+"$";var ce=d++;c[ce]="^"+c[G]+c[b]+"$";var re=d++;c[re]="(?:\\^)";var ge=d++;c[ge]="(\\s*)"+c[re]+"\\s+",v[ge]=new RegExp(c[ge],"g");var ae=d++;c[ae]="^"+c[re]+c[y]+"$";var N=d++;c[N]="^"+c[re]+c[b]+"$";var B=d++;c[B]="^"+c[r]+"\\s*("+n+")$|^$";var M=d++;c[M]="^"+c[r]+"\\s*("+i+")$|^$";var F=d++;c[F]="(\\s*)"+c[r]+"\\s*("+n+"|"+c[y]+")",v[F]=new RegExp(c[F],"g");var W=d++;c[W]="^\\s*("+c[y]+")\\s+-\\s+("+c[y]+")\\s*$";var q=d++;c[q]="^\\s*("+c[b]+")\\s+-\\s+("+c[b]+")\\s*$";var Y=d++;c[Y]="(<|>)?=?\\s*\\*";for(var T=0;T<35;T++)w(T,c[T]),v[T]||(v[T]=new RegExp(c[T]));function z(j,K){if(j instanceof O)return j;if(typeof j!="string"||j.length>R||!(K?v[e]:v[s]).test(j))return null;try{return new O(j,K)}catch{return null}}function O(j,K){if(j instanceof O){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof O))return new O(j,K);w("SemVer",j,K),this.loose=K;var J=j.trim().match(K?v[e]:v[s]);if(!J)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<A)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}t.parse=z,t.valid=function(j,K){var J=z(j,K);return J?J.version:null},t.clean=function(j,K){var J=z(j.trim().replace(/^[=v]+/,""),K);return J?J.version:null},t.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(j){return w("SemVer.compare",this.version,this.loose,j),j instanceof O||(j=new O(j,this.loose)),this.compareMain(j)||this.comparePre(j)},O.prototype.compareMain=function(j){return j instanceof O||(j=new O(j,this.loose)),U(this.major,j.major)||U(this.minor,j.minor)||U(this.patch,j.patch)},O.prototype.comparePre=function(j){if(j instanceof O||(j=new O(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ue=j.prerelease[K];if(w("prerelease compare",K,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return U(J,ue)}while(++K)},O.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},t.inc=function(j,K,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new O(j,J).inc(K,ue).version}catch{return null}},t.diff=function(j,K){if(oe(j,K))return null;var J=z(j),ue=z(K);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},t.compareIdentifiers=U;var L=/^[0-9]+$/;function U(j,K){var J=L.test(j),ue=L.test(K);return J&&ue&&(j=+j,K=+K),J&&!ue?-1:ue&&!J?1:j<K?-1:j>K?1:0}function V(j,K,J){return new O(j,J).compare(new O(K,J))}function H(j,K,J){return V(j,K,J)>0}function X(j,K,J){return V(j,K,J)<0}function oe(j,K,J){return V(j,K,J)===0}function le(j,K,J){return V(j,K,J)!==0}function pe(j,K,J){return V(j,K,J)>=0}function ve(j,K,J){return V(j,K,J)<=0}function ie(j,K,J,ue){var me;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),me=j===J;break;case"!==":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),me=j!==J;break;case"":case"=":case"==":me=oe(j,J,ue);break;case"!=":me=le(j,J,ue);break;case">":me=H(j,J,ue);break;case">=":me=pe(j,J,ue);break;case"<":me=X(j,J,ue);break;case"<=":me=ve(j,J,ue);break;default:throw new TypeError("Invalid operator: "+K)}return me}function se(j,K){if(j instanceof se){if(j.loose===K)return j;j=j.value}if(!(this instanceof se))return new se(j,K);w("comparator",j,K),this.loose=K,this.parse(j),this.semver===he?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(j,K){return U(K,j)},t.major=function(j,K){return new O(j,K).major},t.minor=function(j,K){return new O(j,K).minor},t.patch=function(j,K){return new O(j,K).patch},t.compare=V,t.compareLoose=function(j,K){return V(j,K,!0)},t.rcompare=function(j,K,J){return V(K,j,J)},t.sort=function(j,K){return j.sort(function(J,ue){return t.compare(J,ue,K)})},t.rsort=function(j,K){return j.sort(function(J,ue){return t.rcompare(J,ue,K)})},t.gt=H,t.lt=X,t.eq=oe,t.neq=le,t.gte=pe,t.lte=ve,t.cmp=ie,t.Comparator=se;var he={};function de(j,K){if(j instanceof de)return j.loose===K?j:new de(j.raw,K);if(j instanceof se)return new de(j.value,K);if(!(this instanceof de))return new de(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function Se(j){return!j||j.toLowerCase()==="x"||j==="*"}function Le(j,K,J,ue,me,Ce,we,Te,be,De,Me,Re,Oe){return((K=Se(J)?"":Se(ue)?">="+J+".0.0":Se(me)?">="+J+"."+ue+".0":">="+K)+" "+(Te=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Te)).trim()}function Fe(j,K){for(var J=0;J<j.length;J++)if(!j[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<j.length;J++)if(w(j[J].semver),j[J].semver!==he&&j[J].semver.prerelease.length>0){var ue=j[J].semver;if(ue.major===K.major&&ue.minor===K.minor&&ue.patch===K.patch)return!0}return!1}return!0}function Ue(j,K,J){try{K=new de(K,J)}catch{return!1}return K.test(j)}function xe(j,K,J,ue){var me,Ce,we,Te,be;switch(j=new O(j,ue),K=new de(K,ue),J){case">":me=H,Ce=ve,we=X,Te=">",be=">=";break;case"<":me=X,Ce=pe,we=H,Te="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(j,K,ue))return!1;for(var De=0;De<K.set.length;++De){var Me=K.set[De],Re=null,Oe=null;if(Me.forEach(function(Ae){Ae.semver===he&&(Ae=new se(">=0.0.0")),Re=Re||Ae,Oe=Oe||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Oe.semver,ue)&&(Oe=Ae)}),Re.operator===Te||Re.operator===be||(!Oe.operator||Oe.operator===Te)&&Ce(j,Oe.semver)||Oe.operator===be&&we(j,Oe.semver))return!1}return!0}se.prototype.parse=function(j){var K=this.loose?v[B]:v[M],J=j.match(K);if(!J)throw new TypeError("Invalid comparator: "+j);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new O(J[2],this.loose):this.semver=he},se.prototype.toString=function(){return this.value},se.prototype.test=function(j){return w("Comparator.test",j,this.loose),this.semver===he||(typeof j=="string"&&(j=new O(j,this.loose)),ie(j,this.operator,this.semver,this.loose))},se.prototype.intersects=function(j,K){if(!(j instanceof se))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new de(j.value,K),Ue(this.value,J,K);if(j.operator==="")return J=new de(this.value,K),Ue(j.semver,J,K);var ue=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ce=this.semver.version===j.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Te=ie(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),be=ie(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ue||me||Ce&&we||Te||be},t.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),w("range",j,K);var J=K?v[q]:v[W];j=j.replace(J,Le),w("hyphen replace",j),j=j.replace(v[F],"$1$2$3"),w("comparator trim",j,v[F]),j=(j=(j=j.replace(v[Q],"$1~")).replace(v[ge],"$1^")).split(/\s+/).join(" ");var ue=K?v[B]:v[M],me=j.split(" ").map(function(Ce){return function(we,Te){return w("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){w("caret",Re,Oe);var Ae=Oe?v[N]:v[ae];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(w("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),w("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Te),w("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){var Ae=Oe?v[ce]:v[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",w("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Te),w("tildes",we),we=function(be,De){return w("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Oe){Re=Re.trim();var Ae=Oe?v[x]:v[k];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,ke){w("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=Se(Ee),ze=We||Se(Pe),je=ze||Se(Ie);return ye==="="&&je&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),w("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Te),w("xrange",we),we=function(be,De){return w("replaceStars",be,De),be.trim().replace(v[Y],"")}(we,Te),w("stars",we),we}(Ce,K)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new se(Ce,K)})},de.prototype.intersects=function(j,K){if(!(j instanceof de))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return j.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,K)})})})})},t.toComparators=function(j,K){return new de(j,K).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new O(j,this.loose));for(var K=0;K<this.set.length;K++)if(Fe(this.set[K],j))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(j,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return j.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new O(ue=we,J)))}),ue},t.minSatisfying=function(j,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return j.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new O(ue=we,J)))}),ue},t.validRange=function(j,K){try{return new de(j,K).range||"*"}catch{return null}},t.ltr=function(j,K,J){return xe(j,K,"<",J)},t.gtr=function(j,K,J){return xe(j,K,">",J)},t.outside=xe,t.prerelease=function(j,K){var J=z(j,K);return J&&J.prerelease.length?J.prerelease:null},t.intersects=function(j,K,J){return j=new de(j,J),K=new de(K,J),j.intersects(K)},t.coerce=function(j){if(j instanceof O)return j;if(typeof j!="string")return null;var K=j.match(v[_]);return K==null?null:z((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,C(1))},function($,t){var C,I,w=$.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(E){if(C===setTimeout)return setTimeout(E,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(E,0);try{return C(E,0)}catch{try{return C.call(null,E,0)}catch{return C.call(this,E,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{I=typeof clearTimeout=="function"?clearTimeout:A}catch{I=A}})();var c,d=[],D=!1,P=-1;function h(){D&&c&&(D=!1,c.length?d=c.concat(d):P=-1,d.length&&S())}function S(){if(!D){var E=v(h);D=!0;for(var l=d.length;l;){for(c=d,d=[];++P<l;)c&&c[P].run();P=-1,l=d.length}c=null,D=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===A||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(E)}}function f(E,l){this.fun=E,this.array=l}function m(){}w.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];d.push(new f(E,l)),d.length!==1||D||v(S)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=m,w.addListener=m,w.once=m,w.off=m,w.removeListener=m,w.removeAllListeners=m,w.emit=m,w.prependListener=m,w.prependOnceListener=m,w.listeners=function(E){return[]},w.binding=function(E){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(E){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Z[69],ee([0,1]),function($,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class I{constructor(v,c,d){this.level=v,this.key=c,this.value=d,this.forward=[]}}const w=void 0;class R{constructor(v,c=2**16){this.comparator=v,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new I(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,w,w)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,c){return R._insert(this,v,c,this.comparator)&&(this._size+=1),this}delete(v){const c=R._delete(this,v,this.comparator);return c&&(this._size-=1),c}forEach(v,c){let d=this._header.forward[0];for(;d;)v.call(c,d.value,d.key,this),d=d.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",c=this._header.forward[0];for(;c;)v+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return v}static _search(v,c,d){let D=v._header;for(let P=v._level-1;P>=0;P--)for(;D.forward[P]&&d(D.forward[P].key,c)<0;)D=D.forward[P];if(D=D.forward[0],D&&d(D.key,c)===0)return D}static _insert(v,c,d,D){const P=[];let h=v._header;for(let S=v._level-1;S>=0;S--){for(;h.forward[S]&&D(h.forward[S].key,c)<0;)h=h.forward[S];P[S]=h}if(h=h.forward[0],h&&D(h.key,c)===0)return h.value=d,!1;{const S=R._randomLevel(v);if(S>v._level){for(let f=v._level;f<S;f++)P[f]=v._header;v._level=S}h=new I(S,c,d);for(let f=0;f<S;f++)h.forward[f]=P[f].forward[f],P[f].forward[f]=h;return!0}}static _randomLevel(v,c=.5){let d=1;for(;Math.random()<c&&d<v._maxLevel;)d+=1;return d}static _delete(v,c,d){const D=[];let P=v._header;for(let h=v._level-1;h>=0;h--){for(;P.forward[h]&&d(P.forward[h].key,c)<0;)P=P.forward[h];D[h]=P}if(P=P.forward[0],!P||d(P.key,c)!==0)return!1;for(let h=0;h<v._level&&D[h].forward[h]===P;h++)D[h].forward[h]=P.forward[h];for(;v._level>0&&v._header.forward[v._level-1]===w;)v._level-=1;return!0}}t.SkipList=R}),define(Z[43],ee([0,1,12,2]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function w(a){const s=a;return s?typeof s.read=="function":!1}t.isReadable=w;function R(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}t.isReadableStream=R;function A(a){const s=a;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=A;function v(a,s){return new c(a,s)}t.newWriteableStream=v;class c{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const e=n.indexOf(i);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(a,s){const i=[];let n;for(;(n=a.read())!==null;)i.push(n);return s(i)}t.consumeReadable=d;function D(a,s,i){const n=[];let e;for(;(e=a.read())!==null&&n.length<i;)n.push(e);return e===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof e!="undefined"){const r=e;return e=void 0,r}return a.read()}}}t.peekReadable=D;function P(a,s){return new Promise((i,n)=>{const e=[];h(a,{onData:r=>{s&&e.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(e):void 0)}})})}t.consumeStream=P;function h(a,s){let i=!1;return a.on("error",n=>{i||s.onError(n)}),a.on("end",()=>{i||s.onEnd()}),a.on("data",n=>{i||s.onData(n)}),(0,I.toDisposable)(()=>i=!0)}t.listenStream=h;function S(a,s){return new Promise((i,n)=>{const e=new I.DisposableStore,r=[],o=b=>{if(r.push(b),r.length>s)return e.dispose(),a.pause(),i({stream:a,buffer:r,ended:!1})},p=b=>n(b),y=()=>i({stream:a,buffer:r,ended:!0});e.add((0,I.toDisposable)(()=>a.removeListener("error",p))),a.on("error",p),e.add((0,I.toDisposable)(()=>a.removeListener("end",y))),a.on("end",y),e.add((0,I.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}t.peekStream=S;function f(a,s){const i=v(s);return i.end(a),i}t.toStream=f;function m(){const a=v(()=>{throw new Error("not supported")});return a.end(),a}t.emptyStream=m;function E(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}t.toReadable=E;function l(a,s,i){const n=v(i);return h(a,{onData:e=>n.write(s.data(e)),onError:e=>n.error(s.error?s.error(e):e),onEnd:()=>n.end()}),n}t.transform=l;function u(a,s,i){let n=!1;return{read:()=>{const e=s.read();return n?e:(n=!0,e!==null?i([a,e]):a)}}}t.prefixedReadable=u;function g(a,s,i){let n=!1;const e=v(i);return h(s,{onData:r=>n?e.write(r):(n=!0,e.write(i([a,r]))),onError:r=>e.error(r),onEnd:()=>{n||(n=!0,e.write(a)),e.end()}}),e}t.prefixedStream=g}),define(Z[15],ee([0,1,43]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined";let w,R;class A{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return I?new A(Buffer.allocUnsafe(b)):new A(new Uint8Array(b))}static wrap(b){return I&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new A(b)}static fromString(b,k){return!(k?.dontUseNodeBuffer||!1)&&I?new A(Buffer.from(b)):(w||(w=new TextEncoder),new A(w.encode(b)))}static fromByteArray(b){const k=A.alloc(b.length);for(let x=0,_=b.length;x<_;x++)k.buffer[x]=b[x];return k}static concat(b,k){if(typeof k=="undefined"){k=0;for(let G=0,Q=b.length;G<Q;G++)k+=b[G].byteLength}const x=A.alloc(k);let _=0;for(let G=0,Q=b.length;G<Q;G++){const ne=b[G];x.set(ne,_),_+=ne.byteLength}return x}clone(){const b=A.alloc(this.byteLength);return b.set(this),b}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,k){return new A(this.buffer.subarray(b,k))}set(b,k){if(b instanceof A)this.buffer.set(b.buffer,k);else if(b instanceof Uint8Array)this.buffer.set(b,k);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),k);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,k){D(this.buffer,b,k)}readUInt32LE(b){return P(this.buffer,b)}writeUInt32LE(b,k){h(this.buffer,b,k)}readUInt8(b){return S(this.buffer,b)}writeUInt8(b,k){f(this.buffer,b,k)}}t.VSBuffer=A;function v(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0}t.readUInt16LE=v;function c(y,b,k){y[k+0]=b&255,b=b>>>8,y[k+1]=b&255}t.writeUInt16LE=c;function d(y,b){return y[b]*2**24+y[b+1]*2**16+y[b+2]*2**8+y[b+3]}t.readUInt32BE=d;function D(y,b,k){y[k+3]=b,b=b>>>8,y[k+2]=b,b=b>>>8,y[k+1]=b,b=b>>>8,y[k]=b}t.writeUInt32BE=D;function P(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0|y[b+2]<<16>>>0|y[b+3]<<24>>>0}t.readUInt32LE=P;function h(y,b,k){y[k+0]=b&255,b=b>>>8,y[k+1]=b&255,b=b>>>8,y[k+2]=b&255,b=b>>>8,y[k+3]=b&255}t.writeUInt32LE=h;function S(y,b){return y[b]}t.readUInt8=S;function f(y,b,k){y[k]=b}t.writeUInt8=f;function m(y){return C.consumeReadable(y,b=>A.concat(b))}t.readableToBuffer=m;function E(y){return C.toReadable(y)}t.bufferToReadable=E;function l(y){return C.consumeStream(y,b=>A.concat(b))}t.streamToBuffer=l;async function u(y){return y.ended?A.concat(y.buffer):A.concat([...y.buffer,await l(y.stream)])}t.bufferedStreamToBuffer=u;function g(y){return C.toStream(y,b=>A.concat(b))}t.bufferToStream=g;function a(y){return C.transform(y,{data:b=>typeof b=="string"?A.fromString(b):A.wrap(b)},b=>A.concat(b))}t.streamToBufferReadableStream=a;function s(y){return C.newWriteableStream(b=>A.concat(b),y)}t.newWriteableBufferStream=s;function i(y,b){return C.prefixedReadable(y,b,k=>A.concat(k))}t.prefixedBufferReadable=i;function n(y,b){return C.prefixedStream(y,b,k=>A.concat(k))}t.prefixedBufferStream=n;function e(y){let b=0,k=0,x=0;const _=new Uint8Array(Math.floor(y.length/4*3)),G=ne=>{switch(k){case 3:_[x++]=b|ne,k=0;break;case 2:_[x++]=b|ne>>>2,b=ne<<6,k=3;break;case 1:_[x++]=b|ne>>>4,b=ne<<4,k=2;break;default:b=ne<<2,k=1}};for(let ne=0;ne<y.length;ne++){const ce=y.charCodeAt(ne);if(ce>=65&&ce<=90)G(ce-65);else if(ce>=97&&ce<=122)G(ce-97+26);else if(ce>=48&&ce<=57)G(ce-48+52);else if(ce===43||ce===45)G(62);else if(ce===47||ce===95)G(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${y[ne]}`)}}const Q=x;for(;k>0;)G(0);return A.wrap(_).slice(0,Q)}t.decodeBase64=e;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:y},b=!0,k=!1){const x=k?o:r;let _="";const G=y.byteLength%3;let Q=0;for(;Q<y.byteLength-G;Q+=3){const ne=y[Q+0],ce=y[Q+1],re=y[Q+2];_+=x[ne>>>2],_+=x[(ne<<4|ce>>>4)&63],_+=x[(ce<<2|re>>>6)&63],_+=x[re&63]}if(G===1){const ne=y[Q+0];_+=x[ne>>>2],_+=x[ne<<4&63],b&&(_+="==")}else if(G===2){const ne=y[Q+0],ce=y[Q+1];_+=x[ne>>>2],_+=x[(ne<<4|ce>>>4)&63],_+=x[ce<<2&63],b&&(_+="=")}return _}t.encodeBase64=p}),define(Z[26],ee([0,1,5]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.keys(l).forEach(g=>{l[g]&&typeof l[g]=="object"?u[g]=I(l[g]):u[g]=l[g]}),u}t.deepClone=I;function w(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const a in g)if(R.call(g,a)){const s=g[a];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.isTypedArray)(s)&&u.push(s)}}return l}t.deepFreeze=w;const R=Object.prototype.hasOwnProperty;function A(l,u){return v(l,u,new Set)}t.cloneAndChange=A;function v(l,u,g){if((0,C.isUndefinedOrNull)(l))return l;const a=u(l);if(typeof a!="undefined")return a;if(Array.isArray(l)){const s=[];for(const i of l)s.push(v(i,u,g));return s}if((0,C.isObject)(l)){if(g.has(l))throw new Error("Cannot clone recursive data-structure");g.add(l);const s={};for(const i in l)R.call(l,i)&&(s[i]=v(l[i],u,g));return g.delete(l),s}return l}function c(l,u,g=!0){return(0,C.isObject)(l)?((0,C.isObject)(u)&&Object.keys(u).forEach(a=>{a in l?g&&((0,C.isObject)(l[a])&&(0,C.isObject)(u[a])?c(l[a],u[a],g):l[a]=u[a]):l[a]=u[a]}),l):u}t.mixin=c;function d(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let g,a;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(g=0;g<l.length;g++)if(!d(l[g],u[g]))return!1}else{const s=[];for(a in l)s.push(a);s.sort();const i=[];for(a in u)i.push(a);if(i.sort(),!d(s,i))return!1;for(g=0;g<s.length;g++)if(!d(l[s[g]],u[s[g]]))return!1}return!0}t.equals=d;function D(l){const u=new Set;return JSON.stringify(l,(g,a)=>{if((0,C.isObject)(a)||Array.isArray(a)){if(u.has(a))return"[Circular]";u.add(a)}return a})}t.safeStringify=D;function P(l,u){const g=Object.create(null);return!l||!u||Object.keys(u).forEach(s=>{const i=l[s],n=u[s];d(i,n)||(g[s]=n)}),g}t.distinct=P;function h(l,u){const g=u.toLowerCase(),a=Object.keys(l).find(s=>s.toLowerCase()===g);return a?l[a]:l[u]}t.getCaseInsensitive=h;function S(l,u){const g=Object.create(null);for(const[a,s]of Object.entries(l))u(a,s)&&(g[a]=s);return g}t.filter=S;function f(l){let u=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}t.getAllPropertyNames=f;function m(l){const u=[];for(const g of f(l))typeof l[g]=="function"&&u.push(g);return u}t.getAllMethodNames=m;function E(l,u){const g=s=>function(){const i=Array.prototype.slice.call(arguments,0);return u(s,i)},a={};for(const s of l)a[s]=g(s);return a}t.createProxyObject=E}),define(Z[30],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(w){return C.test(w)}t.isUUID=I,t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(v){for(let c=0;c<v.length;c++)v[c]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){w(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let c=0,d="";return d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d+="-",d+=A[R[c++]],d+=A[R[c++]],d+="-",d+=A[R[c++]],d+=A[R[c++]],d+="-",d+=A[R[c++]],d+=A[R[c++]],d+="-",d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d+=A[R[c++]],d}}()}),define(Z[70],ee([6,7]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[71],ee([0,1,70]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const I=60,w=I*60,R=w*24,A=R*7,v=R*30,c=R*365;function d(P,h,S){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,C.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,C.localize)(1,null);let m;return f<I?(m=f,h?m===1?S?(0,C.localize)(2,null,m):(0,C.localize)(3,null,m):S?(0,C.localize)(4,null,m):(0,C.localize)(5,null,m):m===1?S?(0,C.localize)(6,null,m):(0,C.localize)(7,null,m):S?(0,C.localize)(8,null,m):(0,C.localize)(9,null,m)):f<w?(m=Math.floor(f/I),h?m===1?S?(0,C.localize)(10,null,m):(0,C.localize)(11,null,m):S?(0,C.localize)(12,null,m):(0,C.localize)(13,null,m):m===1?S?(0,C.localize)(14,null,m):(0,C.localize)(15,null,m):S?(0,C.localize)(16,null,m):(0,C.localize)(17,null,m)):f<R?(m=Math.floor(f/w),h?m===1?S?(0,C.localize)(18,null,m):(0,C.localize)(19,null,m):S?(0,C.localize)(20,null,m):(0,C.localize)(21,null,m):m===1?S?(0,C.localize)(22,null,m):(0,C.localize)(23,null,m):S?(0,C.localize)(24,null,m):(0,C.localize)(25,null,m)):f<A?(m=Math.floor(f/R),h?m===1?(0,C.localize)(26,null,m):(0,C.localize)(27,null,m):m===1?(0,C.localize)(28,null,m):(0,C.localize)(29,null,m)):f<v?(m=Math.floor(f/A),h?m===1?S?(0,C.localize)(30,null,m):(0,C.localize)(31,null,m):S?(0,C.localize)(32,null,m):(0,C.localize)(33,null,m):m===1?S?(0,C.localize)(34,null,m):(0,C.localize)(35,null,m):S?(0,C.localize)(36,null,m):(0,C.localize)(37,null,m)):f<c?(m=Math.floor(f/v),h?m===1?S?(0,C.localize)(38,null,m):(0,C.localize)(39,null,m):S?(0,C.localize)(40,null,m):(0,C.localize)(41,null,m):m===1?S?(0,C.localize)(42,null,m):(0,C.localize)(43,null,m):S?(0,C.localize)(44,null,m):(0,C.localize)(45,null,m)):(m=Math.floor(f/c),h?m===1?S?(0,C.localize)(46,null,m):(0,C.localize)(47,null,m):S?(0,C.localize)(48,null,m):(0,C.localize)(49,null,m):m===1?S?(0,C.localize)(50,null,m):(0,C.localize)(51,null,m):S?(0,C.localize)(52,null,m):(0,C.localize)(53,null,m))}t.fromNow=d;function D(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=D}),define(Z[72],ee([6,7]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[31],ee([0,1,19,5,72]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function R(P,h){return h&&(P.stack||P.stacktrace)?w.localize(0,null,v(P),A(P.stack)||A(P.stacktrace)):v(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function v(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?w.localize(1,null,P.message):P.message||w.localize(2,null)}function c(P=null,h=!1){if(!P)return w.localize(3,null);if(Array.isArray(P)){const S=C.coalesce(P),f=c(S[0],h);return S.length>1?w.localize(4,null,f,S.length):f}if(I.isString(P))return P;if(P.detail){const S=P.detail;if(S.error)return R(S.error,h);if(S.exception)return R(S.exception,h)}return P.stack?R(P,h):P.message?P.message:w.localize(5,null)}t.toErrorMessage=c;function d(P){const h=P;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=d;function D(P,h){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=h,S}t.createErrorWithActions=D}),define(Z[73],ee([6,7]),function($,t){return $.create("vs/base/common/jsonErrorMessages",t)}),define(Z[74],ee([0,1,73]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0;function I(w){switch(w){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}t.getParseErrorMessage=I}),define(Z[51],ee([0,1,13]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeDangerousEnvVariables=t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var I;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(I=t.Source||(t.Source={}));var w;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(w=t.TerminateResponseCode||(t.TerminateResponseCode={}));function R(v,...c){const d=c.reduce((h,S)=>(h[S]=!0,h),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(h=>!d[h]).forEach(h=>{for(let S=0;S<D.length;S++)if(h.search(D[S])!==-1){delete v[h];break}})}t.sanitizeProcessEnvironment=R;function A(v){!v||(delete v.DEBUG,C.isMacintosh&&delete v.DYLD_LIBRARY_PATH,C.isLinux&&delete v.LD_PRELOAD)}t.removeDangerousEnvVariables=A}),define(Z[52],ee([0,1,4,2]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MutableObservableValue=t.staticObservableValue=void 0;const w=A=>({onDidChange:C.Event.None,value:A});t.staticObservableValue=w;class R extends I.Disposable{constructor(v){super();this._value=v,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}}t.MutableObservableValue=R}),define(Z[53],ee([0,1,27]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function I(l){return w(l,0)}t.hash=I;function w(l,u){switch(typeof l){case"object":return l===null?R(349,u):Array.isArray(l)?c(l,u):d(l,u);case"string":return v(l,u);case"boolean":return A(l,u);case"number":return R(l,u);case"undefined":return R(937,u);default:return R(617,u)}}t.doHash=w;function R(l,u){return(u<<5)-u+l|0}t.numberHash=R;function A(l,u){return R(l?433:863,u)}function v(l,u){u=R(149417,u);for(let g=0,a=l.length;g<a;g++)u=R(l.charCodeAt(g),u);return u}t.stringHash=v;function c(l,u){return u=R(104579,u),l.reduce((g,a)=>w(a,g),u)}function d(l,u){return u=R(181387,u),Object.keys(l).sort().reduce((g,a)=>(g=v(a,g),w(l[a],g)),u)}class D{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=w(u,this._value),this._value}}t.Hasher=D;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function h(l,u,g=32){const a=g-u,s=~((1<<a)-1);return(l<<u|(s&l)>>>a)>>>0}function S(l,u=0,g=l.byteLength,a=0){for(let s=0;s<g;s++)l[u+s]=a}function f(l,u,g="0"){for(;l.length<u;)l=g+l;return l}function m(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),u/4)}t.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const a=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,e;for(i!==0?(n=i,e=-1,i=0):(n=u.charCodeAt(0),e=0);;){let r=n;if(C.isHighSurrogate(n))if(e+1<g){const o=u.charCodeAt(e+1);C.isLowSurrogate(o)?(e++,r=C.computeCodePoint(n,o)):r=65533}else{i=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(a,s,r),e++,e<g)n=u.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(u,g,a){return a<128?u[g++]=a:a<2048?(u[g++]=192|(a&1984)>>>6,u[g++]=128|(a&63)>>>0):a<65536?(u[g++]=224|(a&61440)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0):(u[g++]=240|(a&1835008)>>>18,u[g++]=128|(a&258048)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=E._bigBlock32,g=this._buffDV;for(let y=0;y<64;y+=4)u.setUint32(y,g.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)u.setUint32(y,h(u.getUint32(y-12,!1)^u.getUint32(y-32,!1)^u.getUint32(y-56,!1)^u.getUint32(y-64,!1),1),!1);let a=this._h0,s=this._h1,i=this._h2,n=this._h3,e=this._h4,r,o,p;for(let y=0;y<80;y++)y<20?(r=s&i|~s&n,o=1518500249):y<40?(r=s^i^n,o=1859775393):y<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),p=h(a,5)+r+e+o+u.getUint32(y*4,!1)&4294967295,e=n,n=i,i=h(s,30),s=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[54],ee([0,1,27]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var I;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(I||(I={})),function(w){const R="error",A="warning",v="warn",c="info",d="ignore";function D(h){return h?C.equalsIgnoreCase(R,h)?w.Error:C.equalsIgnoreCase(A,h)||C.equalsIgnoreCase(v,h)?w.Warning:C.equalsIgnoreCase(c,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=D;function P(h){switch(h){case w.Error:return R;case w.Warning:return A;case w.Info:return c;default:return d}}w.toString=P}(I||(I={})),t.default=I}),define(Z[75],ee([0,1,10]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function I(d){const D=d;return D&&typeof D.type=="string"&&typeof D.severity=="string"}t.isRemoteConsoleLog=I;function w(d){const D=[];let P;try{const h=JSON.parse(d.arguments),S=h[h.length-1];S&&S.__$stack&&(h.pop(),P=S.__$stack),D.push(...h)}catch{D.push("Unable to log remote console arguments",d.arguments)}return{args:D,stack:P}}t.parse=w;function R(d){if(typeof d!="string")return R(w(d).stack);const D=d;if(D){const P=A(D),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=R;function A(d){if(!d)return d;const D=d.indexOf(`
`);return D===-1?d:d.substring(0,D)}function v(d,D){const{args:P,stack:h}=w(d),S=typeof P[0]=="string"&&P.length===1;let f=A(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof P[0]=="string"?f&&S?m=[`%c[${D}] %c${P[0]} %c${f}`,c("blue"),c(""),c("grey")]:m=[`%c[${D}] %c${P[0]}`,c("blue"),c(""),...P.slice(1)]:m=[`%c[${D}]%`,c("blue"),...P],f&&!S&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}t.log=v;function c(d){return`color: ${d}`}}),define(Z[44],ee([0,1,15,27,10]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function R(d){return JSON.stringify(d,v)}t.stringify=R;function A(d){let D=JSON.parse(d);return D=c(D),D}t.parse=A;function v(d,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function c(d,D=0){if(!d||D>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return w.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof C.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let P=0;P<d.length;++P)d[P]=c(d[P],D+1);else for(const P in d)Object.hasOwnProperty.call(d,P)&&(d[P]=c(d[P],D+1))}return d}t.revive=c}),define(Z[76],ee([0,1,38,14,20]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var c;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class P{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:s=!1}={}){const i=h({useAlternateBitness:a});if(!i)return null;const n=I.join(i,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let e=-1,r=null;for(const y of await w.Promises.readdir(n)){let b=-1;if(s){const x=y.indexOf("-");if(x<0)continue;const _=y.substring(0,x);if(!R.test(_)||y.substring(x+1)!=="preview")continue;b=parseInt(_,10)}else{if(!R.test(y))continue;b=parseInt(y,10)}if(b<=e)continue;const k=I.join(n,y,"pwsh.exe");!await w.SymlinkSupport.existsFile(k)||(r=k,e=b)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",p=s?" Preview":"";return new P(r,`PowerShell${p}${o}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=a?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const e of await w.Promises.readdir(s))if(i.test(e)){const r=I.join(s,e,"pwsh.exe");return new P(r,n)}return null}function m(){const a=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new P(a,".NET Core PowerShell Global Tool")}function E(){const a=I.join(process.env.windir,d===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(a,"Windows PowerShell",!0)}async function*l(){let a=await S();a&&(yield a),a=await S({useAlternateBitness:!0}),a&&(yield a),a=await f(),a&&(yield a),a=m(),a&&(yield a),a=await S({findPreview:!0}),a&&(yield a),a=await f({findPreview:!0}),a&&(yield a),a=await S({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=E(),a&&(yield a)}async function*u(){for await(const a of l())await a.exists()&&(yield a)}t.enumeratePowerShellInstallations=u;async function g(){for await(const a of u())return a;return null}t.getFirstAvailablePowerShellInstallation=g}),define(Z[55],ee([0,1,14,13,32,51,5,20]),function($,t,C,I,w,R,A,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function c(P=w.env){return P.comspec||"cmd.exe"}t.getWindowsShell=c;function d(P){let h=[],S=!1;const f=function(m){if(S){h.push(m);return}(!P.send(m,l=>{if(l&&console.error(l),S=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||I.isWindows)&&(S=!0)};return{send:f}}t.createQueuedSender=d;var D;(function(P){async function h(S,f,m){if(C.isAbsolute(S))return S;if(f===void 0&&(f=w.cwd()),C.dirname(S)!=="."||(m===void 0&&A.isString(w.env.PATH)&&(m=w.env.PATH.split(C.delimiter)),m===void 0||m.length===0))return C.join(f,S);async function l(u){if(await v.Promises.exists(u)){let g;try{g=await v.Promises.stat(u)}catch(a){a.message.startsWith("EACCES")&&(g=await v.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(C.isAbsolute(u)?g=C.join(u,S):g=C.join(f,u,S),await l(g))return g;let a=g+".com";if(await l(a)||(a=g+".exe",await l(a)))return a}return C.join(f,S)}P.findExecutable=h})(D=t.win32||(t.win32={}))}),define(Z[77],ee([0,1,38,13,76,55]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function A(S,f){return S===1?I.isWindows?P():R.getWindowsShell(f):d(S,f)}t.getSystemShell=A;function v(S,f){return S===1?I.isWindows?h(f):R.getWindowsShell(f):d(S,f)}t.getSystemShellSync=v;let c=null;function d(S,f){if(I.isLinux&&S===2||I.isMacintosh&&S===3)return"/bin/bash";if(!c){let m;if(I.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,C.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}c=m}return c}let D=null;async function P(){return D||(D=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),D}function h(S){if(D)return D;const f=I.isWindows&&parseFloat((0,C.release)())>=10,m=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${S.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?E:R.getWindowsShell(S)}});var fe=this&&this.__decorate||function($,t,C,I){var w=arguments.length,R=w<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,C):I,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($,t,C,I);else for(var v=$.length-1;v>=0;v--)(A=$[v])&&(R=(w<3?A(R):w>3?A(t,C,R):A(t,C))||R);return w>3&&R&&Object.defineProperty(t,C,R),R};define(Z[56],ee([0,1,19,3,15,24,49,12,4,2,44,27,5]),function($,t,C,I,w,R,A,v,c,d,D,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=t.RequestType||(t.RequestType={}));function f(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(m=t.ResponseType||(t.ResponseType={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class g{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(a||(a={}));function s(M){const F=w.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const F=w.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const e={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object)},r=typeof Buffer!="undefined";function o(M,F){if(typeof F=="undefined")M.write(e.Undefined);else if(typeof F=="string"){const W=w.VSBuffer.fromString(F);M.write(e.String),M.write(s(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(F)){const W=w.VSBuffer.wrap(F);M.write(e.Buffer),M.write(s(W.byteLength)),M.write(W)}else if(F instanceof w.VSBuffer)M.write(e.VSBuffer),M.write(s(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(e.Array),M.write(s(F.length));for(const W of F)o(M,W)}else{const W=w.VSBuffer.fromString(JSON.stringify(F));M.write(e.Object),M.write(s(W.byteLength)),M.write(W)}}function p(M){switch(M.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return M.read(i(M)).toString();case a.Buffer:return M.read(i(M)).buffer;case a.VSBuffer:return M.read(i(M));case a.Array:{const W=i(M),q=[];for(let Y=0;Y<W;Y++)q.push(p(M));return q}case a.Object:return JSON.parse(M.read(i(M)).toString())}}class y{constructor(F,W,q=null,Y=1e3){this.protocol=F,this.ctx=W,this.logger=q,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger?.logOutgoing(W,0,1,E(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(W,F.id,1,E(F.type),F.data);return}}}send(F,W=void 0){const q=new g;return o(q,F),o(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const W=new u(F),q=p(W),Y=p(W),T=q[0];switch(T){case 100:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}: ${q[2]}.${q[3]}`,Y),this.onPromise({type:T,id:q[1],channelName:q[2],name:q[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}: ${q[2]}.${q[3]}`,Y),this.onEventListen({type:T,id:q[1],channelName:q[2],name:q[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}`),this.disposeActiveRequest({type:T,id:q[1]});case 103:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}`),this.disposeActiveRequest({type:T,id:q[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=new R.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,F.name,F.arg,q.token)}catch(O){Y=Promise.reject(O)}const T=F.id;Y.then(O=>{this.sendResponse({id:T,data:O,type:201}),this.activeRequests.delete(F.id)},O=>{O instanceof Error?this.sendResponse({id:T,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:T,data:O,type:203}),this.activeRequests.delete(F.id)});const z=(0,d.toDisposable)(()=>q.cancel());this.activeRequests.set(F.id,z)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=F.id,T=W.listen(this.ctx,F.name,F.arg)(z=>this.sendResponse({id:q,data:z,type:204}));this.activeRequests.set(F.id,T)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:q})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=y;var b;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(b=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(F){const W=this;return{call(q,Y,T){return W.isDisposed?Promise.reject(new v.CancellationError):W.requestPromise(F,q,Y,T)},listen(q,Y){return W.isDisposed?c.Event.None:W.requestEvent(F,q,Y)}}}requestPromise(F,W,q,Y=R.CancellationToken.None){const T=this.lastRequestId++,O={id:T,type:100,channelName:F,name:W,arg:q};if(Y.isCancellationRequested)return Promise.reject(new v.CancellationError);let L;return new Promise((V,H)=>{if(Y.isCancellationRequested)return H(new v.CancellationError);const X=()=>{const ve=ie=>{switch(ie.type){case 201:this.handlers.delete(T),V(ie.data);break;case 202:{this.handlers.delete(T);const se=new Error(ie.data.message);se.stack=ie.data.stack,se.name=ie.data.name,H(se);break}case 203:this.handlers.delete(T),H(ie.data);break}};this.handlers.set(T,ve),this.sendRequest(O)};let oe=null;this.state===l.Idle?X():(oe=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,X()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:T,type:101}),H(new v.CancellationError)},pe=Y.onCancellationRequested(le);L=(0,d.combinedDisposable)((0,d.toDisposable)(le),pe),this.activeRequests.add(L)}).finally(()=>{this.activeRequests.delete(L)})}requestEvent(F,W,q){const Y=this.lastRequestId++,z={id:Y,type:102,channelName:F,name:W,arg:q};let O=null;const L=new c.Emitter({onFirstListenerAdd:()=>{O=(0,I.createCancelablePromise)(V=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(L),this.sendRequest(z)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(L),this.sendRequest({id:Y,type:103}))}}),U=V=>L.fire(V.data);return this.handlers.set(Y,U),L.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(W,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger?.logOutgoing(W,F.id,0,f(F.type));return}}}send(F,W=void 0){const q=new g;return o(q,F),o(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const W=new u(F),q=p(W),Y=p(W),T=q[0];switch(T){case 200:return this.logger?.logIncoming(F.byteLength,0,0,E(T)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,q[1],0,E(T),Y),this.onResponse({type:q[0],id:q[1],data:Y})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([A.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class x{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:q})=>{c.Event.once(W.onMessage)(T=>{const z=new u(T),O=p(z),L=new y(W,O),U=new k(W);this.channels.forEach((H,X)=>L.registerChannel(X,H));const V={channelServer:L,channelClient:U,ctx:O};this._connections.add(V),this._onDidAddConnection.fire(V),q(()=>{L.dispose(),U.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const q=this;return{call(Y,T,z){let O;if((0,h.isFunction)(W)){const U=(0,C.getRandomElement)(q.connections.filter(W));O=U?Promise.resolve(U):c.Event.toPromise(c.Event.filter(q.onDidAddConnection,W))}else O=W.routeCall(q,Y,T);const L=O.then(U=>U.channelClient.getChannel(F));return G(L).call(Y,T,z)},listen(Y,T){if((0,h.isFunction)(W))return q.getMulticastEvent(F,W,Y,T);const z=W.routeEvent(q,Y,T).then(O=>O.channelClient.getChannel(F));return G(z).listen(Y,T)}}}getMulticastEvent(F,W,q,Y){const T=this;let z=new d.DisposableStore;const O=new c.Emitter({onFirstListenerAdd:()=>{z=new d.DisposableStore;const L=new c.EventMultiplexer,U=new Map,V=X=>{const le=X.channelClient.getChannel(F).listen(q,Y),pe=L.add(le);U.set(X,pe)},H=X=>{const oe=U.get(X);!oe||(oe.dispose(),U.delete(X))};T.connections.filter(W).forEach(V),c.Event.filter(T.onDidAddConnection,W)(V,void 0,z),T.onDidRemoveConnection(H,void 0,z),L.event(O.fire,O,z),z.add(L)},onLastListenerRemove:()=>{z.dispose()}});return O.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(q=>{q.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=x;class _{constructor(F,W,q=null){const Y=new g;o(Y,W),F.send(Y.buffer),this.channelClient=new k(F,q),this.channelServer=new y(F,W,q)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=_;function G(M){return{call(F,W,q){return M.then(Y=>Y.call(F,W,q))},listen(F,W){const q=new c.Relay;return M.then(Y=>q.input=Y.listen(F,W)),q.event}}}t.getDelayedChannel=G;function Q(M){let F=!1;return{call(W,q,Y){return F?M.call(W,q,Y):(0,I.timeout)(0).then(()=>F=!0).then(()=>M.call(W,q,Y))},listen(W,q){if(F)return M.listen(W,q);const Y=new c.Relay;return(0,I.timeout)(0).then(()=>F=!0).then(()=>Y.input=M.listen(W,q)),Y.event}}}t.getNextTickChannel=Q;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await c.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ne;var ce;(function(M){function F(T,z){const O=T,L=z&&z.disableMarshalling,U=new Map;for(const V in O)q(V)&&U.set(V,c.Event.buffer(O[V],!0));return new class{listen(V,H,X){const oe=U.get(H);if(oe)return oe;if(Y(H)){const le=O[H];if(typeof le=="function")return le.call(O,X)}throw new Error(`Event not found: ${H}`)}call(V,H,X){const oe=O[H];if(typeof oe=="function"){if(!L&&Array.isArray(X))for(let le=0;le<X.length;le++)X[le]=(0,D.revive)(X[le]);return oe.apply(O,X)}throw new Error(`Method not found: ${H}`)}}}M.fromService=F;function W(T,z){const O=z&&z.disableMarshalling;return new Proxy({},{get(L,U){if(typeof U=="string")return z?.properties?.has(U)?z.properties.get(U):Y(U)?function(V){return T.listen(U,V)}:q(U)?T.listen(U):async function(...V){let H;z&&!(0,h.isUndefinedOrNull)(z.context)?H=[z.context,...V]:H=V;const X=await T.call(U,H);return O?X:(0,D.revive)(X)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=W;function q(T){return T[0]==="o"&&T[1]==="n"&&P.isUpperAsciiLetter(T.charCodeAt(2))}function Y(T){return/^onDynamic/.test(T)&&P.isUpperAsciiLetter(T.charCodeAt(9))}})(ce=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function ae(M){return Array.isArray(M)?M.map(ge):ge(M)}function N(M,F,W,q,Y,T,z){z=ae(z);const O=re[Y],L=O[q%O.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(T)?(U=U.concat(z),U.push(")")):U.push(z),console.log.apply(console,U)}t.logWithColors=N;class B{constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,q,Y,T){this._totalOutgoing+=F,N(this._outgoingPrefix,this._totalOutgoing,F,W,q,Y,T)}logIncoming(F,W,q,Y,T){this._totalIncoming+=F,N(this._incomingPrefix,this._totalIncoming,F,W,q,Y,T)}}t.IPCLogger=B}),define(Z[78],ee([0,1,57,3,15,24,75,12,4,2,26,55,51,56]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class f extends S.ChannelServer{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>w.VSBuffer.wrap(Buffer.from(u,"base64")))},l);process.once("disconnect",()=>this.dispose())}}t.Server=f;class m{constructor(l,u){this.modulePath=l,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new I.Delayer(g),this.child=null,this._client=null}getChannel(l){const u=this;return{call(g,a,s){return u.requestPromise(l,g,a,s)},listen(g,a){return u.requestEvent(l,g,a)}}}requestPromise(l,u,g,a=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),i=(0,I.createCancelablePromise)(r=>s.call(u,g,r)),n=a.onCancellationRequested(()=>i.cancel()),e=(0,d.toDisposable)(()=>i.cancel());return this.activeRequests.add(e),i.finally(()=>{n.dispose(),this.activeRequests.delete(e),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(l,u,g){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let a;const s=new c.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(l).listen(u,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,C.fork)(this.modulePath,l,u);const g=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=g.event,e={send:i,onMessage:n};this._client=new S.ChannelClient(e);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,p)=>{process.removeListener("exit",r),this.activeRequests.forEach(y=>(0,d.dispose)(y)),this.activeRequests.clear(),o!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+p),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:p})})}return this._client}getCachedChannel(l){let u=this.channels.get(l);return u||(u=this.client.getChannel(l),this.channels.set(l,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=m}),define(Z[79],ee([0,1,3,4,2,5]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=t.StorageHint||(t.StorageHint={}));function v(P){const h=P;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=v;var c;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(c=t.StorageState||(t.StorageState={}));class d extends w.Disposable{constructor(h,S=Object.create(null)){super();this.database=h,this.options=S,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((S,f)=>this.accept(f,S)),h.deleted?.forEach(S=>this.accept(S,void 0))}accept(h,S){if(this.state===c.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(S)?f=this.cache.delete(h):this.cache.get(h)!==S&&(this.cache.set(h,S),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,S){const f=this.cache.get(h);return(0,R.isUndefinedOrNull)(f)?S:f}getBoolean(h,S){const f=this.get(h);return(0,R.isUndefinedOrNull)(f)?S:f==="true"}getNumber(h,S){const f=this.get(h);return(0,R.isUndefinedOrNull)(f)?S:parseInt(f,10)}async set(h,S){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(h);const f=String(S);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((S,f)=>this.items.set(f,S)),h.delete?.forEach(S=>this.items.delete(S))}async close(){}}t.InMemoryStorageDatabase=D}),define(Z[80],ee([6,7]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[81],ee([6,7]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[82],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[83],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[84],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[85],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(Z[86],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[87],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[88],ee([6,7]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[89],ee([6,7]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[90],ee([6,7]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[91],ee([6,7]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[92],ee([6,7]),function($,t){return $.create("vs/platform/languagePacks/common/languagePacks",t)}),define(Z[93],ee([6,7]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[94],ee([6,7]),function($,t){return $.create("vs/platform/shell/node/shellEnv",t)}),define(Z[95],ee([6,7]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[96],ee([6,7]),function($,t){return $.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(Z[97],ee([6,7]),function($,t){return $.create("vs/platform/workspace/common/workspace",t)}),define(Z[98],ee([0,1,71,49,16,14,32,17,10]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(m,E,l){this._args=m,this.paths=E,this.productService=l,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(w.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get stateResource(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return c.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?c.URI.file((0,R.join)(m,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.resolve)(m):(0,R.normalize)((0,R.join)(w.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,R.resolve)(m):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.resolve)(m);const E=A.env.VSCODE_EXTENSIONS;if(E)return E;const l=A.env.VSCODE_PORTABLE;return l?(0,R.join)(l,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(E=>/^[^:/?#]+?:\/\//.test(E)?c.URI.parse(E):c.URI.file((0,R.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,R.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=A.env.VSCODE_PORTABLE;return m?c.URI.file((0,R.join)(m,"policy.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([I.memoize],d.prototype,"appRoot",null),fe([I.memoize],d.prototype,"userHome",null),fe([I.memoize],d.prototype,"userDataPath",null),fe([I.memoize],d.prototype,"appSettingsHome",null),fe([I.memoize],d.prototype,"tmpDir",null),fe([I.memoize],d.prototype,"cacheHome",null),fe([I.memoize],d.prototype,"stateResource",null),fe([I.memoize],d.prototype,"userRoamingDataHome",null),fe([I.memoize],d.prototype,"userDataSyncHome",null),fe([I.memoize],d.prototype,"userDataSyncLogResource",null),fe([I.memoize],d.prototype,"editSessionsLogResource",null),fe([I.memoize],d.prototype,"sync",null),fe([I.memoize],d.prototype,"machineSettingsResource",null),fe([I.memoize],d.prototype,"workspaceStorageHome",null),fe([I.memoize],d.prototype,"localHistoryHome",null),fe([I.memoize],d.prototype,"keyboardLayoutResource",null),fe([I.memoize],d.prototype,"argvResource",null),fe([I.memoize],d.prototype,"isExtensionDevelopment",null),fe([I.memoize],d.prototype,"untitledWorkspacesHome",null),fe([I.memoize],d.prototype,"installSourcePath",null),fe([I.memoize],d.prototype,"builtinExtensionsPath",null),fe([I.memoize],d.prototype,"extensionsPath",null),fe([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([I.memoize],d.prototype,"extensionDevelopmentKind",null),fe([I.memoize],d.prototype,"extensionTestsLocationURI",null),fe([I.memoize],d.prototype,"debugExtensionHost",null),fe([I.memoize],d.prototype,"serviceMachineIdResource",null),fe([I.memoize],d.prototype,"telemetryLogResource",null),fe([I.memoize],d.prototype,"disableWorkspaceTrust",null),fe([I.memoize],d.prototype,"policyFile",null),t.AbstractNativeEnvironmentService=d;function D(f,m){return S(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}t.parseExtensionHostPort=D;function P(f,m){return S(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}t.parseSearchPort=P;function h(f,m){return S(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}t.parsePtyHostPort=h;function S(f,m,E,l,u,g){const s=Number(m||f)||(l?null:E),i=s?Boolean(!!m):!1;let n;if(g)try{n=JSON.parse(g)}catch{}return{port:s,break:i,debugId:u,env:n}}}),function(){"use strict";function $(t,C,I,w){function R(v){const c=A(v),d=[c];return t.isAbsolute(c)||d.unshift(w),t.resolve(...d)}function A(v){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,I);const D=v["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(P,"AppData","Roaming")}break;case"darwin":d=t.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,I)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[99],ee([0,147,38,16,17,32]),function(t,C,I,w,R,A){const v=R.dirname(w.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return $(C,I,c.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=$(C,I,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[100],ee([0,1,38,98,99]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(v,c){super(v,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,w.getUserDataPath)(v)},c)}}t.NativeEnvironmentService=R}),define(Z[45],ee([0,1,17,54,88,39]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.validateExtensionManifest=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function c(l){return l=l.trim(),l==="*"||A.test(l)}t.isValidVersionStr=c;function d(l){if(!c(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}t.parseVersion=d;function D(l){if(!l)return null;const u=l.majorBase,g=l.majorMustEqual,a=l.minorBase;let s=l.minorMustEqual;const i=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(u===0||(s=!1),n=!1);let e=0;if(l.preRelease){const r=v.exec(l.preRelease);if(r){const[,o,p,y]=r;e=Date.UTC(Number(o),Number(p)-1,Number(y))}}return{majorBase:u,majorMustEqual:g,minorBase:a,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:e}}t.normalizeVersion=D;function P(l,u,g){let a;typeof l=="string"?a=D(d(l)):a=l;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let i;if(typeof g=="string"?i=D(d(g)):i=g,!a||!i)return!1;const n=a.majorBase,e=a.minorBase,r=a.patchBase;let o=i.majorBase,p=i.minorBase,y=i.patchBase;const b=i.notBefore;let k=i.majorMustEqual,x=i.minorMustEqual,_=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:e>p?!0:e<p||s&&s<b?!1:r>=y:(n===1&&o===0&&(!k||!x||!_)&&(o=1,p=0,y=0,k=!0,x=!1,_=!1),n<o?!1:n>o?!k:e<p?!1:e>p?!x:r<y?!1:r>y?!_:!(s&&s<b))}t.isValidVersion=P;function h(l,u,g,a,s){const i=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return i.push([I.default.Error,w.localize(0,null)]),i;if(typeof a.name!="string")return i.push([I.default.Error,w.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([I.default.Error,w.localize(2,null,"version")]),i;if(!a.engines)return i.push([I.default.Error,w.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([I.default.Error,w.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies!="undefined"&&!E(a.extensionDependencies))return i.push([I.default.Error,w.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents!="undefined"){if(!E(a.activationEvents))return i.push([I.default.Error,w.localize(6,null,"activationEvents")]),i;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return i.push([I.default.Error,w.localize(7,null,"activationEvents","main")]),i}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&i.push([I.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return i.push([I.default.Error,w.localize(9,null,"main")]),i;{const r=(0,C.joinPath)(g,a.main);(0,C.isEqualOrParent)(r,g)||i.push([I.default.Warning,w.localize(10,null,r.path,g.path)])}if(typeof a.activationEvents=="undefined")return i.push([I.default.Error,w.localize(11,null,"activationEvents","main")]),i}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return i.push([I.default.Error,w.localize(12,null,"browser")]),i;{const r=(0,C.joinPath)(g,a.browser);(0,C.isEqualOrParent)(r,g)||i.push([I.default.Warning,w.localize(13,null,r.path,g.path)])}if(typeof a.activationEvents=="undefined")return i.push([I.default.Error,w.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(a.version))return i.push([I.default.Error,w.localize(15,null)]),i;const n=[];if(!S(l,u,a,s,n))for(const r of n)i.push([I.default.Error,r]);return i}t.validateExtensionManifest=h;function S(l,u,g,a,s){return a||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:m(l,u,g.engines.vscode,s)}t.isValidExtensionVersion=S;function f(l,u,g){return l==="*"||m(u,g,l)}t.isEngineValid=f;function m(l,u,g,a=[]){const s=D(d(g));if(!s)return a.push(w.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(w.localize(17,null,g)),!1}else if(!s.majorMustEqual)return a.push(w.localize(18,null,g)),!1;return P(l,u,s)?!0:(a.push(w.localize(19,null,l,g)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let u=0,g=l.length;u<g;u++)if(typeof l[u]!="string")return!1;return!0}}),define(Z[101],ee([0,1,15,30]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(R,A,v){let c=v&&v.get("storage.serviceMachineId",-1)||null;if(c)return c;try{const D=(await A.readFile(R.serviceMachineIdResource)).value.toString();c=(0,I.isUUID)(D)?D:null}catch{c=null}if(!c){c=(0,I.generateUuid)();try{await A.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(c))}catch{}}return v?.store("storage.serviceMachineId",c,-1,1),c}t.getServiceMachineId=w}),define(Z[46],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(w,R=[],A=!1){this.ctor=w,this.staticArguments=R,this.supportsDelayedInstantiation=A}}t.SyncDescriptor=C}),define(Z[102],ee([0,1,46]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const I=[];function w(A,v,c){v instanceof C.SyncDescriptor||(v=new C.SyncDescriptor(v,[],c)),I.push([A,v])}t.registerSingleton=w;function R(){return I}t.getSingletonServiceDescriptors=R}),define(Z[103],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=C;class I{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const A of this._nodes.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const v=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(A);v.outgoing.set(this._hashFn(A),c),c.incoming.set(this._hashFn(R),v)}removeNode(R){const A=this._hashFn(R);this._nodes.delete(A);for(const v of this._nodes.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(R){const A=this._hashFn(R);let v=this._nodes.get(A);return v||(v=new C(R),this._nodes.set(A,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[A,v]of this._nodes)R.push(`${A}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this._nodes){const v=new Set([R]),c=this._findCycle(A,v);if(c)return c}}_findCycle(R,A){for(const[v,c]of R.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const d=this._findCycle(c,A);if(d)return d;A.delete(v)}}}t.Graph=I}),define(Z[21],ee([0,1,5,10,8]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLanguageTagSettingPlainKey=t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,w.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof I.URI)}t.isConfigurationOverrides=R;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof I.URI)}t.isConfigurationUpdateOverrides=A;var v;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(v=t.ConfigurationTarget||(t.ConfigurationTarget={}));function c(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}t.ConfigurationTargetToString=c;function d(l,u){const g=Object.create(null);for(const a in l)D(g,a,l[a],u);return g}t.toValuesTree=d;function D(l,u,g,a){const s=u.split("."),i=s.pop();let n=l;for(let e=0;e<s.length;e++){const r=s[e];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${u} as ${s.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=g}catch{a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=D;function P(l,u){const g=u.split(".");h(l,g)}t.removeFromValueTree=P;function h(l,u){const g=u.shift();if(u.length===0){delete l[g];return}if(Object.keys(l).indexOf(g)!==-1){const a=l[g];typeof a=="object"&&!Array.isArray(a)&&(h(a,u),Object.keys(a).length===0&&delete l[g])}}function S(l,u,g){function a(n,e){let r=n;for(const o of e){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=u.split("."),i=a(l,s);return typeof i=="undefined"?g:i}t.getConfigurationValue=S;function f(l,u,g){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in l?C.isObject(l[a])&&C.isObject(u[a])?f(l[a],u[a],g):g&&(l[a]=u[a]):l[a]=u[a])})}t.merge=f;function m(l,u,g){const a=l.inspect(u),s=l.inspect(g);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:a.defaultValue}t.getMigratedSettingValue=m;function E(l){return l.replace(/[\[\]]/g,"")}t.getLanguageTagSettingPlainKey=E}),define(Z[58],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Z[18],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],ee([0,1,83,8]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IServerExtensionManagementService=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function w(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=w;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=R;function A(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=A;function v(l,u){return u==="web"&&!l.includes("web")}t.isNotWebExtensionInWebTargetPlatform=v;function c(l,u,g){return v(u,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:d(g).includes(l)}t.isTargetPlatformCompatible=c;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=d;function D(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=D;var P;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(P=t.SortBy||(t.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=t.SortOrder||(t.SortOrder={}));var S;(function(l){l.Install="install",l.Uninstall="uninstall"})(S=t.StatisticType||(t.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(u,g){super(u);this.code=g,this.name=g}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),t.IServerExtensionManagementService=(0,I.refineServiceDecorator)(t.IExtensionManagementService),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,C.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,C.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Z[59],ee([0,1,15,12,90,11]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function A(D,P,h,S,f,m){let E;try{await v(D,P,h,S,f,m)}catch(l){E=l}finally{E&&f.errorTransformer&&(E=f.errorTransformer(E)),typeof E!="undefined"&&h.error(E),h.end()}}t.readFileIntoStream=A;async function v(D,P,h,S,f,m){c(m);const E=await D.open(P,{create:!1});try{c(m);let l=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,a=C.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,i=0;do u=await D.read(E,s,a.buffer,i,a.byteLength-i),s+=u,i+=u,l+=u,typeof g=="number"&&(g-=u),i===a.byteLength&&(await h.write(S(a)),a=C.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),i=0);while(u>0&&(typeof g!="number"||g>0)&&c(m)&&d(l,f));if(i>0){let n=i;typeof g=="number"&&(n=Math.min(i,g)),h.write(S(a.slice(0,n)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await D.close(E)}}function c(D){if(D.isCancellationRequested)throw(0,I.canceled)();return!0}function d(D,P){if(P?.limits){if(typeof P.limits.memory=="number"&&D>P.limits.memory)throw(0,R.createFileSystemProviderError)((0,w.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&D>P.limits.size)throw(0,R.createFileSystemProviderError)((0,w.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[104],ee([0,1,4,148,2,13,149]),function($,t,C,I,w,R,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class v extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const D=this.normalizeRequests(d),P=D.filter(S=>{const f=this.watchers.get(S.path);return f?!(0,I.patternsEquals)(f.request.excludes,S.excludes)||!(0,I.patternsEquals)(f.request.includes,S.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:S})=>!D.find(f=>f.path===S.path&&(0,I.patternsEquals)(f.excludes,S.excludes)&&(0,I.patternsEquals)(f.includes,S.includes))).map(({request:S})=>S.path);P.length&&this.trace(`Request to start watching: ${P.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const S of h)this.stopWatching(S);for(const S of P)this.startWatching(S)}startWatching(d){const D=new A.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),P={request:d,instance:D};this.watchers.set(d.path,P)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const D=this.watchers.get(d);D&&(this.watchers.delete(d),D.instance.dispose())}normalizeRequests(d){const D=new Map;for(const P of d){const h=R.isLinux?P.path:P.path.toLowerCase();D.set(h,P)}return Array.from(D.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,D]of this.watchers)D.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,D){return D?`[File Watcher (node.js)] ${d} (path: ${D.request.path})`:`[File Watcher (node.js)] ${d}`}}t.NodeJSWatcher=v}),define(Z[105],ee([0,1,60,104]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class w extends C.AbstractNonRecursiveWatcherClient{constructor(A,v,c){super(A,v,c);this.init()}createWatcher(){return new I.NodeJSWatcher}}t.NodeJSWatcherClient=w}),define(Z[106],ee([0,1,16,56,78,60]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(c,d,D){super(c,d,D);this.init()}createWatcher(c){const d=c.add(new w.Client(C.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:D,signal:P})=>this.onError(`terminated by itself with code ${D}, signal: ${P}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}t.UniversalWatcherClient=A}),define(Z[61],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...w){this._entries=new Map;for(const[R,A]of w)this.set(R,A)}set(w,R){const A=this._entries.get(w);return this._entries.set(w,R),A}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=C}),define(Z[107],ee([0,1,3,12,46,103,8,61]),function($,t,C,I,w,R,A,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class D{constructor(f=new v.ServiceCollection,m=!1,E){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(f){return new D(f,this._strict,this)}invokeFunction(f,...m){const E=h.traceInvocation(f);let l=!1;try{return f({get:g=>{if(l)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,E);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...m)}finally{l=!0,E.stop()}}createInstance(f,...m){let E,l;return f instanceof w.SyncDescriptor?(E=h.traceCreation(f.ctor),l=this._createInstance(f.ctor,f.staticArguments.concat(m),E)):(E=h.traceCreation(f),l=this._createInstance(f,m,E)),E.stop(),l}_createInstance(f,m=[],E){const l=A._util.getServiceDependencies(f).sort((a,s)=>a.index-s.index),u=[];for(const a of l){const s=this._getOrCreateServiceInstance(a.id,E);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),u.push(s)}const g=l.length>0?l[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const a=g-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,g)}return new f(...[...m,...u])}_setServiceInstance(f,m){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){const E=this._getServiceInstanceOrDescriptor(f);return E instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,E,m.branch(f,!0)):(m.branch(f,!1),E)}_safeCreateAndCacheServiceInstance(f,m,E){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,E)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,E){const l=new R.Graph(a=>a.id.toString());let u=0;const g=[{id:f,desc:m,_trace:E}];for(;g.length;){const a=g.pop();if(l.lookupOrInsertNode(a),u++>1e3)throw new d(l);for(const s of A._util.getServiceDependencies(a.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),i instanceof w.SyncDescriptor){const n={id:s.id,desc:i,_trace:a._trace.branch(s.id,!0)};l.insertEdge(a,n),g.push(n)}}}for(;;){const a=l.roots();if(a.length===0){if(!l.isEmpty())throw new d(l);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,E=[],l,u){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(m,E,l,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,E,l,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],E,l){if(E){const u=new C.IdleValue(()=>this._createInstance(f,m,l));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];const s=u.value;let i=s[a];return typeof i!="function"||(i=i.bind(s),g[a]=i),i},set(g,a,s){return u.value[a]=s,!0}})}else return this._createInstance(f,m,l)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}t.InstantiationService=D;var P;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(P||(P={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return c?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return c?new h(0,f.name):h._None}branch(f,m){const E=new h(2,f.toString());return this._dep.push([f,m,E]),E}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function E(u,g){const a=[],s=new Array(u+1).join("	");for(const[i,n,e]of g._dep)if(n&&e){m=!0,a.push(`${s}CREATES -> ${i}`);const r=E(u+1,e);r&&a.push(r)}else a.push(`${s}uses -> ${i}`);return a.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(l.join(`
`))}}t.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var te=this&&this.__param||function($,t){return function(C,I){t(C,I,$)}};define(Z[62],ee([0,1,24,2,13,92,22,8]),function($,t,C,I,w,R,A,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.ILanguagePackService=(0,v.createDecorator)("languagePackService");let c=class extends I.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new C.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let P;try{P=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const S=P.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],E=this.getLocale(f);return{...this.createQuickPickItem(E,m,f),extensionId:f.identifier.id,galleryExtension:f}});return S.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),S}getLocale(D){return D.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(D,P,h){const S=P??D;let f;if(S!==D&&(f=`(${D})`),D.toLowerCase()===w.language.toLowerCase()&&(f??(f=""),f+=(0,R.localize)(0,null)),h?.installCount){f??(f="");const m=h.installCount;let E;m>1e6?E=`${Math.floor(m/1e5)/10}M`:m>1e3?E=`${Math.floor(m/1e3)}K`:E=String(m),f+=` $(cloud-download) ${E}`}return{id:D,label:S,description:f}}};c=fe([te(0,A.IExtensionGalleryService)],c),t.LanguagePackBaseService=c}),define(Z[9],ee([0,1,31,4,2,13,8]),function($,t,C,I,w,R,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,A.createDecorator)("logService"),t.ILoggerService=(0,A.createDecorator)("loggerService");function v(){return new Date().toISOString()}var c;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function d(n,e,r){switch(e){case c.Trace:n.trace(r);break;case c.Debug:n.debug(r);break;case c.Info:n.info(r);break;case c.Warning:n.warn(r);break;case c.Error:n.error(r);break;case c.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}t.log=d;function D(n){let e="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(r>0?" ":"")+o}return e}t.format=D;class P extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=P;class h extends P{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...r){this.checkLogLevel(c.Trace)&&this.log(c.Trace,D([e,...r]))}debug(e,...r){this.checkLogLevel(c.Debug)&&this.log(c.Debug,D([e,...r]))}info(e,...r){this.checkLogLevel(c.Info)&&this.log(c.Info,D([e,...r]))}warn(e,...r){this.checkLogLevel(c.Warning)&&this.log(c.Warning,D([e,...r]))}error(e,...r){if(this.checkLogLevel(c.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(c.Error,D(o))}else this.log(c.Error,D([e,...r]))}critical(e,...r){this.checkLogLevel(c.Critical)&&this.log(c.Critical,D([e,...r]))}flush(){}}t.AbstractMessageLogger=h;class S extends P{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...r){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...r):console.log(`[main ${v()}]`,e,...r))}debug(e,...r){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...r):console.log(`[main ${v()}]`,e,...r))}info(e,...r){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,e,...r):console.log(`[main ${v()}]`,e,...r))}warn(e,...r){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,e,...r):console.warn(`[main ${v()}]`,e,...r))}error(e,...r){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,e,...r):console.error(`[main ${v()}]`,e,...r))}critical(e,...r){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,e,...r):console.error(`[main ${v()}]`,e,...r))}dispose(){}flush(){}}t.ConsoleMainLogger=S;class f extends P{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...r){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...r)}debug(e,...r){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...r)}info(e,...r){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...r)}warn(e,...r){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...r)}error(e,...r){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...r)}critical(e,...r){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...r)}dispose(){}flush(){}}t.ConsoleLogger=f;class m extends P{constructor(e,r=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(r)}trace(e,...r){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...r])}debug(e,...r){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...r])}info(e,...r){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...r])}warn(e,...r){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...r])}error(e,...r){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...r])}critical(e,...r){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...r])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=m;class E extends P{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const r of this.logServices)r.setLevel(e);super.setLevel(e)}trace(e,...r){for(const o of this.logServices)o.trace(e,...r)}debug(e,...r){for(const o of this.logServices)o.debug(e,...r)}info(e,...r){for(const o of this.logServices)o.info(e,...r)}warn(e,...r){for(const o of this.logServices)o.warn(e,...r)}error(e,...r){for(const o of this.logServices)o.error(e,...r)}critical(e,...r){for(const o of this.logServices)o.critical(e,...r)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=E;class l extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...r){this.logger.trace(e,...r)}debug(e,...r){this.logger.debug(e,...r)}info(e,...r){this.logger.info(e,...r)}warn(e,...r){this.logger.warn(e,...r)}error(e,...r){this.logger.error(e,...r)}critical(e,...r){this.logger.critical(e,...r)}flush(){this.logger.flush()}}t.LogService=l;class u extends w.Disposable{constructor(e,r){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(p=>p.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,r){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,r?.always?c.Trace:this.logLevel,r),this.loggers.set(e.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...r){}debug(e,...r){}info(e,...r){}warn(e,...r){}error(e,...r){}critical(e,...r){}dispose(){}flush(){}}t.NullLogService=g;function a(n){if(n.verbose)return c.Trace;if(typeof n.logLevel=="string"){const e=s(n.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=a;function s(n){switch(n){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=s;function i(n){switch(n){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=i}),define(Z[108],ee([0,1,19,3,12,4,2,14,60,9]),function($,t,C,I,w,R,A,v,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(h,S){super();this.logService=h,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(h,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,S):this.watchNonRecursive(h,S)}watchUniversal(h,S){const f={path:this.toFilePath(h),excludes:S.excludes,includes:S.includes,recursive:S.recursive},m=(0,C.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,c.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&h.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,S){const f={path:this.toFilePath(h),excludes:S.excludes,includes:S.includes,recursive:!1},m=(0,C.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,v.normalize)(h.fsPath)}}t.AbstractDiskFileSystemProvider=D}),define(Z[109],ee([0,1,19,3,15,24,4,53,63,2,36,16,110,17,43,89,11,59,9]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let g=class extends d.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(e=>this._onDidFilesChange.fire(new E.FileChangesEvent(e,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),n.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){i.push(n)}}),!this.provider.has(s)&&await I.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return c.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,S.isAbsolutePath)(s))throw new E.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,m.localize)(1,null,s.toString()),n}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i)||(0,E.hasFileReadCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(s,i){const n=await this.withProvider(s),e=this.isPathCaseSensitive(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,p=i?.resolveMetadata,y=await n.stat(s);let b;return this.toFileStat(n,s,y,void 0,!!p,(k,x)=>(b||(b=D.TernarySearchTree.forUris(()=>!e),b.set(s,!0),r&&b.fill(!0,r)),b.get(k.resource)||b.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?x===1:!1))}async toFileStat(s,i,n,e,r,o){const{providerExtUri:p}=this.getExtUri(s),y={resource:i,name:p.basename(i),isFile:(n.type&E.FileType.File)!=0,isDirectory:(n.type&E.FileType.Directory)!=0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(y.isDirectory&&o(y,e)){try{const b=await s.readdir(i),k=await I.Promises.settled(b.map(async([x,_])=>{try{const G=p.joinPath(i,x),Q=r?await s.stat(G):{type:_};return await this.toFileStat(s,G,Q,b.length,r,o)}catch(G){return this.logService.trace(G),null}}));y.children=(0,C.coalesce)(k)}catch(b){this.logService.trace(b),y.children=[]}return y}return y}async resolveAll(s){return I.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),n=await i.stat(s);return this.toFileStat(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(n){return n}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=w.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const e=await this.writeFile(s,i);return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,e)),e}async writeFile(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(e);try{await this.validateWriteFile(e,s,n)||await this.mkdirp(e,r.dirname(s));let p;if((0,E.hasReadWriteCapability)(e)&&!(i instanceof w.VSBuffer))if((0,f.isReadableStream)(i)){const y=await(0,f.peekStream)(i,3);y.ended?p=w.VSBuffer.concat(y.buffer):p=y}else p=(0,f.peekReadable)(i,y=>w.VSBuffer.concat(y),3);else p=i;!(0,E.hasOpenReadWriteCloseCapability)(e)||(0,E.hasReadWriteCapability)(e)&&p instanceof w.VSBuffer?await this.doWriteUnbuffered(e,s,n,p):await this.doWriteBuffered(e,s,n,p instanceof w.VSBuffer?(0,w.bufferToReadable)(p):p),this._onDidRunOperation.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,n);if(this.throwIfFileIsReadonly(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,m.localize)(7,null),3,n);return r}async readFile(s,i,n){const e=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(e,s,i,n):this.doReadFile(e,s,i,n)}async doReadFileAtomic(s,i,n,e){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const p=await this.doReadFile(s,i,n,e);r(p)}catch(p){o(p)}})})}async doReadFile(s,i,n,e){const r=await this.doReadFileStream(s,i,{...n,preferUnbuffered:!0},e);return{...r,value:await(0,w.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,i,n)}async doReadFileStream(s,i,n,e){const r=new R.CancellationTokenSource(e),o=this.validateReadFile(i,n).then(y=>y,y=>{throw r.cancel(),y});let p;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?p=this.readFileUnbuffered(s,i,n):(0,E.hasFileReadStreamCapability)(s)?p=this.readFileStreamed(s,i,r.token,n):p=this.readFileBuffered(s,i,r.token,n),{...await o,value:p}}catch(y){p&&await(0,f.consumeStream)(p);const b=(0,m.localize)(8,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(y).toString());throw y instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(b,y.stat,n):new E.FileOperationError(b,(0,E.toFileOperationResult)(y),n)}}readFileStreamed(s,i,n,e=Object.create(null)){const r=s.readFileStream(i,e,n);return(0,f.transform)(r,{data:o=>o instanceof w.VSBuffer?o:w.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),e)},o=>w.VSBuffer.concat(o))}readFileBuffered(s,i,n,e=Object.create(null)){const r=(0,w.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,i,r,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new E.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),e)},n),r}readFileUnbuffered(s,i,n){const e=(0,f.newWriteableStream)(r=>w.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(i,r.byteLength,n),e.end(w.VSBuffer.wrap(r))}catch(r){e.error(r),e.end()}})(),e}async validateReadFile(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,m.localize)(12,null),n,i);return this.validateReadFileLimits(s,n.size,i),n}validateReadFileLimits(s,i,n){if(n?.limits){let e;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(e=9),typeof n.limits.size=="number"&&i>n.limits.size&&(e=7),typeof e=="number")throw new E.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,i,n){return this.doCanMoveCopy(s,i,"move",n)}async canCopy(s,i,n){return this.doCanMoveCopy(s,i,"copy",n)}async doCanMoveCopy(s,i,n,e){if(s.toString()!==i.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,o,i,n,e)}catch(r){return r}return!0}async move(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"move",!!n),p=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="move"?2:3,p)),p}async copy(s,i,n){const e=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"copy",!!n),p=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="copy"?3:2,p)),p}async doMoveCopy(s,i,n,e,r,o){if(i.toString()===e.toString())return r;const{exists:p,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(s,i,n,e,r,o);if(p&&!y&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(e)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(i,e,{overwrite:o});else{const b=await this.resolve(i);b.isDirectory?await this.doCopyFolder(s,b,n,e):await this.doCopyFile(s,i,n,e)}return r}else return s===n?(await s.rename(i,e,{overwrite:o}),r):(await this.doMoveCopy(s,i,n,e,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,n,e){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,i,n,e);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,i,n,e);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,i,n,e);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,i,n,e)}async doCopyFolder(s,i,n,e){await n.mkdir(e),Array.isArray(i.children)&&await I.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(e,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,i,n,e,r,o){let p=!1;if(s===n){const{providerExtUri:b,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(p=b.isEqual(i,e)),p&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(e)));if(!p&&b.isEqualOrParent(e,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(e)))}const y=await this.exists(e);if(y&&!p){if(!o)throw new E.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(e)),4);if(s===n){const{providerExtUri:b}=this.getExtUri(s);if(b.isEqualOrParent(i,e))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(e)))}}return{exists:y,isSameResourceWithDifferentPathCase:p}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,n)),n}async mkdirp(s,i){const n=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(i,e.dirname(i));)try{if(((await s.stat(i)).type&E.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(e.basename(i)),i=e.dirname(i)}for(let r=n.length-1;r>=0;r--){i=e.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(n){return n}return!0}async doValidateDelete(s,i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new E.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const p=await this.resolve(s);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return n}async del(s,i){const n=await this.doValidateDelete(s,i),e=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:e}),this._onDidRunOperation.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.withProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(n===e&&this.getExtUri(n).providerExtUri.isEqual(s,i))return;if(n===e&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===e&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,e,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let e=!1,r=()=>{e=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,i);e?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,i){const n=await this.withProvider(s),e=(0,v.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),i]);let r=this.activeWatchers.get(e);return r||(r={count:0,disposable:n.watch(s,i)},this.activeWatchers.set(e,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(e)||(0,f.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,r,e):await this.doWriteReadableBufferedQueued(s,r,e)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,i,n){let e=0,r;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=w.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,e,0),e+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,p)=>{(0,f.listenStream)(r,{onData:async y=>{r.pause();try{await this.doWriteBuffer(s,i,y,y.byteLength,e,0)}catch(b){return p(b)}e+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>p(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,n){let e=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,e,0),e+=r.byteLength}async doWriteBuffer(s,i,n,e,r,o){let p=0;for(;p<e;)p+=await s.write(i,r+p,n.buffer,o+p,e-p)}async doWriteUnbuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,n,e))}async doWriteUnbufferedQueued(s,i,n,e){let r;e instanceof w.VSBuffer?r=e:(0,f.isReadableStream)(e)?r=await(0,w.streamToBuffer)(e):(0,f.isReadableBufferedStream)(e)?r=await(0,w.bufferedStreamToBuffer)(e):r=(0,w.readableToBuffer)(e),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,n,e))}async doPipeBufferedQueued(s,i,n,e){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(e,{create:!0,unlock:!1});const p=w.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,b=0,k=0;do k=await s.read(r,y,p.buffer,b,p.byteLength-b),await this.doWriteBuffer(n,o,p,k,y,b),y+=k,b+=k,b===p.byteLength&&(b=0);while(k>0)}catch(p){throw(0,E.ensureFileSystemProviderError)(p)}finally{await I.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,n,e))}async doPipeUnbufferedQueued(s,i,n,e){return n.writeFile(e,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,n,e))}async doPipeUnbufferedToBufferedQueued(s,i,n,e){const r=await n.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(n,r,w.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,i,n,e){const r=await(0,w.streamToBuffer)(this.readFileBuffered(s,i,R.CancellationToken.None));await this.doWriteUnbuffered(n,e,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new E.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===P.Schemas.file?s.fsPath:s.toString(!0)}};g=fe([te(0,u.ILogService)],g),t.FileService=g}),define(Z[111],ee([0,1,112,150,3,36,15,4,151,2,14,13,17,43,20,91,11,59,108,31,106,105]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u,g,a,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(n)}`)}})();class i extends u.AbstractDiskFileSystemProvider{constructor(e,r){super(e,r);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await f.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async p=>{try{let y;p.isSymbolicLink()?y=(await this.stat((0,h.joinPath)(e,p.name))).type:y=this.toType(p),o.push([p.name,y])}catch(y){this.logService.trace(y)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(e,r){let o;return r?.dangling?o=E.FileType.Unknown:e.isFile()?o=E.FileType.File:e.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async createResourceLock(e){const r=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const p=new w.Barrier;return this.resourceLocks.set(e,p),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(e)===p&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),p.open()})}async readFile(e,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const p=this.toFilePath(e);return await f.Promises.readFile(p)}catch(p){throw this.toFileSystemProviderError(p)}finally{o?.dispose()}}readFileStream(e,r,o){const p=(0,S.newWriteableStream)(y=>A.VSBuffer.concat(y.map(b=>A.VSBuffer.wrap(b))).buffer);return(0,l.readFileIntoStream)(this,e,p,y=>y.buffer,{...r,bufferSize:256*1024},o),p}async writeFile(e,r,o){let p;try{const y=this.toFilePath(e);if(!o.create||!o.overwrite){if(await f.Promises.exists(y)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,m.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,m.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(p,0,r,0,r.byteLength)}catch(y){throw await this.toFileSystemProviderWriteError(e,y)}finally{typeof p=="number"&&await this.close(p)}}static configureFlushOnWrite(e){i.canFlush=e}async open(e,r){const o=this.toFilePath(e);let p;(0,E.isFileOpenForWriteOptions)(r)&&(p=await this.createResourceLock(e));let y;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(o);k.mode&128||await f.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let b;if((0,E.isFileOpenForWriteOptions)(r)){if(P.isWindows)try{await f.Promises.truncate(o,0),b="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}b||(b="w")}else b="r";y=await f.Promises.open(o,b)}catch(b){throw p?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(e,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(y,0),(0,E.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(y,e),p){const b=this.mapHandleToLock.get(y);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${o})`),this.mapHandleToLock.set(y,p),b&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${o})`),b.dispose())}return y}async close(e){const r=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&i.canFlush)try{await f.Promises.fdatasync(e)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(e)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),r.dispose())}}async read(e,r,o,p,y){const b=this.normalizePos(e,r);let k=null;try{k=(await f.Promises.read(e,o,p,y,b)).bytesRead}catch(x){throw this.toFileSystemProviderError(x)}finally{this.updatePos(e,b,k)}return k}normalizePos(e,r){return r===this.mapHandleToPos.get(e)?null:r}updatePos(e,r,o){const p=this.mapHandleToPos.get(e);typeof p=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,p+o):this.mapHandleToPos.delete(e)))}async write(e,r,o,p,y){return(0,w.retry)(()=>this.doWrite(e,r,o,p,y),100,3)}async doWrite(e,r,o,p,y){const b=this.normalizePos(e,r);let k=null;try{k=(await f.Promises.write(e,o,p,y,b)).bytesWritten}catch(x){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),x)}finally{this.updatePos(e,b,k)}return k}async mkdir(e){try{await f.Promises.mkdir(this.toFilePath(e))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const o=this.toFilePath(e);r.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,r,o){const p=this.toFilePath(e),y=this.toFilePath(r);if(p!==y)try{await this.validateTargetDeleted(e,r,"move",o.overwrite),await f.Promises.move(p,y)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(2,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(y)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(e,r,o){const p=this.toFilePath(e),y=this.toFilePath(r);if(p!==y)try{await this.validateTargetDeleted(e,r,"copy",o.overwrite),await f.Promises.copy(p,y,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(3,null,(0,D.basename)(p),(0,D.basename)((0,D.dirname)(y)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(e,r,o,p){const y=this.toFilePath(e),b=this.toFilePath(r);let k=!1;if(!!(this.capabilities&1024)||(k=(0,c.isEqual)(y,b,!0)),k&&o==="copy")throw(0,E.createFileSystemProviderError)((0,m.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!k&&await f.Promises.exists(b)){if(!p)throw(0,E.createFileSystemProviderError)((0,m.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(e,r){return this.doCloneFile(e,r,!1)}async doCloneFile(e,r,o){const p=this.toFilePath(e),y=this.toFilePath(r),b=!!(this.capabilities&1024);if((0,c.isEqual)(p,y,!b))return;const k=new d.DisposableStore;try{const[x,_]=await Promise.all([this.createResourceLock(e),this.createResourceLock(r)]);k.add(x),k.add(_),o&&await f.Promises.mkdir((0,D.dirname)(y),{recursive:!0}),await f.Promises.copyFile(p,y)}catch(x){if(x.code==="ENOENT"&&!o)return this.doCloneFile(e,r,!0);throw this.toFileSystemProviderError(x)}finally{k.dispose()}}createUniversalWatcher(e,r,o){return new a.UniversalWatcherClient(p=>e(p),p=>r(p),o)}createNonRecursiveWatcher(e,r,o){return new s.NodeJSWatcherClient(p=>e(p),p=>r(p),o)}toFileSystemProviderError(e){if(e instanceof E.FileSystemProviderError)return e;let r;switch(e.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(e,r)}async toFileSystemProviderWriteError(e,r){let o=this.toFileSystemProviderError(r);if(e&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await f.SymlinkSupport.stat(this.toFilePath(e));p.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return o}}t.DiskFileSystemProvider=i,i.canFlush=!0}),define(Z[113],ee([0,1,11,9]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function w(v,c,d,D,P){try{const h=await new Promise((f,m)=>{$(["spdlog"],f,m)});h.setFlushOn(I.LogLevel.Trace);const S=await h.createAsyncRotatingLogger(v,c,d,D);return P&&S.clearFormatters(),S}catch(h){console.error(h)}return null}function R(v,c,d){switch(c){case I.LogLevel.Trace:v.trace(d);break;case I.LogLevel.Debug:v.debug(d);break;case I.LogLevel.Info:v.info(d);break;case I.LogLevel.Warning:v.warn(d);break;case I.LogLevel.Error:v.error(d);break;case I.LogLevel.Critical:v.critical(d);break;default:throw new Error("Invalid log level")}}class A extends I.AbstractMessageLogger{constructor(c,d,D,P,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,d,D,P),this._register(this.onDidChangeLogLevel(S=>{this._logger?.setLevel(S)}))}async _createSpdLogLogger(c,d,D,P){const h=D?6:1,S=30/h*C.ByteSize.MB,f=await w(c,d,S,h,P);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:E}of this.buffer)R(this._logger,m,E);this.buffer=[]}}log(c,d){this._logger?R(this._logger,c,d):this.getLevel()<=c&&this.buffer.push({level:c,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=A}),define(Z[37],ee([0,1,4,63,2,8]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,R.createDecorator)("policy");class A extends w.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),I.Iterable.reduce(this.policies.entries(),(P,[h,S])=>({...P,[h]:S}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[D,P])=>({...d,[D]:{definition:P,value:this.policies.get(D)}}),{})}}t.AbstractPolicyService=A;class v{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=v}),define(Z[114],ee([0,1,3,4,63,5,11,9,37]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function d(P,h){const S=[];for(const f of w.Iterable.concat(P.keys(),h.keys()))P.get(f)!==h.get(f)&&S.push(f);return S}let D=class extends c.AbstractPolicyService{constructor(h,S,f){super();this.file=h,this.fileService=S,this.logService=f,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const m=I.Event.filter(S.onDidFilesChange,E=>E.affects(h));this._register(S.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const S=await this.fileService.readFile(this.file),f=JSON.parse(S.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(S){S.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",S)}return h}async refresh(){const h=await this.read(),S=d(this.policies,h);this.policies=h,S.length>0&&this._onDidChange.fire(S)}};D=fe([te(1,A.IFileService),te(2,v.ILogService)],D),t.FilePolicyService=D}),define(Z[28],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Z[33],ee([0,1,68,5]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(A,v){C.ok(I.isString(A)),C.ok(I.isObject(v)),C.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,v)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}t.Registry=new w}),define(Z[115],ee([0,1,4,33]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[w(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new R;I.Registry.add(t.Extensions.JSONContribution,A)}),define(Z[40],ee([0,1,19,4,5,81,21,115,33]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var D;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=c.Registry.as(v.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const e=this.doRegisterConfigurations(i,n);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(i){const n=this.doDeregisterConfigurations(i);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:i,remove:n}){const e=[];e.push(...this.doDeregisterConfigurations(n)),e.push(...this.doRegisterConfigurations(i,!1)),P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(e)})}registerDefaultConfigurations(i){const n=[],e=[];for(const{overrides:r,source:o}of i)for(const p in r)if(n.push(p),t.OVERRIDE_PROPERTY_REGEX.test(p)){const y=this.configurationDefaultsOverrides.get(p),b=y?.valuesSources??new Map;if(o)for(const G of Object.keys(r[p]))b.set(G,o);const k={...y?.value||{},...r[p]};this.configurationDefaultsOverrides.set(p,{source:o,value:k,valuesSources:b});const x=(0,A.getLanguageTagSettingPlainKey)(p),_={type:"object",default:k,description:R.localize(1,null,x),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:w.isString(o)?void 0:o,defaultValueSource:o};e.push(...m(p)),this.configurationProperties[p]=_,this.defaultLanguageConfigurationOverridesNode.properties[p]=_}else{this.configurationDefaultsOverrides.set(p,{value:r[p],source:o});const y=this.configurationProperties[p];y&&(this.updatePropertyDefaultValue(p,y),this.updateSchema(p,y))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:e,source:r}of i)for(const o in e){const p=this.configurationDefaultsOverrides.get(o),y=w.isString(r)?r:r?.id,b=w.isString(p?.source)?p?.source:p?.source?.id;if(y===b)if(n.push(o),this.configurationDefaultsOverrides.delete(o),t.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const n of i)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,n){const e=[];return i.forEach(r=>{e.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),e}doDeregisterConfigurations(i){const n=[],e=r=>{if(r.properties)for(const o in r.properties){n.push(o);const p=this.configurationProperties[o];p?.policy?.name&&this.policyConfigurations.delete(p.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>e(o))};for(const r of i){e(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(i,n=!0,e,r,o=3){o=w.isUndefinedOrNull(i.scope)?o:i.scope;const p=[],y=i.properties;if(y)for(const k in y){const x=y[k];if(n&&g(k,x)){delete y[k];continue}if(x.source=e,x.defaultDefaultValue=y[k].default,this.updatePropertyDefaultValue(k,x),t.OVERRIDE_PROPERTY_REGEX.test(k)?x.scope=void 0:(x.scope=w.isUndefinedOrNull(x.scope)?o:x.scope,x.restricted=w.isUndefinedOrNull(x.restricted)?!!r?.includes(k):x.restricted),y[k].hasOwnProperty("included")&&!y[k].included){this.excludedConfigurationProperties[k]=y[k],delete y[k];continue}else this.configurationProperties[k]=y[k],y[k].policy?.name&&this.policyConfigurations.set(y[k].policy.name,k);!y[k].deprecationMessage&&y[k].markdownDeprecationMessage&&(y[k].deprecationMessage=y[k].markdownDeprecationMessage),p.push(k)}const b=i.allOf;if(b)for(const k of b)p.push(...this.validateAndRegisterProperties(k,n,e,r,o));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const n=e=>{const r=e.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);e.allOf?.forEach(n)};n(i)}updateSchema(i,n){switch(t.allSettings.properties[i]=n,n.scope){case 1:t.applicationSettings.properties[i]=n;break;case 2:t.machineSettings.properties[i]=n;break;case 6:t.machineOverridableSettings.properties[i]=n;break;case 3:t.windowSettings.properties[i]=n;break;case 4:t.resourceSettings.properties[i]=n;break;case 5:t.resourceSettings.properties[i]=n,this.resourceLanguageSettingsSchema.properties[i]=n;break}}removeFromSchema(i,n){switch(delete t.allSettings.properties[i],n.scope){case 1:delete t.applicationSettings.properties[i];break;case 2:delete t.machineSettings.properties[i];break;case 6:delete t.machineOverridableSettings.properties[i];break;case 3:delete t.windowSettings.properties[i];break;case 4:case 5:delete t.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const n=`[${i}]`,e={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,e),t.allSettings.properties[n]=e,t.applicationSettings.properties[n]=e,t.machineSettings.properties[n]=e,t.machineOverridableSettings.properties[n]=e,t.windowSettings.properties[n]=e,t.resourceSettings.properties[n]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,n){const e=this.configurationDefaultsOverrides.get(i);let r=e?.value,o=e?.source;w.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),w.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",f=new RegExp(S,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function m(s){const i=[];if(t.OVERRIDE_PROPERTY_REGEX.test(s)){let n=f.exec(s);for(;n?.length;){const e=n[1].trim();e&&i.push(e),n=f.exec(s)}}return(0,C.distinct)(i)}t.overrideIdentifiersFromKey=m;function E(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}t.keyFromOverrideIdentifiers=E;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const u=new h;c.Registry.add(t.Extensions.Configuration,u);function g(s,i){return s.trim()?t.OVERRIDE_PROPERTY_REGEX.test(s)?R.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,s,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}t.validateProperty=g;function a(){const s=[],i=u.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}t.getScopes=a}),define(Z[64],ee([0,1,19,4,50,2,36,26,5,10,21,40,33]),function($,t,C,I,w,R,A,v,c,d,D,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0;class S{constructor(n={},e=[],r=[]){this._contents=n,this._keys=e,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,e){const r=this.getContentsForOverrideIdentifer(e);return r?n?(0,D.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const e=[];for(const r of this.overrides)r.identifiers.includes(n)&&e.push(...r.keys);return C.distinct(e)}getAllOverrideIdentifiers(){const n=[];for(const e of this.overrides)n.push(...e.identifiers);return C.distinct(n)}override(n){let e=this.overrideConfigurations.get(n);return e||(e=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,e)),e}merge(...n){const e=v.deepClone(this.contents),r=v.deepClone(this.overrides),o=[...this.keys];for(const p of n)if(!p.isEmpty()){this.mergeContents(e,p.contents);for(const y of p.overrides){const[b]=r.filter(k=>C.equals(k.identifiers,y.identifiers));b?(this.mergeContents(b.contents,y.contents),b.keys.push(...y.keys),b.keys=C.distinct(b.keys)):r.push(v.deepClone(y))}for(const y of p.keys)o.indexOf(y)===-1&&o.push(y)}return new S(e,o,r)}freeze(){return this.frozen=!0,this}clone(){return new S(v.deepClone(this.contents),[...this.keys],v.deepClone(this.overrides))}createOverrideConfigurationModel(n){const e=this.getContentsForOverrideIdentifer(n);if(!e||typeof e!="object"||!Object.keys(e).length)return this;const r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(e)])){let p=this.contents[o];const y=e[o];y&&(typeof p=="object"&&typeof y=="object"?(p=v.deepClone(p),this.mergeContents(p,y)):p=y),r[o]=p}return new S(r,this.keys,this.overrides)}mergeContents(n,e){for(const r of Object.keys(e)){if(r in n&&c.isObject(n[r])&&c.isObject(e[r])){this.mergeContents(n[r],e[r]);continue}n[r]=v.deepClone(e[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?v.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let e=null,r=null;const o=p=>{p&&(r?this.mergeContents(r,p):r=v.deepClone(p))};for(const p of this.overrides)C.equals(p.identifiers,[n])?e=p.contents:p.identifiers.includes(n)&&o(p.contents);return o(e),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,e){this.addKey(n),(0,D.addToValueTree)(this.contents,n,e,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let e=this.keys.length;for(let r=0;r<e;r++)n.indexOf(this.keys[r])===0&&(e=r);this.keys.splice(e,1,n)}removeKey(n){const e=this.keys.indexOf(n);return e!==-1?(this.keys.splice(e,1),!0):!1}}t.ConfigurationModel=S;class f{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,e){if(!c.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,e)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,e){this._raw=n;const{contents:r,keys:o,overrides:p,restricted:y}=this.doParseRaw(n,e);this._configurationModel=new S(r,o,p),this._restrictedConfigurations=y||[]}doParseContent(n){let e={},r=null,o=[];const p=[],y=[];function b(x){Array.isArray(o)?o.push(x):r!==null&&(o[r]=x)}const k={onObjectBegin:()=>{const x={};b(x),p.push(o),o=x,r=null},onObjectProperty:x=>{r=x},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const x=[];b(x),p.push(o),o=x,r=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:b,onError:(x,_,G)=>{y.push({error:x,offset:_,length:G})}};if(n)try{w.visit(n,k),e=o[0]||{}}catch(x){console.error(`Error while parsing settings file ${this._name}: ${x}`),this._parseErrors=[x]}return e}doParseRaw(n,e){const r=h.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,e);n=o.raw;const p=(0,D.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),y=Object.keys(n),b=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:p,keys:y,overrides:b,restricted:o.restricted}}filter(n,e,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const p={},y=[];for(const b in n)if(P.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const k=this.filter(n[b],e,!1,o);p[b]=k.raw,y.push(...k.restricted)}else{const k=e[b],x=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&y.push(b),(x===void 0||o.scopes===void 0||o.scopes.includes(x))&&(o.skipRestricted&&k?.restricted||(p[b]=n[b]))}return{raw:p,restricted:y}}toOverrides(n,e){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const p={};for(const y in n[o])p[y]=n[o][y];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(p),contents:(0,D.toValuesTree)(p,e)})}return r}}t.ConfigurationModelParser=f;class m extends R.Disposable{constructor(n,e,r,o){super();this.userSettingsResource=n,this.scopes=e,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&r.isEqual(p.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=m;class E{constructor(n,e,r,o,p=new S,y=new S,b=new A.ResourceMap,k=new S,x=new A.ResourceMap,_=!0){this._defaultConfiguration=n,this._policyConfiguration=e,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=p,this._workspaceConfiguration=y,this._folderConfigurations=b,this._memoryConfiguration=k,this._memoryConfigurationByResource=x,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,e,r){return this.getConsolidatedConfigurationModel(n,e,r).getValue(n)}updateValue(n,e,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new S,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,e===void 0?o.removeValue(n):o.setValue(n,e),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,e,r){const o=this.getConsolidatedConfigurationModel(n,e,r),p=this.getFolderConfigurationModelForResource(e.resource,r),y=e.resource?this._memoryConfigurationByResource.get(e.resource)||this._memoryConfiguration:this._memoryConfiguration,b=e.overrideIdentifier?this._defaultConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),x=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),_=e.overrideIdentifier?this.userConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),G=e.overrideIdentifier?this.localUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),Q=e.overrideIdentifier?this.remoteUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),ne=r?e.overrideIdentifier?this._workspaceConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ce=p?e.overrideIdentifier?p.freeze().override(e.overrideIdentifier).getValue(n):p.freeze().getValue(n):void 0,re=e.overrideIdentifier?y.override(e.overrideIdentifier).getValue(n):y.getValue(n),ge=o.getValue(n),ae=C.distinct(o.overrides.map(N=>N.identifiers).flat()).filter(N=>o.getOverrideValue(n,N)!==void 0);return{defaultValue:b,policyValue:k,applicationValue:x,userValue:_,userLocalValue:G,userRemoteValue:Q,workspaceValue:ne,workspaceFolderValue:ce,memoryValue:re,value:ge,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:x!==void 0?{value:x,override:e.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userLocal:G!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspace:ne!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspaceFolder:ce!==void 0?{value:p?.freeze().getValue(n),override:e.overrideIdentifier?p?.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:y.getValue(n),override:e.overrideIdentifier?y.getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(n){const e=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:e?e.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,e){this._folderConfigurations.set(n,e),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,e){const r=[];if(!e){const{added:o,updated:p,removed:y}=a(this._defaultConfiguration,n);e=[...o,...p,...y]}for(const o of e)for(const p of(0,P.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(p),b=n.getKeysForOverrideIdentifier(p),k=[...b.filter(x=>y.indexOf(x)===-1),...y.filter(x=>b.indexOf(x)===-1),...y.filter(x=>!v.equals(this._defaultConfiguration.override(p).getValue(x),n.override(p).getValue(x)))];r.push([p,k])}return this.updateDefaultConfiguration(n),{keys:e,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:e,updated:r,removed:o}=a(this._policyConfiguration,n),p=[...e,...r,...o];return p.length&&this.updatePolicyConfiguration(n),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:e,updated:r,removed:o,overrides:p}=a(this.applicationConfiguration,n),y=[...e,...r,...o];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:p}}compareAndUpdateLocalUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:p}=a(this.localUserConfiguration,n),y=[...e,...r,...o];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:p}}compareAndUpdateRemoteUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:p}=a(this.remoteUserConfiguration,n),y=[...e,...r,...o];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:p}}compareAndUpdateWorkspaceConfiguration(n){const{added:e,updated:r,removed:o,overrides:p}=a(this.workspaceConfiguration,n),y=[...e,...r,...o];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:p}}compareAndUpdateFolderConfiguration(n,e){const r=this.folderConfigurations.get(n),{added:o,updated:p,removed:y,overrides:b}=a(r,e),k=[...o,...p,...y];return(k.length||!r)&&this.updateFolderConfiguration(n,e),{keys:k,overrides:b}}compareAndDeleteFolderConfiguration(n){const e=this.folderConfigurations.get(n);if(!e)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:p,overrides:y}=a(e,void 0);return{keys:[...r,...o,...p],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,e,r){let o=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier&&(o=o.override(e.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},e){let r=this.getWorkspaceConsolidatedConfiguration();if(e&&n){const o=e.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const p=this._memoryConfigurationByResource.get(n);p&&(r=r.merge(p))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let e=this._foldersConsolidatedConfigurations.get(n);if(!e){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(e=r.merge(o),this._freeze&&(e=e.freeze()),this._foldersConsolidatedConfigurations.set(n,e)):e=r}return e}getFolderConfigurationModelForResource(n,e){if(e&&n){const r=e.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,e)=>{const{contents:r,overrides:o,keys:p}=this._folderConfigurations.get(e);return n.push([e,{contents:r,overrides:o,keys:p}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(e=>n.add(e)),this.userConfiguration.freeze().keys.forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().keys.forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const e=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>e.add(o))),[...e.values()]}static parse(n){const e=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),p=this.parseConfigurationModel(n.user),y=this.parseConfigurationModel(n.workspace),b=n.folders.reduce((k,x)=>(k.set(d.URI.revive(x[0]),this.parseConfigurationModel(x[1])),k),new A.ResourceMap);return new E(e,r,o,p,new S,y,b,new S,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new S(n.contents,n.keys,n.overrides).freeze()}}t.Configuration=E;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,e=new Map;for(const o of i)o.keys.forEach(p=>n.add(p)),o.overrides.forEach(([p,y])=>{const b=(0,A.getOrSet)(e,p,new Set);y.forEach(k=>b.add(k))});const r=[];return e.forEach((o,p)=>r.push([p,[...o.values()]])),{keys:[...n.values()],overrides:r}}t.mergeChanges=l;class u{constructor(n,e,r,o){this.change=n,this.previous=e,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const p=new Set;n.keys.forEach(b=>p.add(b)),n.overrides.forEach(([,b])=>b.forEach(k=>p.add(k))),this.affectedKeys=[...p.values()];const y=new S;this.affectedKeys.forEach(b=>y.setValue(b,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,e){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(e){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,e,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,e,this.currentWorkspace);return!v.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,e){let r=(0,D.toValuesTree)({[e]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}t.ConfigurationChangeEvent=u;class g extends u{constructor(n,e,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,e);this.source=r,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=g;function a(i,n){const{added:e,removed:r,updated:o}=s(n,i),p=[],y=i?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const k=b.filter(x=>!y.includes(x));for(const x of k)p.push([x,n.getKeysForOverrideIdentifier(x)])}if(i){const k=y.filter(x=>!b.includes(x));for(const x of k)p.push([x,i.getKeysForOverrideIdentifier(x)])}if(n&&i){for(const k of y)if(b.includes(k)){const x=s({contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});p.push([k,[...x.added,...x.removed,...x.updated]])}}return{added:e,removed:r,updated:o,overrides:p}}function s(i,n){const e=i?n?i.keys.filter(p=>n.keys.indexOf(p)===-1):[...i.keys]:[],r=n?i?n.keys.filter(p=>i.keys.indexOf(p)===-1):[...n.keys]:[],o=[];if(i&&n){for(const p of n.keys)if(i.keys.indexOf(p)!==-1){const y=(0,D.getConfigurationValue)(n.contents,p),b=(0,D.getConfigurationValue)(i.contents,p);v.equals(y,b)||o.push(p)}}return{added:e,removed:r,updated:o}}}),define(Z[116],ee([0,1,19,4,2,26,5,21,64,40,9,37,33]),function($,t,C,I,w,R,A,v,c,d,D,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfigurationModel=t.DefaultConfiguration=void 0;class S extends w.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}t.DefaultConfiguration=S;class f extends c.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(g),s=Object.create(null),i=[];for(const n in g){const e=u[n],r=e!==void 0?e:g[n].default;(0,v.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,v.toValuesTree)(s[n],e=>console.error(`Conflict in default settings file: ${e}`))});super(s,a,i)}}t.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new c.ConfigurationModel}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=m;let E=class extends w.Disposable{constructor(u,g,a){super();this.defaultConfiguration=u,this.policyService=g,this.logService=a,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new c.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},a=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const i of u){const n=s[i];if(!n){a.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}a.push(i),g[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),a}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),a=(0,C.coalesce)(u.map(s=>g.get(s)));this.update(a,!0)}update(u,g){const a=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],i=this._configurationModel.isEmpty();for(const n of u){const e=a[n]?.policy?.name;if(e){const r=this.policyService.getPolicyValue(e);(i?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new c.ConfigurationModel;for(const e of n.keys)this._configurationModel.setValue(e,n.getValue(e));for(const[e,r]of s)r===void 0?this._configurationModel.removeValue(e):this._configurationModel.setValue(e,r);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=fe([te(1,P.IPolicyService),te(2,D.ILogService)],E),t.PolicyConfiguration=E}),define(Z[117],ee([0,1,3,4,2,17,21,64,116,37]),function($,t,C,I,w,R,A,v,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class D extends w.Disposable{constructor(h,S,f,m){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new c.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new c.NullPolicyConfiguration:this._register(new c.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,S)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new v.ConfigurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:l})=>this.onDidDefaultConfigurationChange(E,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,S,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(h,S,new v.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,S){const f=typeof h=="string"?h:void 0,m=(0,A.isConfigurationOverrides)(h)?h:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,S,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const S=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,S,2)}onDidDefaultConfigurationChange(h,S){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,S);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const S=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,S,7)}trigger(h,S,f){const m=new v.ConfigurationChangeEvent(h,{data:S},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=D}),define(Z[118],ee([0,1,16]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseAuthorityWithOptionalPort=t.parseAuthorityWithPort=t.getRemoteServerRootPath=t.getRemoteName=t.getRemoteAuthority=void 0;function I(d){return d.scheme===C.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=I;function w(d){if(!d)return;const D=d.indexOf("+");return D<0?d:d.substr(0,D)}t.getRemoteName=w;function R(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}t.getRemoteServerRootPath=R;function A(d){const{host:D,port:P}=c(d);if(typeof P=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:P}}t.parseAuthorityWithPort=A;function v(d,D){let{host:P,port:h}=c(d);return typeof h=="undefined"&&(h=D),{host:P,port:h}}t.parseAuthorityWithOptionalPort=v;function c(d){const D=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const P=d.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Z[34],ee([0,1,27,8,118]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.isApplicationScopedExtension=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}t.getWorkspaceSupportTypeMessage=R;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=A,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var v;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(v=t.ExtensionType||(t.ExtensionType={}));var c;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(c=t.TargetPlatform||(t.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,E){if(typeof m=="undefined"||m===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof m=="string"||typeof E=="string"){const l=typeof m=="string"?m:m.value,u=typeof E=="string"?E:E.value;return C.equalsIgnoreCase(l,u)}return m._lower===E._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.ExtensionIdentifier=d;function D(f){return P(f)}t.isApplicationScopedExtension=D;function P(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=P;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=h;function S(f,m){if(m){const E=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return f.activationEvents?.indexOf(E)!==-1}return!1}t.isResolverExtension=S,t.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],ee([0,1,27,22,34,13,10,12,32]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeTargetPlatform=t.isAlpineLinux=t.getExtensionDependencies=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.getIdAndVersion=t.ExtensionKey=t.areSameExtensions=void 0;function d(n,e){return n.uuid&&e.uuid?n.uuid===e.uuid:n.id===e.id?!0:(0,C.compareIgnoreCase)(n.id,e.id)===0}t.areSameExtensions=d;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{constructor(e,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=e.id}static create(e){const r=e.manifest?e.manifest.version:e.version,o=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new P(e.identifier,r,o)}static parse(e){const r=D.exec(e);return r&&r[1]&&r[2]?new P({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof P?d(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.ExtensionKey=P;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(n){const e=h.exec(n);return e&&e[1]?[m(e[1]),e[2]]:[m(n),void 0]}t.getIdAndVersion=S;function f(n,e){return`${n}.${e}`}t.getExtensionId=f;function m(n){return n.toLocaleLowerCase()}t.adoptToGalleryExtensionId=m;function E(n,e){return m(f(n,e))}t.getGalleryExtensionId=E;function l(n,e){const r=[],o=p=>{for(const y of r)if(y.some(b=>d(e(b),e(p))))return y;return null};for(const p of n){const y=o(p);y?y.push(p):r.push([p])}return r}t.groupByExtension=l;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=u;function g(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}t.getGalleryExtensionTelemetryData=g,t.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(n,e){const r=[],o=e.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const p=o.shift();if(p&&r.every(y=>!d(y.identifier,{id:p}))){const y=n.filter(b=>d(b.identifier,{id:p}));y.length===1&&(r.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}t.getExtensionDependencies=a;async function s(n,e){if(!R.isLinux)return!1;let r;try{r=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){e.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(p))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}t.isAlpineLinux=s;async function i(n,e){const r=await s(n,e),o=(0,I.getTargetPlatform)(r?"alpine":R.platform,c.arch);return e.debug("ComputeTargetPlatform:",o),o}t.computeTargetPlatform=i}),define(Z[119],ee([0,1,24,12,16,17,39,10,84,22,23,34]),function($,t,C,I,w,R,A,v,c,d,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const h=E=>(0,c.localize)(0,null,E),S=(0,c.localize)(1,null,"ms-dotnettools.csharp");function f(E,l){return l?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let m=class{constructor(l,u){this.extensionManagementService=l,this.extensionGalleryService=u}get location(){}async listExtensions(l,u,g=console){let a=await this.extensionManagementService.getInstalled(1);const s=P.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){g.log("Possible Categories: "),s.forEach(n=>{g.log(n)});return}this.location&&g.log((0,c.localize)(2,null,this.location)),a=a.sort((n,e)=>n.identifier.id.localeCompare(e.identifier.id));let i;for(const n of a)i!==n.identifier.id&&(i=n.identifier.id,g.log(f(n.manifest,l)))}async installExtensions(l,u,g,a,s=console){const i=[],n=[];l.length&&s.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),r=(b,k)=>{const x=e.find(_=>(0,D.areSameExtensions)(_.identifier,{id:b}));if(x){if(!a&&(!k||k==="prerelease"&&x.preRelease))return s.log((0,c.localize)(5,null,b,x.manifest.version,b)),!1;if(k&&x.manifest.version===k)return s.log((0,c.localize)(6,null,`${b}@${k}`)),!1}return!0},o=(b,k,x)=>{y.push({id:b,version:k!=="prerelease"?k:void 0,installOptions:{...g,isBuiltin:x,installPreReleaseVersion:k==="prerelease"||g.installPreReleaseVersion}})},p=[],y=[];for(const b of l)if(b instanceof v.URI)p.push(b);else{const[k,x]=(0,D.getIdAndVersion)(b);r(k,x)&&o(k,x,!1)}for(const b of u){const[k,x]=(0,D.getIdAndVersion)(b);r(k,x)&&o(k,x,!0)}if(p.length&&await Promise.all(p.map(async b=>{try{const k=await this.installVSIX(b,{...g,isBuiltin:!1},a,s);k&&n.push(k)}catch(k){s.error(k.message||k.stack||k),i.push(b.toString())}})),y.length){const b=await this.getGalleryExtensions(y);await Promise.all(y.map(async k=>{const x=b.get(k.id.toLowerCase());if(x)try{const _=await this.installFromGallery(k,x,e,a,s);_&&n.push(_)}catch(_){s.error(_.message||_.stack||_),i.push(k.id)}else s.error(`${h(k.version?`${k.id}@${k.version}`:k.id)}
${S}`),i.push(k.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(l,u,g,a){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,a))try{return await this.extensionManagementService.install(l,u),a.log((0,c.localize)(8,null,(0,R.basename)(l))),s}catch(n){if((0,I.isCancellationError)(n))return a.log((0,c.localize)(9,null,(0,R.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const u=new Map,g=l.some(s=>s.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:g})),C.CancellationToken.None);for(const s of a)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:l,version:u,installOptions:g},a,s,i,n){const e=await this.extensionGalleryService.getManifest(a,C.CancellationToken.None);if(e&&!this.validateExtensionKind(e,n))return null;const r=s.find(o=>(0,D.areSameExtensions)(o.identifier,a.identifier));if(r){if(a.version===r.manifest.version)return n.log((0,c.localize)(10,null,u?`${l}@${u}`:l)),null;n.log((0,c.localize)(11,null,l,a.version))}try{g.isBuiltin?n.log(u?(0,c.localize)(12,null,l,u):(0,c.localize)(13,null,l)):n.log(u?(0,c.localize)(14,null,l,u):(0,c.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(a,{...g,installGivenVersion:!!u});return n.log((0,c.localize)(16,null,l,o.manifest.version)),e}catch(o){if((0,I.isCancellationError)(o))return n.log((0,c.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,u){return!0}async validateVSIX(l,u,g){const a={id:(0,D.getGalleryExtensionId)(l.publisher,l.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,D.areSameExtensions)(a,n.identifier)&&(0,A.gt)(n.manifest.version,l.version));return i&&!u?(g.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,l.version)),!1):this.validateExtensionKind(l,g)}async uninstallExtensions(l,u,g=console){const a=async i=>{if(i instanceof v.URI){const n=await this.extensionManagementService.getManifest(i);return f(n)}return i},s=[];for(const i of l){const n=await a(i),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,D.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${S}`);if(r.some(o=>o.type===0)){g.log((0,c.localize)(19,null,n));return}if(!u&&r.some(o=>o.isBuiltin)){g.log((0,c.localize)(20,null,n));return}g.log((0,c.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?g.log((0,c.localize)(22,null,n,this.location)):g.log((0,c.localize)(23,null,n))}}async locateExtension(l,u=console){const g=await this.extensionManagementService.getInstalled();l.forEach(a=>{g.forEach(s=>{if(s.identifier.id===a&&s.location.scheme===w.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,c.localize)(24,null,l,this.location):(0,c.localize)(25,null,l)}};m=fe([te(0,d.IExtensionManagementService),te(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(Z[41],ee([0,1,3,15,2,36,10,23,11,8,9]),function($,t,C,I,w,R,A,v,c,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=t.IExtensionsProfileScannerService=void 0,t.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let P=class extends w.Disposable{constructor(S,f){super();this.fileService=S,this.logService=f,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,f){return this.withProfileExtensions(f,m=>(m=m.filter(E=>S.some(([l])=>!(0,v.areSameExtensions)(E.identifier,l.identifier))),m.push(...S.map(([E,l])=>({identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:l}))),m))}removeExtensionFromProfile(S,f){return this.withProfileExtensions(f,m=>m.filter(E=>!(0,v.areSameExtensions)(E.identifier,S)))}async withProfileExtensions(S,f){return this.getResourceAccessQueue(S).queue(async()=>{let m=[];try{const E=await this.fileService.readFile(S),l=JSON.parse(E.value.toString());for(const u of l){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:A.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}if(f){m=f(m);const E=m.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(S,I.VSBuffer.fromString(JSON.stringify(E)))}return m})}getResourceAccessQueue(S){let f=this.resourcesAccessQueueMap.get(S);return f||(f=new C.Queue,this.resourcesAccessQueueMap.set(S,f)),f}};P=fe([te(0,c.IFileService),te(1,D.ILogService)],P),t.ExtensionsProfileScannerService=P}),define(Z[120],ee([0,1,3,12,2,13,17,39,10,30,20,18,22,23,11,9]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let E=class extends w.Disposable{constructor(u,g,a,s){super();this.fileService=g,this.extensionGalleryService=a,this.logService=s,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const a=this.getName(u),s=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(s)){const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(u,i,g);try{await this.rename(i,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,a){try{await D.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(R.isWindows&&s&&s.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,a);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],a=[];for(const n of u.children){const e=S.ExtensionKey.parse(n.name);e&&a.push([e,n])}const s=(0,S.groupByExtension)(a,([n])=>n),i=[];for(const n of s)n.sort((e,r)=>v.rcompare(e[0].version,r[0].version)),g.push(...n.slice(1).map(e=>e[1].resource)),i.push(n[0][1]);i.sort((n,e)=>n.mtime-e.mtime),g.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(g.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?S.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};E=fe([te(0,P.INativeEnvironmentService),te(1,f.IFileService),te(2,h.IExtensionGalleryService),te(3,m.ILogService)],E),t.ExtensionsDownloader=E}),define(Z[121],ee([0,1,2,14,20,34]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class A extends C.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(d.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=A}),define(Z[122],ee([0,1,152,19,3,2,16,14,20,18,22,23,9,62]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let f=class extends S.LanguagePackBaseService{constructor(u,g,a,s){super(a);this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(a=>{const s=u[a];return{...this.createQuickPickItem(a,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((a,s)=>a.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(a=>g[a]&&g[a].extensions.some(s=>(0,P.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(g);return!(0,I.equals)(Object.keys(u),Object.keys(a))}};f=fe([te(0,D.IExtensionManagementService),te(1,d.INativeEnvironmentService),te(2,D.IExtensionGalleryService),te(3,h.ILogService)],f),t.NativeLanguagePackService=f;let m=class extends R.Disposable{constructor(u,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(a=>delete g[a]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const a of g)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,a);Object.keys(u).forEach(a=>this.updateHash(u[a]))}createLanguagePacksFromExtension(u,g){const a=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const i of s)if(g.location.scheme===A.Schemas.file&&E(i)){let n=u[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},u[i.languageId]=n);const e=n.extensions.filter(r=>(0,P.areSameExtensions)(r.extensionIdentifier,a))[0];e?e.version=g.manifest.version:n.extensions.push({extensionIdentifier:a,version:g.manifest.version});for(const r of i.translations)n.translations[r.id]=(0,v.join)(g.location.fsPath,r.path)}}updateHash(u){if(u){const g=(0,C.createHash)("md5");for(const a of u.extensions)g.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(g=u(a),a)).then(a=>{for(const i of Object.keys(a))a[i]||delete a[i];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,a=>this.logService.error(a))})}};m=fe([te(0,d.INativeEnvironmentService),te(1,h.ILogService)],m);function E(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(Z[47],ee([0,1,15,93,40,8,33]),function($,t,C,I,w,R,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asTextOrError=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function v(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}t.isSuccess=v;function c(m){return m.res.statusCode===204}async function d(m){return c(m)?null:(await(0,C.streamToBuffer)(m.stream)).toString()}t.asText=d;async function D(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}t.asTextOrError=D;async function P(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);if(c(m))return null;const l=(await(0,C.streamToBuffer)(m.stream)).toString();try{return JSON.parse(l)}catch(u){throw u.message+=`:
`+l,u}}t.asJson=P;function h(m){f(m)}t.updateProxyConfigurationsScope=h;let S;function f(m){const E=A.Registry.as(w.Extensions.Configuration),l=S;S={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[S],remove:l?[l]:[]})}f(2)}),define(Z[123],ee([0,1,24,16,11,47]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let A=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,D=C.CancellationToken.None){if(c.scheme===I.Schemas.file||c.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const P={type:"GET",url:c.toString(!0)},h=await this.requestService.request(P,D);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const S=await(0,R.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${S}`)}}};A=fe([te(0,R.IRequestService),te(1,w.IFileService)],A),t.DownloadService=A}),define(Z[124],ee([0,1,125,5]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(A,v){return A.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:A.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(A,v,c={}){const d=(0,C.parse)(A),D=c.proxyUrl||w(d,v);if(!D)return null;const P=(0,C.parse)(D);if(!/^https?:$/.test(P.protocol||""))return null;const h={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,I.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((S,f)=>{$(["http-proxy-agent"],S,f)}))(h):new(await new Promise((S,f)=>{$(["https-proxy-agent"],S,f)}))(h)}t.getProxyAgent=R}),define(Z[126],ee([0,1,57,14,94,24,31,12,13,30,77,153,3]),function($,t,C,I,w,R,A,v,c,d,D,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const S=1e4;let f;async function m(l,u,g){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(a,s)=>{const i=new R.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,w.localize)(0,null)))},S);try{a(await E(l,i.token))}catch(e){!(0,v.isCancellationError)(e)&&!i.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,A.toErrorMessage)(e)))):a({})}finally{clearTimeout(n),i.dispose()}})),f)}t.getResolvedShellEnv=m;async function E(l,u){const g=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",a);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const e=await(0,D.getSystemShell)(c.OS,n);return l.trace("getUnixShellEnvironment#shell",e),new Promise((r,o)=>{if(u.isCancellationRequested)return o((0,v.canceled)());const p=(0,I.basename)(e);let y,b;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(p)?(y=`& '${process.execPath}' ${k} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,b=["-Login","-Command"]):(y=`'${process.execPath}' ${k} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,p==="tcsh"?b=["-ic"]:b=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),y);const x=(0,C.spawn)(e,[...b,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(x.kill(),o((0,v.canceled)()))),x.on("error",Q=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(Q)),o(Q)});const _=[];x.stdout.on("data",Q=>_.push(Q));const G=[];x.stderr.on("data",Q=>G.push(Q)),x.on("close",(Q,ne)=>{const ce=Buffer.concat(_).toString("utf8");l.trace("getUnixShellEnvironment#raw",ce);const re=Buffer.concat(G).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),Q||ne)return o(new Error((0,w.localize)(2,null,Q,ne)));const ge=i.exec(ce),ae=ge?ge[1]:"{}";try{const N=JSON.parse(ae);g?N.ELECTRON_RUN_AS_NODE=g:delete N.ELECTRON_RUN_AS_NODE,a?N.ELECTRON_NO_ATTACH_CONSOLE=a:delete N.ELECTRON_NO_ATTACH_CONSOLE,delete N.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",N),r(N)}catch(N){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(N)),o(N)}})})}}),define(Z[65],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,C.createDecorator)("stateService")}),define(Z[127],ee([0,1,3,15,5,18,11,9]),function($,t,C,I,w,R,A,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class c{constructor(P,h,S){this.storagePath=P,this.logService=h,this.fileService=S,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new C.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,h){const S=this.storage[P];return(0,w.isUndefinedOrNull)(S)?h:S}setItem(P,h){this.setItems([{key:P,data:h}])}setItems(P){let h=!1;for(const{key:S,data:f}of P)this.storage[S]!==f&&((0,w.isUndefinedOrNull)(f)?(0,w.isUndefined)(this.storage[S])||(this.storage[S]=void 0,h=!0):(this.storage[S]=f,h=!0));h&&this.save()}removeItem(P){(0,w.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(P){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),P)}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,I.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=c;let d=class{constructor(P,h,S){this.fileStorage=new c(P.stateResource,h,S)}async init(){await this.fileStorage.init()}getItem(P,h){return this.fileStorage.getItem(P,h)}};d=fe([te(0,R.IEnvironmentService),te(1,v.ILogService),te(2,A.IFileService)],d),t.StateService=d}),define(Z[66],ee([0,1,13,32,10,30]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function A(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function v(d,D,P,h,S,f,m,E,l,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=S,g.version=f,g["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,C.PlatformToString)(C.platform),g["common.nodePlatform"]=I.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",E&&(g["common.msftInternal"]=E);let a=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),C.isLinuxSnap&&(g["common.snap"]="true");const i=A(P);i&&(g["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(l));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}t.resolveCommonProperties=v;function c(d){const D=I.env.USERDNSDOMAIN;if(!D)return!1;const P=D.toLowerCase();return d.some(h=>P===h)}t.verifyMicrosoftInternalDomain=c}),define(Z[35],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(I=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[42],ee([0,1,26,52,5,21,66,35]),function($,t,C,I,w,R,A,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPiiPathsFromEnvironment=t.isInternalTelemetry=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class c{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(i,n){return Promise.resolve(void 0)}publicLog2(i,n){return this.publicLog(i,n)}publicLogError(i,n){return Promise.resolve(void 0)}publicLogError2(i,n){return this.publicLogError(i,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=c,t.NullTelemetryService=new c;class d{async publicLog(i,n,e){}async publicLogError(i,n,e){}}t.NullEndpointTelemetryService=d,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(s,i){return i.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(n.source),configurationKeys:l(n.sourceConfig)})})}t.configurationTelemetry=D;function P(s,i){return!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}t.supportsTelemetry=P;function h(s){const i=s.getValue(v.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=h;function S(s){const i={},n={},e={};E(s,e);for(let r in e){r=r.length>150?r.substr(r.length-149):r;const o=e[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),i[r]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(i[r]=o)}return{properties:i,measurements:n}}t.validateTelemetryData=S;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const i of f)if(s.startsWith(`${i}+`))return i;return"other"}t.cleanRemoteAuthority=m;function E(s,i,n=0,e){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],p=e?e+r:r;Array.isArray(o)?i[p]=(0,C.safeStringify)(o):o instanceof Date?i[p]=o.toISOString():(0,w.isObject)(o)?n<2?E(o,i,n+1,p+"."):i[p]=(0,C.safeStringify)(o):i[p]=o}}function l(s){if(!s)return[];const i=[];return u(i,"",s),i}function u(s,i,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(e=>u(s,i?`${i}.${e}`:e,n[e])):s.push(i)}function g(s,i){const n=s.msftInternalDomains||[],e=i.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||e}t.isInternalTelemetry=g;function a(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}t.getPiiPathsFromEnvironment=a}),define(Z[128],ee([0,1,101,42]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function w(R,A,v,c,d,D,P){const h={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`},S=await(0,C.getServiceMachineId)(v,d,D),{sessionId:f}=await P.getTelemetryInfo();return(0,I.supportsTelemetry)(A,v)&&(0,I.getTelemetryLevel)(c)===3&&(h["X-Market-User-Id"]=S,h["VSCode-SessionId"]=f),h}t.resolveMarketplaceHeaders=w}),define(Z[129],ee([0,1,12,26,42]),function($,t,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(c,d,D){const P=await new Promise((E,l)=>{$(["@microsoft/1ds-core-js"],E,l)}),h=await new Promise((E,l)=>{$(["@microsoft/1ds-post-js"],E,l)}),S=new P.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:c,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(D){m.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:D};m.extensionConfig[f.identifier]=E}return S.initialize(m,[]),S.addTelemetryInitializer(E=>{d&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),S}class v{constructor(d,D,P,h,S){this._isInternalTelemetry=d,this._eventPrefix=D,this._defaultData=P,this._xhrOverride=S,this.endPointUrl=R,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(D=>{d(D)},D=>{(0,C.onUnexpectedError)(D),console.error(D)})}}log(d,D){if(!this._aiCoreOrKey)return;D=(0,I.mixin)(D,this._defaultData),D=(0,w.validateTelemetryData)(D);const P=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=D?.properties.version??"Unknown",h.track({name:P,baseData:{name:P,properties:D?.properties,measurements:D?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(D=>{D.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=v}),define(Z[130],ee([0,1,2,26,52,13,27,95,21,40,131,28,33,35,42]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(u,g,a){this._configurationService=g,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const a=g.usage?3:g.error?2:0;u=Math.min(u,a)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,a=u["common.machineId"],s=u["common.firstSessionDate"],i=u["common.msftInternal"];return{sessionId:g,machineId:a,firstSessionDate:s,msftInternal:i}}dispose(){this._disposables.dispose()}_log(u,g,a,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(i=>{a=(0,I.mixin)(a,i),a=(0,I.mixin)(a,this._experimentProperties),a=(0,I.cloneAndChange)(a,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(u,a))},i=>{console.error(i)})}publicLog(u,g,a){return this._log(u,3,g,a)}publicLog2(u,g,a){return this.publicLog(u,g,a)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const a=[];for(const e of this._cleanupPatterns)for(;;){const r=e.exec(u);if(!r)break;a.push([r.index,e.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(g="";;){const e=i.exec(u);if(!e)break;!s.test(e[0])&&a.every(([r,o])=>e.index<r||e.index>=o)&&(g+=u.substring(n,e.index)+"<REDACTED: user-file-path>",n=i.lastIndex)}return n<u.length&&(g+=u.substr(n)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of a)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let a=u;g&&(a=this._anonymizeFilePaths(a));for(const s of this._cleanupPatterns)a=a.replace(s,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([te(1,c.IConfigurationService),te(2,P.IProductService)],m),t.TelemetryService=m;function E(){const l=(0,v.localize)(0,null,D.default.nameLong),u=D.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,v.localize)(3,null),a=(0,v.localize)(4,null),s=(0,v.localize)(5,null),i=(0,v.localize)(6,null),n=(0,v.localize)(7,null),e=`
|       | ${a} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,v.localize)(8,null);return`
${l} ${u} ${g}

&nbsp;

${n}
${e}

&nbsp;

${r}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,v.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,v.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[132],ee([0,1,154,129]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;class w extends I.AbstractOneDataSystemAppender{constructor(A,v,c,d){const D={sendPOST:(P,h)=>{const S={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const f=C.request(P.urlString,S,m=>{m.on("data",function(E){h(m.statusCode??200,m.headers,E.toString())}),m.on("error",function(E){h(0,{})})});f.write(P.data),f.end()}catch{h(0,{})}}};super(A,v,c,d,D)}}t.OneDataSystemAppender=w}),define(Z[133],ee([0,1,14,20]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(R,A){const v=Object.create(null),c=(D,P)=>{const h=JSON.parse(D);v[P]=h};if(A){const D=[],P=await I.Promises.readdir(A);for(const S of P)try{(await I.Promises.stat((0,C.join)(A,S))).isDirectory()&&D.push(S)}catch{}const h=[];for(const S of D)(await I.Promises.readdir((0,C.join)(A,S))).filter(m=>m==="telemetry.json").length===1&&h.push(S);for(const S of h){const f=(await I.Promises.readFile((0,C.join)(A,S,"telemetry.json"))).toString();c(f,S)}}let d=(await I.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await I.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(v,null,4)}t.buildTelemetryMessage=w}),define(Z[29],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Z[134],ee([0,1,4,2,10,18,23,11,9,29]),function($,t,C,I,w,R,A,v,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let D=class extends I.Disposable{constructor(h,S,f,m,E){super();this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const l=w.URI.file(f.extensionsPath);this._register(S.watch(l)),this._register(C.Event.filter(S.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,l)))(()=>this.onDidChange()))}doesChangeAffects(h,S){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),S)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const S of h)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),S=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,A.areSameExtensions)(E,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(E=>(0,A.areSameExtensions)(E,m))?!1:h.every(E=>!(0,A.areSameExtensions)(E.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(S.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:f})}}};D=fe([te(1,v.IFileService),te(2,R.INativeEnvironmentService),te(3,c.ILogService),te(4,d.IUriIdentityService)],D),t.ExtensionsWatcher=D}),define(Z[135],ee([0,1,29,102,11,17,69,4,2]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let D=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const S=new Map,f=m=>{let E=S.get(m.scheme);return E===void 0&&(E=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),S.set(m.scheme,E)),E};this._dispooables.add(v.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{S.delete(m.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new A.SkipList((m,E)=>this.extUri.compare(m,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));const S=this._canonicalUris.get(h);return S?S.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let f=0;f<S;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};D=fe([te(0,w.IFileService)],D),t.UriIdentityService=D,(0,I.registerSingleton)(C.IUriIdentityService,D,!0)}),define(Z[136],ee([0,1,97,14,36,17,10,8,16]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.hasWorkspaceFileExtension=t.isSavedWorkspace=t.isTemporaryWorkspace=t.isUntitledWorkspace=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.isWorkspaceFolder=t.isWorkspace=t.WorkbenchState=t.reviveIdentifier=t.isWorkspaceIdentifier=t.toWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=(0,v.createDecorator)("contextService");function d(e){const r=e;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}t.isSingleFolderWorkspaceIdentifier=d;function D(e){if(e.configuration)return{id:e.id,configPath:e.configuration};if(e.folders.length===1)return{id:e.id,uri:e.folders[0].uri}}t.toWorkspaceIdentifier=D;function P(e){const r=e;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}t.isWorkspaceIdentifier=P;function h(e){const r=e;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const o=e;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(e?.id)return{id:e.id}}t.reviveIdentifier=h;var S;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(S=t.WorkbenchState||(t.WorkbenchState={}));function f(e){const r=e;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}t.isWorkspace=f;function m(e){const r=e;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}t.isWorkspaceFolder=m;class E{constructor(r,o,p,y,b){this._id=r,this._transient=p,this._configuration=y,this._ignorePathCasing=b,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=E;class l{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=l;function u(e){return new l({uri:e,index:0,name:(0,R.basenameOrAuthority)(e)},{uri:e.toString()})}t.toWorkspaceFolder=u,t.WORKSPACE_EXTENSION="code-workspace";const g=`.${t.WORKSPACE_EXTENSION}`;t.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function a(e,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(e,r.untitledWorkspacesHome)}t.isUntitledWorkspace=a;function s(e){let r;return A.URI.isUri(e)?r=e:r=e.configuration,r?.scheme===c.Schemas.tmp}t.isTemporaryWorkspace=s;function i(e,r){return!a(e,r)&&!s(e)}t.isSavedWorkspace=i;function n(e){return(typeof e=="string"?(0,I.extname)(e):(0,R.extname)(e))===g}t.hasWorkspaceFileExtension=n}),define(Z[25],ee([0,1,53,4,2,17,5,10,96,18,11,8,9,136,36,29,3,30,27]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=t.toUserDataProfile=t.EXTENSIONS_RESOURCE_NAME=t.reviveProfile=t.IUserDataProfilesService=t.PROFILES_ENABLEMENT_CONFIG=t.isUserDataProfile=void 0;function g(n){const e=n;return!!(e&&typeof e=="object"&&typeof e.id=="string"&&typeof e.isDefault=="boolean"&&typeof e.name=="string"&&v.URI.isUri(e.location)&&v.URI.isUri(e.globalStorageHome)&&v.URI.isUri(e.settingsResource)&&v.URI.isUri(e.keybindingsResource)&&v.URI.isUri(e.tasksResource)&&v.URI.isUri(e.snippetsHome)&&((0,A.isUndefined)(e.extensionsResource)||v.URI.isUri(e.extensionsResource)))}t.isUserDataProfile=g,t.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",t.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function a(n,e){return{id:n.id,isDefault:n.isDefault,name:n.name,location:v.URI.revive(n.location).with({scheme:e}),globalStorageHome:v.URI.revive(n.globalStorageHome).with({scheme:e}),settingsResource:v.URI.revive(n.settingsResource).with({scheme:e}),keybindingsResource:v.URI.revive(n.keybindingsResource).with({scheme:e}),tasksResource:v.URI.revive(n.tasksResource).with({scheme:e}),snippetsHome:v.URI.revive(n.snippetsHome).with({scheme:e}),extensionsResource:v.URI.revive(n.extensionsResource)?.with({scheme:e}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}t.reviveProfile=a,t.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(n,e,r,o){return{id:(0,C.hash)(e.path).toString(16),name:n,location:e,isDefault:!1,globalStorageHome:(0,R.joinPath)(e,"globalStorage"),settingsResource:(0,R.joinPath)(e,"settings.json"),keybindingsResource:(0,R.joinPath)(e,"keybindings.json"),tasksResource:(0,R.joinPath)(e,"tasks.json"),snippetsHome:(0,R.joinPath)(e,"snippets"),extensionsResource:(0,R.joinPath)(e,t.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:o}}t.toUserDataProfile=s;let i=class extends w.Disposable{constructor(e,r,o,p){super();this.environmentService=e,this.fileService=r,this.uriIdentityService=o,this.logService=p,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new I.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new I.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new I.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new I.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(e){this.enabled!==e&&(this._profilesObject=void 0,this.enabled=e)}get profilesObject(){if(!this._profilesObject){const e=this.enabled?this.getStoredProfiles().map(y=>s(y.name,y.location,y.useDefaultFlags)):[];let r;const o=new f.ResourceMap,p=s((0,c.localize)(0,null),this.environmentService.userRoamingDataHome);if(e.unshift({...p,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||e.length>0||this.transientProfilesObject.profiles.length>0?p.extensionsResource:void 0}),e.length){const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[b,k]of Object.entries(y.workspaces)){const x=v.URI.parse(b),_=v.URI.parse(k),G=e.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,_));G&&o.set(x,G)}if(y.emptyWindow){const b=v.URI.parse(y.emptyWindow);r=e.find(k=>this.uriIdentityService.extUri.isEqual(k.location,b))}}this._profilesObject={profiles:e,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(e){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let p=0;for(const b of this.profiles){const k=o.exec(b.name),x=k?parseInt(k[1]):0;p=x>p?x:p}const y=`${r} ${p+1}`;return this.createProfile(y,void 0,e,!0)}async createProfile(e,r,o,p){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const y=await this.doCreateProfile(e,r,p);return o&&await this.setProfileForWorkspace(o,y),y}async doCreateProfile(e,r,o){let p=this.profileCreationPromises.get(e);return p||(p=(async()=>{try{const y=this.profiles.find(x=>x.name===e);if(y)return y;const b=s(e,(0,R.joinPath)(this.profilesHome,(0,C.hash)((0,l.generateUuid)()).toString(16)),r,o);await this.fileService.createFolder(b.location);const k=[];return this._onWillCreateProfile.fire({profile:b,join(x){k.push(x)}}),await E.Promises.settled(k),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(e)}})(),this.profileCreationPromises.set(e,p)),p}async updateProfile(e,r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);let p=this.profiles.find(y=>y.id===e.id);if(!p)throw new Error(`Profile '${e.name}' does not exist`);return p=s(r,p.location,o),this.updateProfiles([],[],[p]),p}async removeProfile(e){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(e.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(p=>p.id===e.id);if(!r)throw new Error(`Profile '${e.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(p){o.push(p)}}),await E.Promises.settled(o),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const p of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(p)?.id&&this.profilesObject.workspaces.delete(p);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(p){this.logService.error(p)}}getOrSetProfileForWorkspace(e,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(e);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(e,o)),o}async setProfileForWorkspace(e,r){this.setProfileForWorkspaceSync(e,r)}setProfileForWorkspaceSync(e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(p=>p.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(e,o)}unsetWorkspace(e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(e,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!this.enabled)return;const e=await this.fileService.resolve(this.profilesHome);await Promise.all((e.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}async cleanUpTransientProfiles(){if(!this.enabled)return;const e=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(e.map(r=>this.removeProfile(r)))}getProfileForWorkspace(e){const r=this.getWorkspace(e);return v.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(e){return(0,S.isSingleFolderWorkspaceIdentifier)(e)?e.uri:(0,S.isWorkspaceIdentifier)(e)?e.configPath:"empty-window"}isProfileAssociatedToWorkspace(e){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,e.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,e.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,e.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,e.location)))}updateProfiles(e,r,o){const p=[...this.profiles,...e],y=[];this.transientProfilesObject.profiles=[];for(let b of p)b.isDefault||r.some(k=>b.id===k.id)||(b=o.find(k=>b.id===k.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):y.push({location:b.location,name:b.name,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(e,r,o)}triggerProfilesChanges(e,r,o){this._onDidChangeProfiles.fire({added:e,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(e,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(e,void 0,!0);const p=this.getWorkspace(e),y=o?this.transientProfilesObject:this.profilesObject;v.URI.isUri(p)?(y.workspaces.delete(p),r&&y.workspaces.set(p,r)):y.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const e={};for(const[o,p]of this.profilesObject.workspaces.entries())e[o.toString()]=p.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:e,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(e){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(e){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=fe([te(0,d.IEnvironmentService),te(1,D.IFileService),te(2,m.IUriIdentityService),te(3,h.ILogService)],i),t.UserDataProfilesService=i}),define(Z[137],ee([0,1,19,3,24,12,4,2,13,10,82,22,23,34,9,28,35,25]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let u=class extends v.Disposable{constructor(e,r,o,p,y){super();this.galleryService=e,this.telemetryService=r,this.logService=o,this.productService=p,this.userDataProfilesService=y,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,v.toDisposable)(()=>{this.installingExtensions.forEach(b=>b.cancel()),this.uninstallingExtensions.forEach(b=>b.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(o=>(0,P.isTargetPlatformCompatible)(o,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{if(!this.galleryService.isEnabled())throw new P.ExtensionManagementError(D.localize(0,null),P.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(e,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(e),error:o}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(o),a(o)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.uninstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:r,compatible:!0},w.CancellationToken.None);if(!o)throw new Error(D.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,r,o){const p=_=>`${h.ExtensionKey.create(_).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(r)){const _=this.installingExtensions.get(p(r));if(_){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:G}=await _.waitUntilTaskIsFinished();return G}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const y=[],b=[],k=this.createInstallExtensionTask(e,r,o);d.URI.isUri(r)||this.installingExtensions.set(p(r),k),this._onInstallExtension.fire({identifier:k.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",k.identifier.id),y.push({task:k,manifest:e});let x=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const G=await this.getAllDepsAndPackExtensionsToInstall(k.identifier,e,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:Q,manifest:ne}of G){x=x||!!ne.extensionDependencies?.some(re=>(0,h.areSameExtensions)({id:re},k.identifier));const ce=p(Q);if(this.installingExtensions.has(ce))this.logService.info("Extension is already requested to install",Q.identifier.id);else{const re=this.createInstallExtensionTask(ne,Q,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,re),this._onInstallExtension.fire({identifier:re.identifier,source:Q,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),y.push({task:re,manifest:ne})}}}catch(G){if(d.URI.isUri(k.source))(0,C.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,G.message),(0,C.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,G.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),G}const _=y.reduce((G,{task:Q,manifest:ne})=>(G.set(Q.identifier.id.toLowerCase(),{task:Q,manifest:ne}),G),new Map);for(;_.size;){let G;const Q=[..._.values()].filter(({manifest:ne})=>!ne.extensionDependencies?.some(ce=>_.has(ce.toLowerCase())));Q.length?G=_.size===1?Q:Q.filter(({task:ne})=>!(ne===k&&!x)):(this.logService.info("Found extensions with circular dependencies",Q.map(({task:ne})=>ne.identifier.id)),G=[..._.values()]),await this.joinAllSettled(G.map(async({task:ne})=>{const ce=new Date().getTime();try{const{local:re}=await ne.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(re,ne.source,o,w.CancellationToken.None))),!d.URI.isUri(ne.source)){const ge=ne.operation===3,ae=ge?void 0:(new Date().getTime()-ne.source.lastUpdated)/1e3;if(s(this.telemetryService,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,durationSinceUpdate:ae}),c.isWeb&&ne.operation!==3)try{await this.galleryService.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}b.push({local:re,identifier:ne.identifier,operation:ne.operation,source:ne.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw d.URI.isUri(ne.source)||s(this.telemetryService,ne.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,error:re}),this.logService.error("Error while installing the extension:",ne.identifier.id),re}finally{_.delete(ne.identifier.id.toLowerCase())}}))}return b.forEach(({identifier:G})=>this.logService.info("Extension installed successfully:",G.id)),this._onDidInstallExtensions.fire(b),b.filter(({identifier:G})=>(0,h.areSameExtensions)(G,k.identifier))[0].local}catch(_){if(y.forEach(({task:G})=>G.cancel()),b.length)try{const G=await Promise.allSettled(b.map(({local:Q})=>this.createUninstallExtensionTask(Q,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let Q=0;Q<G.length;Q++){const ne=G[Q],{identifier:ce}=b[Q];ne.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ce.id):this.logService.warn("Rollback: Error while uninstalling extension",ce.id,(0,R.getErrorMessage)(ne.reason))}}catch(G){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(G),b.map(({identifier:Q})=>Q.id))}throw this._onDidInstallExtensions.fire(y.map(({task:G})=>({identifier:G.identifier,operation:2,source:G.source,context:o.context,profileLocation:o.profileLocation}))),_}finally{for(const{task:_}of y)if(!d.URI.isUri(_.source)){const G=p(_.source);this.installingExtensions.delete(G)||this.logService.warn("Installation task is not found in the cache",G)}}}async joinAllSettled(e){const r=[],o=[],p=await Promise.allSettled(e);for(const y of p)y.status==="fulfilled"?r.push(y.value):o.push(y.reason);if(o.length)throw g(o);return r}async getAllDepsAndPackExtensionsToInstall(e,r,o,p,y){if(!this.galleryService.isEnabled())return[];let b=await this.getInstalled(void 0,y);const k=[e,...b.map(G=>G.identifier)],x=[],_=async(G,Q)=>{const ne=Q.extensionDependencies||[],ce=[...ne];if(Q.extensionPack){const re=o?b.find(ge=>(0,h.areSameExtensions)(ge.identifier,G)):void 0;for(const ge of Q.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ae=>(0,h.areSameExtensions)({id:ae},{id:ge}))||ce.every(ae=>!(0,h.areSameExtensions)({id:ae},{id:ge}))&&ce.push(ge)}if(ce.length){const re=[...k,...x.map(ae=>ae.gallery.identifier)],ge=ce.filter(ae=>re.every(N=>!(0,h.areSameExtensions)(N,{id:ae})));if(ge.length){const ae=await this.galleryService.getExtensions(ge.map(N=>({id:N,preRelease:p})),w.CancellationToken.None);for(const N of ae){if(re.find(F=>(0,h.areSameExtensions)(F,N.identifier)))continue;const B=ne.some(F=>(0,h.areSameExtensions)({id:F},N.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(N,!1,p)}catch(F){if(F instanceof P.ExtensionManagementError&&F.code===P.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw F}x.push({gallery:M.extension,manifest:M.manifest}),await _(M.extension.identifier,M.manifest)}}}};return await _(e,r),b=await this.getInstalled(void 0,y),x.filter(G=>!b.some(Q=>(0,h.areSameExtensions)(Q.identifier,G.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r,o){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,h.areSameExtensions)(e.identifier,k)))throw new P.ExtensionManagementError(D.localize(3,null,e.identifier.id),P.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const k=await this.getTargetPlatform();throw new P.ExtensionManagementError(D.localize(4,null,e.identifier.id,this.productService.nameLong,(0,P.TargetPlatformToString)(k)),P.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(e,r,o);if(y){if(o&&!r&&e.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new P.ExtensionManagementError(D.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],w.CancellationToken.None))[0]?new P.ExtensionManagementError(D.localize(6,null,e.identifier.id),P.ExtensionManagementErrorCode.ReleaseVersionNotFound):new P.ExtensionManagementError(D.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const b=await this.galleryService.getManifest(y,w.CancellationToken.None);if(b===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,P.ExtensionManagementErrorCode.Invalid);if(b.version!==y.version)throw new P.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,P.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:b}}async getCompatibleVersion(e,r,o){const p=await this.getTargetPlatform();let y=null;return!r&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==o&&(y=(await this.galleryService.getExtensions([{...e.identifier,preRelease:o}],{targetPlatform:p,compatible:!0},w.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(e,o,p)&&(y=e),y||(r?y=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:p,compatible:!0},w.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(e,o,p)),y}async uninstallExtension(e,r){const o=_=>`${_.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,p=this.uninstallingExtensions.get(o(e.identifier));if(p)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),p.waitUntilTaskIsFinished();const y=(_,G)=>{const Q=this.createUninstallExtensionTask(_,G);return this.uninstallingExtensions.set(o(Q.extension.identifier),Q),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped}),Q},b=(_,G)=>{G?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString(),G.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,G.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:G}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:G?.code,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped})},k=[],x=[];try{k.push(y(e,r));const _=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const G=this.getAllPackExtensionsToUninstall(e,_);for(const Q of G)this.uninstallingExtensions.has(o(Q.identifier))?this.logService.info("Extensions is already requested to uninstall",Q.identifier.id):k.push(y(Q,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.checkForDependents(k.map(G=>G.extension),_,e),await this.joinAllSettled(k.map(async G=>{try{if(await G.run(),await this.joinAllSettled(this.participants.map(Q=>Q.postUninstall(G.extension,r,w.CancellationToken.None))),G.extension.identifier.uuid)try{await this.galleryService.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}b(G.extension)}catch(Q){const ne=Q instanceof P.ExtensionManagementError?Q:new P.ExtensionManagementError((0,R.getErrorMessage)(Q),P.ExtensionManagementErrorCode.Internal);throw b(G.extension,ne),ne}finally{x.push(G)}}))}catch(_){const G=_ instanceof P.ExtensionManagementError?_:new P.ExtensionManagementError((0,R.getErrorMessage)(_),P.ExtensionManagementErrorCode.Internal);for(const Q of k){try{Q.cancel()}catch{}x.includes(Q)||b(Q.extension,G)}throw G}finally{for(const _ of k)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(e,r,o){for(const p of e){const y=this.getDependents(p,r);if(y.length){const b=y.filter(k=>!e.some(x=>(0,h.areSameExtensions)(x.identifier,k.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(p,b,o))}}}getDependentsErrorMessage(e,r,o){return o===e?r.length===1?D.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?D.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):D.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?D.localize(11,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?D.localize(12,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):D.localize(13,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,o=[]){if(o.indexOf(e)!==-1)return[];o.push(e);const p=e.manifest.extensionPack?e.manifest.extensionPack:[];if(p.length){const y=r.filter(k=>!k.isBuiltin&&p.some(x=>(0,h.areSameExtensions)({id:x},k.identifier))),b=[];for(const k of y)b.push(...this.getAllPackExtensionsToUninstall(k,r,o));return[...y,...b]}return[]}getDependents(e,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(p=>(0,h.areSameExtensions)({id:p},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(e,r,o){return o.profileLocation&&(0,S.isApplicationScopedExtension)(e)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(e,r,o)}createUninstallExtensionTask(e,r){return r.profileLocation&&e.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(e,r)}};u=fe([te(0,P.IExtensionGalleryService),te(1,E.ITelemetryService),te(2,f.ILogService),te(3,m.IProductService),te(4,l.IUserDataProfilesService)],u),t.AbstractExtensionManagementService=u;function g(n){const e=Array.isArray(n)?n:[n];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=g;function a(n){if(n instanceof P.ExtensionManagementError)return n;const e=new P.ExtensionManagementError(n.message,P.ExtensionManagementErrorCode.Internal);return e.stack=n.stack,e}function s(n,e,{extensionData:r,duration:o,error:p,durationSinceUpdate:y}){const b=p?p instanceof P.ExtensionManagementError?p.code:P.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(e,{...r,success:!p,duration:o,errorcode:b,durationSinceUpdate:y})}t.reportTelemetry=s;class i{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>new Promise((r,o)=>{const p=e.onCancellationRequested(()=>{p.dispose(),o(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=i}),define(Z[48],ee([0,1,19,3,26,15,12,50,74,2,16,14,13,17,39,54,5,10,85,18,23,34,45,11,8,9,28,4,44,41,25,29]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u,g,a,s,i,n,e,r,o,p,y,b,k,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.toExtensionDescription=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0;var _;(function(ae){function N(B,M){if(B===M)return!0;const F=Object.keys(B),W=new Set;for(const q of Object.keys(M))W.add(q);if(F.length!==W.size)return!1;for(const q of F){if(B[q]!==M[q])return!1;W.delete(q)}return W.size===0}ae.equals=N})(_=t.Translations||(t.Translations={})),t.IExtensionsScannerService=(0,e.createDecorator)("IExtensionsScannerService");let G=class extends d.Disposable{constructor(N,B,M,F,W,q,Y,T,z,O,L){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=B,this.extensionsControlLocation=M,this.cacheLocation=F,this.userDataProfilesService=W,this.extensionsProfileScannerService=q,this.fileService=Y,this.logService=T,this.environmentService=z,this.productService=O,this.instantiationService=L,this._onDidChangeCache=this._register(new p.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,S.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,S.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N,B){const[M,F]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(B)]),W=await this.scanExtensionsUnderDevelopment(N,[...M,...F]);return this.dedupExtensions(M,F,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const B=[];B.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),B.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[M,F]=await Promise.all(B);return this.applyScanOptions([...M,...F],0,N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const B=await this.createExtensionScannerInput(N.profileLocation??this.userExtensionsLocation,!!N.profileLocation,1,!N.includeUninstalled,N.language);let F=await(N.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return F=await this.applyScanOptions(F,1,N,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment(N,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const M=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===D.Schemas.file).map(async F=>{const W=await this.createExtensionScannerInput(F,!1,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=B.find(T=>(0,a.areSameExtensions)(T.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,W)))}))).flat();return this.applyScanOptions(M,"development",N,!0)}return[]}async scanExistingExtension(N,B,M){const F=await this.createExtensionScannerInput(N,!1,B,!0,M.language),W=await this.extensionsScanner.scanExtension(F);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(N,B,M){const F=await this.createExtensionScannerInput(N,!1,B,!0,M.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(W,B,M,!0)}async scanMetadata(N){const B=(0,S.joinPath)(N,"package.json"),M=(await this.fileService.readFile(B)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(N,B){const M=(0,S.joinPath)(N,"package.json"),F=(await this.fileService.readFile(M)).value.toString(),W=JSON.parse(F);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.installedTimestamp=B.installedTimestamp||void 0,W.__metadata={...W.__metadata,...B},await this.fileService.writeFile((0,S.joinPath)(N,"package.json"),R.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(N,B,M,F){return M.includeAllVersions||(N=this.dedupExtensions(B===0?N:void 0,B===1?N:void 0,B==="development"?N:void 0,await this.getTargetPlatform(),F)),M.includeInvalid||(N=N.filter(W=>W.isValid)),N.sort((W,q)=>{const Y=P.basename(W.location.fsPath),T=P.basename(q.location.fsPath);return Y<T?-1:Y>T?1:0})}dedupExtensions(N,B,M,F,W){const q=(T,z,O)=>{if(T.isValid&&!z.isValid)return!1;if(T.isValid===z.isValid){if(W&&f.gt(T.manifest.version,z.manifest.version))return this.logService.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${T.location.path} with version ${T.manifest.version}`),!1;if(f.eq(T.manifest.version,z.manifest.version)){if(T.type===0)return this.logService.debug(`Skipping extension ${z.location.path} in favour of system extension ${T.location.path} with same version`),!1;if(T.targetPlatform===F)return this.logService.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${T.location.path} with ${z.location.path}.`):this.logService.debug(`Overwriting user extension ${T.location.path} with ${z.location.path}.`),!0},Y=new Map;return N?.forEach(T=>{const z=s.ExtensionIdentifier.toKey(T.identifier.id),O=Y.get(z);(!O||q(O,T,!1))&&Y.set(z,T)}),B?.forEach(T=>{const z=s.ExtensionIdentifier.toKey(T.identifier.id),O=Y.get(z);if(!O&&N&&T.type===0){this.logService.debug(`Skipping obsolete system extension ${T.location.path}.`);return}(!O||q(O,T,!1))&&Y.set(z,T)}),M?.forEach(T=>{const z=s.ExtensionIdentifier.toKey(T.identifier.id),O=Y.get(z);(!O||q(O,T,!0))&&Y.set(z,T),Y.set(z,T)}),[...Y.values()]}async scanDefaultSystemExtensions(N,B){this.logService.trace("Started scanning system extensions");const M=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B),W=await(N&&!M.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(N,B){const M=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!M?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=B?await this.getBuiltInExtensionControl():{},W=[],q=l.URI.file(P.normalize(P.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions")));for(const T of M){const z=F[T.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":W.push((0,S.joinPath)(q,T.name));break;default:W.push(l.URI.file(z));break}}const Y=await Promise.all(W.map(async T=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(T,!1,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,C.coalesce)(Y)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,B,M,F,W,q=!0){const Y=await this.getTranslations(W??h.language),T=await this.getMtime(N),z=B?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=z?await this.getMtime(z):void 0;return new Q(N,T,z,O,B,M,F,q,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Y)}async getMtime(N){try{const B=await this.fileService.stat(N);if(typeof B.mtime=="number")return B.mtime}catch{}}};G=fe([te(4,k.IUserDataProfilesService),te(5,b.IExtensionsProfileScannerService),te(6,n.IFileService),te(7,r.ILogService),te(8,g.IEnvironmentService),te(9,o.IProductService),te(10,e.IInstantiationService)],G),t.AbstractExtensionsScannerService=G;class Q{constructor(N,B,M,F,W,q,Y,T,z,O,L,U,V,H){this.location=N,this.mtime=B,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=F,this.profile=W,this.type=q,this.excludeObsolete=Y,this.validate=T,this.productVersion=z,this.productDate=O,this.productCommit=L,this.devMode=U,this.language=V,this.translations=H}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,B){return(0,S.isEqual)(N.location,B.location)&&N.mtime===B.mtime&&(0,S.isEqual)(N.applicationExtensionslocation,B.applicationExtensionslocation)&&N.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&N.profile===B.profile&&N.type===B.type&&N.excludeObsolete===B.excludeObsolete&&N.validate===B.validate&&N.productVersion===B.productVersion&&N.productDate===B.productDate&&N.productCommit===B.productCommit&&N.devMode===B.devMode&&N.language===B.language&&_.equals(N.translations,B.translations)}}let ne=class extends d.Disposable{constructor(N,B,M,F,W){super();this.obsoleteFile=N,this.extensionsProfileScannerService=B,this.uriIdentityService=M,this.fileService=F,this.logService=W}async scanExtensions(N){const B=N.profile?await this.scanExtensionsFromProfile(N):await this.scanExtensionsFromLocation(N);let M={};if(N.excludeObsolete&&N.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();M=JSON.parse(F)}catch{}return(0,E.isEmptyObject)(M)?B:B.filter(F=>!M[a.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(N){const B=await this.fileService.resolve(N.location);if(!B.children?.length)return[];const M=await Promise.all(B.children.map(async F=>{if(!F.isDirectory||N.type===1&&(0,S.basename)(F.resource).indexOf(".")===0)return null;const W=new Q(F.resource,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(W)}));return(0,C.coalesce)(M).sort((F,W)=>F.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(N){let B=await this.scanExtensionsFromProfileResource(N.location,()=>!0,N);if(N.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(N.location,N.applicationExtensionslocation)){B=B.filter(F=>!F.metadata?.isApplicationScoped);const M=await this.scanExtensionsFromProfileResource(N.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,N);B.push(...M)}return B}async scanExtensionsFromProfileResource(N,B,M){const F=await this.extensionsProfileScannerService.scanProfileExtensions(N);if(!F.length)return[];const W=await Promise.all(F.map(async q=>{if(B(q)){const Y=new Q(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Y,q.metadata)}return null}));return(0,C.coalesce)(W)}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,S.joinPath)(N.location,"package.json"))){const B=await this.scanExtension(N);return B?[B]:[]}else return await this.scanExtensions(N)}catch(B){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,A.getErrorMessage)(B)),[]}}async scanExtension(N,B){try{let M=await this.scanExtensionManifest(N.location);if(M){M.publisher||(M.publisher=s.UNDEFINED_PUBLISHER),B=B??M.__metadata,delete M.__metadata;const F=(0,a.getGalleryExtensionId)(M.publisher,M.name),W=B?.id?{id:F,uuid:B.id}:{id:F},q=B?.isSystem?0:N.type,Y=q===0||!!B?.isBuiltin;M=await this.translateManifest(N.location,M,Q.createNlsConfiguration(N));const T={type:q,identifier:W,manifest:M,location:N.location,isBuiltin:Y,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return N.validate?this.validate(T,N):T}}catch(M){N.type!==0&&this.logService.error(M)}return null}validate(N,B){let M=!0;const F=(0,i.validateExtensionManifest)(B.productVersion,B.productDate,B.location,N.manifest,N.isBuiltin);for(const[W,q]of F)W===m.default.Error&&(M=!1,this.logService.error(this.formatMessage(B.location,q)));return N.isValid=M,N.validations=F,N}async scanExtensionManifest(N){const B=(0,S.joinPath)(N,"package.json");let M;try{M=(await this.fileService.readFile(B)).value.toString()}catch(W){return(0,n.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(N,(0,u.localize)(0,null,B.path,W.message))),null}let F;try{F=JSON.parse(M)}catch{const q=[];(0,v.parse)(M,q);for(const Y of q)this.logService.error(this.formatMessage(N,(0,u.localize)(1,null,B.path,Y.offset,Y.length,(0,c.getParseErrorMessage)(Y.error))));return null}return(0,v.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(N,(0,u.localize)(2,null,B.path))),null):F}async translateManifest(N,B,M){const F=await this.getLocalizedMessages(N,B,M);if(F)try{const W=[],q=await this.resolveOriginalMessageBundle(F.default,W);if(W.length>0)return W.forEach(T=>{this.logService.error(this.formatMessage(N,(0,u.localize)(3,null,F.default?.path,(0,c.getParseErrorMessage)(T.error))))}),B;if((0,v.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(N,(0,u.localize)(4,null,F.default?.path))),B;const Y=F.values||Object.create(null);this.replaceNLStrings(M.pseudo,B,Y,q,N)}catch{}return B}async getLocalizedMessages(N,B,M){const F=(0,S.joinPath)(N,"package.nls.json"),W=(z,O)=>{O.forEach(L=>{this.logService.error(this.formatMessage(N,(0,u.localize)(5,null,z?.path,(0,c.getParseErrorMessage)(L.error))))})},q=z=>{this.logService.error(this.formatMessage(N,(0,u.localize)(6,null,z?.path)))},Y=`${B.publisher}.${B.name}`,T=M.translations[Y];if(T)try{const z=l.URI.file(T),O=(await this.fileService.readFile(z)).value.toString(),L=[],U=(0,v.parse)(O,L);return L.length>0?(W(z,L),{values:void 0,default:F}):(0,v.getNodeType)(U)!=="object"?(q(z),{values:void 0,default:F}):{values:U.contents?U.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let O;try{O=await this.findMessageBundles(N,M)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const L=(await this.fileService.readFile(O.localized)).value.toString(),U=[],V=(0,v.parse)(L,U);return U.length>0?(W(O.localized,U),{values:void 0,default:O.original}):(0,v.getNodeType)(V)!=="object"?(q(O.localized),{values:void 0,default:O.original}):{values:V,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(N,B){if(N)try{const M=(await this.fileService.readFile(N)).value.toString();return(0,v.parse)(M,B)}catch{return null}else return null}findMessageBundles(N,B){return new Promise((M,F)=>{const W=q=>{const Y=(0,S.joinPath)(N,`package.nls.${q}.json`);this.fileService.exists(Y).then(T=>{T&&M({localized:Y,original:(0,S.joinPath)(N,"package.nls.json")});const z=q.lastIndexOf("-");z===-1?M({localized:(0,S.joinPath)(N,"package.nls.json"),original:null}):(q=q.substring(0,z),W(q))})};if(B.devMode||B.pseudo||!B.language)return M({localized:(0,S.joinPath)(N,"package.nls.json"),original:null});W(B.language)})}replaceNLStrings(N,B,M,F,W){const q=(Y,T,z)=>{const O=Y[T];if((0,E.isString)(O)){const L=O,U=L.length;if(U>1&&L[0]==="%"&&L[U-1]==="%"){const V=L.substr(1,U-2);let H=M[V];H===void 0&&F&&(H=F[V]);let X=typeof H=="string"?H:H.message;if(X!==void 0)if(N&&(X="\uFF3B"+X.replace(/[aouei]/g,"$&$&")+"\uFF3D"),z&&F&&(T==="title"||T==="category")){const oe=F[V],le={value:X,original:typeof oe=="string"?oe:oe?.message};Y[T]=le}else Y[T]=X;else this.logService.warn(this.formatMessage(W,(0,u.localize)(7,null,V)))}}else if((0,E.isObject)(O))for(const L in O)O.hasOwnProperty(L)&&(L==="commands"?q(O,L,!0):q(O,L,z));else if(Array.isArray(O))for(let L=0;L<O.length;L++)q(O,L,z)};for(const Y in B)B.hasOwnProperty(Y)&&q(B,Y)}formatMessage(N,B){return`[${N.path}]: ${B}`}};ne=fe([te(1,b.IExtensionsProfileScannerService),te(2,x.IUriIdentityService),te(3,n.IFileService),te(4,r.ILogService)],ne);let ce=class extends ne{constructor(N,B,M,F,W,q){super(B,M,F,W,q);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new p.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const B=await this.readExtensionCache();if(this.input=N,B&&B.input&&Q.equals(B.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(F=>(F.location=l.URI.revive(F.location),F));const M=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:M}),M}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),B=JSON.parse(N.value.toString());return{result:B.result,input:(0,y.revive)(B.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(N)))}catch(B){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const B=N.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(M,B))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};ce=fe([te(2,b.IExtensionsProfileScannerService),te(3,x.IUriIdentityService),te(4,n.IFileService),te(5,r.ILogService)],ce);function re(ae,N){const B=(0,a.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:B,identifier:new s.ExtensionIdentifier(B),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:N,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}t.toExtensionDescription=re;class ge extends G{constructor(N,B,M,F,W,q,Y,T,z,O,L){super(N,B,(0,S.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(F,s.MANIFEST_CACHE_FOLDER),W,q,Y,T,z,O,L);this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const U=await this.fileService.readFile(l.URI.file(h.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}t.NativeExtensionsScannerService=ge}),define(Z[138],ee([0,1,57,3,31,4,2,16,14,20,9,25]),function($,t,C,I,w,R,A,v,c,d,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends A.Disposable{constructor(f,m){super();this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new I.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${E}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(f,m){const E=`vscode:${m}`;if(f.location.scheme===v.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[E]=="string"){const l=f.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${E} should be a node script`),null):{script:(0,c.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(f,m,E,l,u){return new Promise((g,a)=>{const s=this.start(f,m,E,u);let i;const n=e=>{i&&(clearTimeout(i),i=null),e?a(e):g(void 0)};s.on("error",e=>{n((0,w.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,r)=>{n(e?`post-${m} process exited with code ${e}`:void 0)}),l&&(i=setTimeout(()=>{i=null,s.kill(),a("timed out")},5e3))})}start(f,m,E,l){const u={silent:!0,execArgv:void 0},g=(0,C.fork)(f,[`--type=extension-post-${m}`,...E],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=R.Event.fromNodeEventEmitter(g.stdout,"data"),s=R.Event.fromNodeEventEmitter(g.stderr,"data");a(e=>this.logService.info(l.identifier.id,l.manifest.version,`post-${m}`,e)),s(e=>this.logService.error(l.identifier.id,l.manifest.version,`post-${m}`,e));const i=R.Event.any(R.Event.map(a,e=>({data:`%c${e}`,format:[""]})),R.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(i,(e,r)=>e?{data:e.data+r.data,format:[...e.format,...r.format]}:{data:r.data,format:r.format},100)(e=>{console.group(l.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,c.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=fe([te(0,P.IUserDataProfilesService),te(1,D.ILogService)],h),t.ExtensionsLifecycle=h}),define(Z[139],ee([0,1,10,18,41,48,11,8,9,28,25]),function($,t,C,I,w,R,A,v,c,d,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let P=class extends R.NativeExtensionsScannerService{constructor(S,f,m,E,l,u,g){super(C.URI.file(l.builtinExtensionsPath),C.URI.file(l.extensionsPath),l.userHome,C.URI.file(l.userDataPath),S,f,m,E,l,u,g)}};P=fe([te(0,D.IUserDataProfilesService),te(1,w.IExtensionsProfileScannerService),te(2,A.IFileService),te(3,c.ILogService),te(4,I.INativeEnvironmentService),te(5,d.IProductService),te(6,v.IInstantiationService)],P),t.ExtensionsScannerService=P}),define(Z[140],ee([0,1,3,4,2,110,5,79,8,25]),function($,t,C,I,w,R,A,v,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.isProfileUsingDefaultStorage=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P=t.WillSaveStateReason||(t.WillSaveStateReason={}));var h;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(h=t.StorageScope||(t.StorageScope={}));var S;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(S=t.StorageTarget||(t.StorageTarget={}));class f extends w.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,a){if(a===D){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:a,target:this.getKeyTargets(g)[a]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,a,s){return this.getStorage(a)?.get(g,s)}getBoolean(g,a,s){return this.getStorage(a)?.getBoolean(g,s)}getNumber(g,a,s){return this.getStorage(a)?.getNumber(g,s)}store(g,a,s,i){if((0,A.isUndefinedOrNull)(a)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,i),this.getStorage(s)?.set(g,a)})}remove(g,a){this.withPausedEmitters(()=>{this.updateKeyTarget(g,a,void 0),this.getStorage(a)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,a){const s=[],i=this.getKeyTargets(g);for(const n of Object.keys(i))i[n]===a&&s.push(n);return s}updateKeyTarget(g,a,s){const i=this.getKeyTargets(a);typeof s=="number"?i[g]!==s&&(i[g]=s,this.getStorage(a)?.set(D,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.getStorage(a)?.set(D,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const a=this.get(D,g);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(t.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const a=this.getStorage(-1),s=this.getStorage(0),i=this.getStorage(1);switch(g){case P.NONE:await C.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await C.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,a=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(g,a,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,a){return this.emitWillSaveState(P.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,a):this.switchToWorkspace(g,a)}canSwitchProfile(g,a){return!(g.id===a.id||m(a)&&m(g))}switchData(g,a,s,i){this.withPausedEmitters(()=>{if(i)for(const[n,e]of g)a.set(n,e);else{const n=new Set;for(const[e,r]of g)n.add(e),a.get(e)!==r&&this.emitDidChangeValue(s,e);for(const[e]of a.items)n.has(e)||this.emitDidChangeValue(s,e)}})}}t.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}t.isProfileUsingDefaultStorage=m;class E extends f{constructor(){super();this.applicationStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.profileStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}t.InMemoryStorageService=E;async function l(u,g,a,s,i,n){const e=G=>{try{return JSON.parse(G)}catch{return G}},r=new Map,o=new Map;u.forEach((G,Q)=>{r.set(Q,G),o.set(Q,e(G))});const p=new Map,y=new Map;g.forEach((G,Q)=>{p.set(Q,G),y.set(Q,e(G))});const b=new Map,k=new Map;a.forEach((G,Q)=>{b.set(Q,G),k.set(Q,e(G))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const x=[];if(r.forEach((G,Q)=>{x.push({key:Q,value:G})}),console.table(x),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const G=[];p.forEach((Q,ne)=>{G.push({key:ne,value:Q})}),console.table(G),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${n})`);const _=[];b.forEach((G,Q)=>{_.push({key:Q,value:G})}),console.table(_),console.groupEnd(),console.log(k)}t.logStorage=l}),define(Z[141],ee([0,1,19,24,12,13,32,5,10,21,18,22,23,45,11,9,28,47,128,140,35]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const s=R.isWeb?"web":(0,P.getTargetPlatform)(R.platform,A.arch);var i;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...O){return String(O.reduce((L,U)=>L|U,0))}var e;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(e||(e={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class b{constructor(L=y){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(L,U=this.state.pageSize){return new b({...this.state,pageNumber:L,pageSize:U})}withFilter(L,...U){const V=[...this.state.criteria,...U.length?U.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new b({...this.state,criteria:V})}withSortBy(L){return new b({...this.state,sortBy:L})}withSortOrder(L){return new b({...this.state,sortOrder:L})}withFlags(...L){return new b({...this.state,flags:L.reduce((U,V)=>U|V,0)})}withAssetTypes(...L){return new b({...this.state,assetTypes:L})}withSource(L){return new b({...this.state,source:L})}get raw(){const{criteria:L,pageNumber:U,pageSize:V,sortBy:H,sortOrder:X,flags:oe,assetTypes:le}=this.state;return{filters:[{criteria:L,pageNumber:U,pageSize:V,sortBy:H,sortOrder:X}],assetTypes:le,flags:oe}}get searchText(){const L=this.state.criteria.filter(U=>U.filterType===e.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(O,L){const U=(O||[]).filter(V=>V.statisticName===L)[0];return U?U.value:0}function x(O){const L="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(V=>V.assetType.indexOf(L)===0).reduce((V,H)=>{const X=Q(O,H.assetType);return X&&V.push([H.assetType.substring(L.length),X]),V},[])}function _(O){if(O.properties){const L=O.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=L.filter(H=>U.test(H.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return Q(O,r.Repository)}function G(O){return{uri:`${O.fallbackAssetUri}/${r.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${r.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function Q(O,L){return O.files.filter(V=>V.assetType===L)[0]?{uri:`${O.assetUri}/${L}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${L}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ne(O,L){const U=O.properties?O.properties.filter(H=>H.key===L):[],V=U.length>0&&U[0].value;return V?V.split(",").map(H=>(0,h.adoptToGalleryExtensionId)(H)):[]}function ce(O){const L=O.properties?O.properties.filter(U=>U.key===o.Engine):[];return L.length>0&&L[0].value||""}function re(O){const L=O.properties?O.properties.filter(U=>U.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function ge(O){const L=O.properties?O.properties.filter(V=>V.key===o.LocalizedLanguages):[],U=L.length>0&&L[0].value||"";return U?U.split(","):[]}function ae(O){return O.properties?.find(L=>L.key===o.SponsorLink)?.value}function N(O){return O.indexOf("preview")!==-1}function B(O){return O.targetPlatform?(0,P.toTargetPlatform)(O.targetPlatform):"undefined"}function M(O){const L=(0,C.distinct)(O.versions.map(B)),U=!!O.tags?.includes(P.WEB_EXTENSION_TAG),V=L.indexOf("web");return U?V===-1&&L.push("web"):V!==-1&&L.splice(V,1),L}function F(O,L){const U=(0,P.getFallbackTargetPlarforms)(L);for(let V=0;V<O.length;V++){const H=O[V];if(H.version===O[V-1]?.version){let X=V;const oe=B(H);if(oe===L)for(;X>0&&O[X-1].version===H.version;)X--;else if(U.includes(oe))for(;X>0&&O[X-1].version===H.version&&B(O[X-1])!==L;)X--;X!==V&&(O.splice(V,1),O.splice(X,0,H))}}return O}t.sortExtensionVersions=F;function W(O,L,U){O.telemetryData={index:L,querySource:U}}function q(O,L,U){const V=O.versions[0],H={manifest:Q(L,r.Manifest),readme:Q(L,r.Details),changelog:Q(L,r.Changelog),license:Q(L,r.License),repository:_(L),download:G(L),icon:Q(L,r.Icon),coreTranslations:x(L)};return{identifier:{id:(0,h.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:L.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(V),description:O.shortDescription||"",installCount:k(O.statistics,"install"),rating:k(O.statistics,"averagerating"),ratingCount:k(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ne(L,o.Dependency),extensionPack:ne(L,o.ExtensionPack),engine:ce(L),localizedLanguages:ge(L),targetPlatform:B(L),isPreReleaseVersion:re(L)},hasPreReleaseVersion:re(V),hasReleaseVersion:!0,preview:N(O.flags)}}let Y=class{constructor(L,U,V,H,X,oe,le,pe){this.requestService=U,this.logService=V,this.environmentService=H,this.telemetryService=X,this.fileService=oe,this.productService=le,this.configurationService=pe;const ve=le.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,L,this.telemetryService)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,U,V){const H=I.CancellationToken.isCancellationToken(U)?{}:U,X=I.CancellationToken.isCancellationToken(U)?U:V,oe=[],le=[],pe=[],ve=[];let ie=!0;for(const de of L){de.uuid?le.push(de.uuid):oe.push(de.id);const Se=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:Se}),de.version&&ve.push({id:de.id,uuid:de.uuid,version:de.version}),ie=ie&&!!de.hasPreRelease&&!Se}if(!le.length&&!oe.length)return[];let se=new b().withPage(1,L.length);le.length&&(se=se.withFilter(e.ExtensionId,...le)),oe.length&&(se=se.withFilter(e.ExtensionName,...oe)),(H.queryAllVersions||ie)&&(se=se.withFlags(se.flags,i.IncludeVersions)),H.source&&(se=se.withSource(H.source));const{extensions:he}=await this.queryGalleryExtensions(se,{targetPlatform:H.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!H.compatible},X);return H.source&&he.forEach((de,Se)=>W(de,Se,H.source)),he}async getCompatibleExtension(L,U,V){if((0,P.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(L,U,V))return L;const H=new b().withFlags(i.IncludeVersions).withPage(1,1).withFilter(e.ExtensionId,L.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:V,compatible:!0,includePreRelease:U},I.CancellationToken.None);return X[0]||null}async isExtensionCompatible(L,U,V){if(!(0,P.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,V)||!U&&L.properties.isPreReleaseVersion)return!1;let H=L.properties.engine;if(!H){const X=await this.getManifest(L,I.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,S.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(L,U,V,H,X){if(!(0,P.isTargetPlatformCompatible)(B(L),H,X)||U!=="any"&&re(L)!==(U==="prerelease"))return!1;if(V)try{const oe=await this.getEngine(L);if(!(0,S.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${L.version}.`,(0,w.getErrorMessage)(oe)),!1}return!0}async query(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=L.text||"";const H=L.pageSize??50;let X=new b().withPage(1,H);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Category,he||se),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Tag,he||se),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(e.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),X=X.withFilter(e.SearchText,V)),X=X.withSortBy(0)):L.ids?X=X.withFilter(e.ExtensionId,...L.ids):L.names?X=X.withFilter(e.ExtensionName,...L.names):X=X.withSortBy(4),typeof L.sortBy=="number"&&(X=X.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(X=X.withSortOrder(L.sortOrder)),L.source&&(X=X.withSource(L.source));const oe=async(ie,se)=>{const{extensions:he,total:de}=await this.queryGalleryExtensions(ie,{targetPlatform:s,compatible:!1,includePreRelease:!!L.includePreRelease},se);return he.forEach((Se,Le)=>W(Se,(ie.pageNumber-1)*ie.pageSize+Le,L.source)),{extensions:he,total:de}},{extensions:le,total:pe}=await oe(X,U),ve=async(ie,se)=>{if(se.isCancellationRequested)throw new w.CancellationError;const{extensions:he}=await oe(X.withPage(ie+1),se);return he};return{firstPage:le,total:pe,pageSize:X.pageSize,getPage:ve}}async queryGalleryExtensions(L,U,V){const H=L.flags;!!(L.flags&i.IncludeLatestVersionOnly)&&!!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(L.flags&i.IncludeLatestVersionOnly)&&!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags,i.IncludeLatestVersionOnly)),U.versions?.length&&(L=L.withFlags(L.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),L=L.withFlags(L.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:X,total:oe}=await this.queryRawGalleryExtensions(L,V);if(!(L.flags&i.IncludeLatestVersionOnly)){const ie=[];for(const se of X){const he=await this.toGalleryExtensionWithCriteria(se,U);he&&ie.push(he)}return{extensions:ie,total:oe}}const pe=[],ve=new Map;for(let ie=0;ie<X.length;ie++){const se=X[ie],he={id:(0,h.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},de=(0,v.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Le=>(0,h.areSameExtensions)(Le,he))?.includePreRelease;if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(M(se),U.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(se,U);!Se||Se.properties.isPreReleaseVersion&&(!de||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?ve.set(se.extensionId,ie):pe.push([ie,Se])}if(ve.size){const ie=new Date().getTime(),se=new b().withFlags(H&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(e.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(se,U,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ie,count:ve.size});for(const de of he){const Se=ve.get(de.identifier.uuid);pe.push([Se,de])}}return{extensions:pe.sort((ie,se)=>ie[0]-se[0]).map(([,ie])=>ie),total:oe}}async toGalleryExtensionWithCriteria(L,U){const V={id:(0,h.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},H=U.versions?.find(pe=>(0,h.areSameExtensions)(pe,V))?.version,X=(0,v.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,V))?.includePreRelease,oe=M(L),le=F(L.versions,U.targetPlatform);if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(oe,U.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const ve=le[pe];if(!(H&&ve.version!==H)){if(await this.isValidVersion(ve,X?"any":"release",U.compatible,oe,U.targetPlatform))return q(L,ve,oe);if(H&&ve.version===H)return null}}return H||U.compatible?null:q(L,L.versions[0],oe)}async queryRawGalleryExtensions(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,i.ExcludeNonValidated).withFilter(e.Target,"Microsoft.VisualStudio.Code").withFilter(e.ExcludeWithFlags,n(i.Unpublished));const V=await this.commonHeadersPromise,H=JSON.stringify(L.raw),X={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},oe=new Date().getTime();let le,pe,ve=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ve};const ie=await(0,l.asJson)(le);if(ie){const se=ie.results[0],he=se.extensions,de=se.resultMetadata&&se.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=de&&de.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(ie){throw pe=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-oe,success:!!le&&(0,l.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(L,U,V,H){if(!this.isEnabled())return;const X=R.isWeb?this.api(`/itemName/${L}.${U}/version/${V}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${L}/extensions/${U}/${V}/stats?statType=${H}`),oe=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:X,headers:pe},I.CancellationToken.None)}catch{}}async download(L,U,V){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,h.getGalleryExtensionTelemetryData)(L),X=new Date().getTime(),oe=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:ie}),le=V===2?"install":V===3?"update":"",pe=le?{uri:`${L.assets.download.uri}${c.URI.parse(L.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${L.assets.download.fallbackUri}${c.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:L.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(U,ve.stream),oe(new Date().getTime()-X)}async getReadme(L,U){if(L.assets.readme){const V=await this.getAsset(L.assets.readme,{},U);return await(0,l.asTextOrError)(V)||""}return""}async getManifest(L,U){if(L.assets.manifest){const V=await this.getAsset(L.assets.manifest,{},U),H=await(0,l.asTextOrError)(V);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(L,U){const V=Q(L,r.Manifest);if(!V)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(V,{headers:H});return await(0,l.asJson)(X)}async getCoreTranslation(L,U){const V=L.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(V){const H=await this.getAsset(V[1]),X=await(0,l.asTextOrError)(H);return X?JSON.parse(X):null}return null}async getChangelog(L,U){if(L.assets.changelog){const V=await this.getAsset(L.assets.changelog,{},U);return await(0,l.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(L,U,V){let H=new b().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(e.ExtensionId,L.identifier.uuid):H=H.withFilter(e.ExtensionName,L.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,I.CancellationToken.None);if(!X.length)return[];const oe=M(X[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(oe,V))return[];const le=[];await Promise.all(X[0].versions.map(async ie=>{try{await this.isValidVersion(ie,U?"any":"release",!0,oe,V)&&le.push(ie)}catch{}}));const pe=[],ve=new Set;for(const ie of F(le,V))ve.has(ie.version)||(ve.add(ie.version),pe.push({version:ie.version,date:ie.lastUpdated,isPreReleaseVersion:re(ie)}));return pe}async getAsset(L,U={},V=I.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},oe={...H,...U.headers||{}};U={...U,...X,headers:oe};const le=L.uri,pe=L.fallbackUri,ve={...U,url:le};try{const ie=await this.requestService.request(ve,V);if(ie.res.statusCode===200)return ie;const se=await(0,l.asTextOrError)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${se}`)}catch(ie){if((0,w.isCancellationError)(ie))throw ie;const se=(0,w.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:se});const he={...U,url:pe};return this.requestService.request(he,V)}}async getEngine(L){let U=ce(L);if(!U){const V=await this.getManifestFromRawExtensionVersion(L,I.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(L),V=[],H={};if(U){for(const X of U.malicious)V.push({id:X});if(U.migrateToPreRelease)for(const[X,oe]of Object.entries(U.migrateToPreRelease))(!oe.engine||(0,S.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[X,oe]of Object.entries(U.deprecated))oe&&(H[X.toLowerCase()]=(0,v.isBoolean)(oe)?{}:oe)}return{malicious:V,deprecated:H}}};Y=fe([te(1,l.IRequestService),te(2,m.ILogService),te(3,D.IEnvironmentService),te(4,a.ITelemetryService),te(5,f.IFileService),te(6,E.IProductService),te(7,d.IConfigurationService)],Y);let T=class extends Y{constructor(L,U,V,H,X,oe,le,pe){super(L,U,V,H,X,oe,le,pe)}};T=fe([te(0,g.IStorageService),te(1,l.IRequestService),te(2,m.ILogService),te(3,D.IEnvironmentService),te(4,a.ITelemetryService),te(5,f.IFileService),te(6,E.IProductService),te(7,d.IConfigurationService)],T),t.ExtensionGalleryService=T;let z=class extends Y{constructor(L,U,V,H,X,oe,le){super(void 0,L,U,V,H,X,oe,le)}};z=fe([te(0,l.IRequestService),te(1,m.ILogService),te(2,D.IEnvironmentService),te(3,a.ITelemetryService),te(4,f.IFileService),te(5,E.IProductService),te(6,d.IConfigurationService)],z),t.ExtensionGalleryServiceWithNoStorageService=z}),define(Z[142],ee([0,1,44,18,11,9,65,29,25]),function($,t,C,I,w,R,A,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=void 0;let d=class Ve extends c.UserDataProfilesService{constructor(P,h,S,f,m){super(S,f,h,m);this.stateService=P}getStoredProfiles(){return(0,C.revive)(this.stateService.getItem(Ve.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,C.revive)(this.stateService.getItem(Ve.PROFILE_ASSOCIATIONS_KEY,{}))}};d=fe([te(0,A.IStateService),te(1,v.IUriIdentityService),te(2,I.IEnvironmentService),te(3,w.IFileService),te(4,R.ILogService)],d),t.UserDataProfilesService=d}),define(Z[143],ee([0,1,37,3,155,2]),function($,t,C,I,w,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;class A extends C.AbstractPolicyService{constructor(c){super();this.productName=c,this.throttler=new I.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(c){await this.throttler.queue(()=>new Promise((d,D)=>{try{this.watcher.value=(0,w.createWatcher)(this.productName,c,P=>{for(const h in P){const S=P[h];S===void 0?this.policies.delete(h):this.policies.set(h,S)}this._onDidChange.fire(Object.keys(P)),d()})}catch(P){D(P)}}))}}t.NativePolicyService=A}),define(Z[67],ee([0,1,112,3,14,5,20,80,156,157]),function($,t,C,I,w,R,A,v,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class D extends Error{constructor(i,n){let e=n.message;switch(i){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=i,this.cause=n}}t.ExtractError=D;function P(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,e)=>n+e,i&61440)}function h(s){if(s instanceof D)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new D(i,s)}function S(s,i,n,e,r,o){const p=w.dirname(i),y=w.join(e,p);if(!y.startsWith(e))return Promise.reject(new Error(v.localize(0,null,i)));const b=w.join(e,i);let k;return o.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(A.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((x,_)=>{if(!o.isCancellationRequested)try{k=(0,C.createWriteStream)(b,{mode:n}),k.once("close",()=>x()),k.once("error",_),s.once("error",_),s.pipe(k)}catch(G){_(G)}}))}function f(s,i,n,e){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((p,y)=>{const b=new I.Sequencer,k=x=>{x.isCancellationRequested||(o++,s.readEntry())};s.once("error",y),s.once("close",()=>r.then(()=>{e.isCancellationRequested||s.entryCount===o?p():y(new D("Incomplete",new Error(v.localize(1,null,o,s.entryCount))))},y)),s.readEntry(),s.on("entry",x=>{if(e.isCancellationRequested)return;if(!n.sourcePathRegex.test(x.fileName)){k(e);return}const _=x.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(_)){const ne=w.join(i,_);r=(0,I.createCancelablePromise)(ce=>A.Promises.mkdir(ne,{recursive:!0}).then(()=>k(ce)).then(void 0,y));return}const G=E(s,x),Q=P(x);r=(0,I.createCancelablePromise)(ne=>b.queue(()=>G.then(ce=>S(ce,_,Q,i,n,ne).then(()=>k(ne)))).then(null,y))})})}function m(s,i=!1){return new Promise((n,e)=>{(0,c.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?e(h(r)):n((0,R.assertIsDefined)(o))})})}function E(s,i){return new Promise((n,e)=>{s.openReadStream(i,(r,o)=>{r?e(h(r)):n((0,R.assertIsDefined)(o))})})}function l(s,i){return new Promise((n,e)=>{const r=new d.ZipFile;i.forEach(p=>{p.contents?r.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&r.addFile(p.localPath,p.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>n(s))})}t.zip=l;function u(s,i,n={},e){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=m(s,!0);return n.overwrite&&(o=o.then(p=>A.Promises.rm(i).then(()=>p))),o.then(p=>f(p,i,{sourcePathRegex:r},e))}t.extract=u;function g(s,i){return m(s).then(n=>new Promise((e,r)=>{n.on("entry",o=>{o.fileName===i&&E(n,o).then(p=>e(p),p=>r(p))}),n.once("close",()=>r(new Error(v.localize(2,null,i))))}))}function a(s,i){return g(s,i).then(n=>new Promise((e,r)=>{const o=[];n.once("error",r),n.on("data",p=>o.push(p)),n.on("end",()=>e(Buffer.concat(o)))}))}t.buffer=a}),define(Z[144],ee([0,1,67,87]),function($,t,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(R){return(0,C.buffer)(R,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}t.getManifest=w}),define(Z[145],ee([0,1,3,31,12,2,16,14,13,17,39,5,10,30,20,67,86,58,18,137,22,23,41,48,120,138,144,121,134,34,45,11,8,9,28,35,29,25]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u,g,a,s,i,n,e,r,o,p,y,b,k,x,_,G,Q,ne,ce,re){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(a.IServerExtensionManagementService);let ge=class extends g.AbstractExtensionManagementService{constructor(T,z,O,L,U,V,H,X,oe,le,pe,ve){super(T,z,O,le,ve);this.extensionsScannerService=U,this.extensionsProfileScannerService=V,this.downloadService=H,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const ie=this._register(X.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(ae,he=>ie.postUninstall(he))),this.manifestCache=this._register(new p.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(X.createInstance(e.ExtensionsDownloader));const se=this._register(new y.ExtensionsWatcher(this,oe,L,O,pe));this._register(se.onDidChangeExtensionsByAnotherSource(({added:he,removed:de})=>{he.length&&this._onDidInstallExtensions.fire(he.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),de.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const z=await this.collectFiles(T),O=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)()).fsPath,z);return h.URI.file(O)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:z,cleanup:O}=await this.downloadVsix(T),L=v.resolve(z.fsPath);try{return await(0,o.getManifest)(L)}finally{await O()}}getInstalled(T,z){return this.extensionsScanner.scanExtensions(T??null,z)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(T,z={}){this.logService.trace("ExtensionManagementService#install",T.toString());const{location:O,cleanup:L}=await this.downloadVsix(T);try{const U=await(0,o.getManifest)(v.resolve(O.fsPath));if(U.engines&&U.engines.vscode&&!(0,k.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,s.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,O,z)}finally{await L()}}getMetadata(T){return this.extensionsScannerService.scanMetadata(T.location)}async updateMetadata(T,z){this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const O={...z};return z.isPreReleaseVersion&&(O.preRelease=!0),T=await this.extensionsScanner.updateMetadata(T,O),this.manifestCache.invalidate(),T}async updateExtensionScope(T,z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.updateMetadata(T,{isMachineScoped:z}),this.manifestCache.invalidate(),T}removeUninstalledExtensions(T){return this.extensionsScanner.cleanUp(T)}async downloadVsix(T){if(T.scheme===A.Schemas.file)return{location:T,async cleanup(){}};this.logService.trace("Downloading extension from",T.toString());const z=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)());return await this.downloadService.download(T,z),this.logService.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.fileService.del(z)}catch(L){this.logService.error(L)}}}}doCreateInstallExtensionTask(T,z,O){let L;if(h.URI.isUri(z))L=new M(T,z,O,this.galleryService,this.extensionsScanner,this.logService);else{const U=s.ExtensionKey.create(z).toString();L=this.installGalleryExtensionsTasks.get(U),L||(this.installGalleryExtensionsTasks.set(U,L=new B(T,z,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),L.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(U)))}return O.profileLocation?new F(L,O.profileLocation,this.extensionsProfileScannerService):L}doCreateUninstallExtensionTask(T,z){return z.profileLocation?new q(T,z.profileLocation,this.extensionsProfileScannerService):new W(T,z,this.extensionsScanner)}async collectFiles(T){const z=async L=>{let U=await f.Promises.readdir(L);U=U.map(X=>v.join(L,X));const V=await Promise.all(U.map(X=>f.Promises.stat(X)));let H=Promise.resolve([]);return V.forEach((X,oe)=>{const le=U[oe];X.isFile()&&(H=H.then(pe=>[...pe,le])),X.isDirectory()&&(H=H.then(pe=>z(le).then(ve=>[...pe,...ve])))}),H};return(await z(T.location.fsPath)).map(L=>({path:`extension/${v.relative(T.location.fsPath,L)}`,localPath:L}))}};ge=fe([te(0,a.IExtensionGalleryService),te(1,ne.ITelemetryService),te(2,G.ILogService),te(3,u.INativeEnvironmentService),te(4,n.IExtensionsScannerService),te(5,i.IExtensionsProfileScannerService),te(6,l.IDownloadService),te(7,_.IInstantiationService),te(8,x.IFileService),te(9,Q.IProductService),te(10,ce.IUriIdentityService),te(11,re.IUserDataProfilesService)],ge),t.ExtensionManagementService=ge;let ae=class extends R.Disposable{constructor(T,z,O,L){super();this.beforeRemovingExtension=T,this.fileService=z,this.extensionsScannerService=O,this.logService=L,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(T){await this.removeUninstalledExtensions(),T&&await this.removeOutdatedExtensions()}async scanExtensions(T,z){const O={includeInvalid:!0,profileLocation:z};let L=[];return T===null||T===0?L.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O)):T===1&&L.push(...await this.extensionsScannerService.scanUserExtensions(O)),L=T!==null?L.filter(U=>U.type===T):L,Promise.all(L.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(T){const z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(z.map(O=>this.toLocalExtension(O)))}async extractUserExtension(T,z,O,L){const U=T.toString(),V=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,S.generateUuid)()}`),H=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await f.Promises.rm(H)}catch{throw new a.ExtensionManagementError(E.localize(1,null,H,T.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(T,z,V,L),O={...O,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(h.URI.file(V),O);try{await this.rename(T,V,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(X){try{await f.Promises.rm(V)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(X)}. Deleted from extracted location`,V),X}return this.scanLocalExtension(h.URI.file(H),1)}async updateMetadata(T,z){return await this.extensionsScannerService.updateMetadata(T.location,z),this.scanLocalExtension(T.location,T.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...T){const z=T.map(O=>s.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{z.forEach(L=>O[L.toString()]=!0)})}async setInstalled(T){await this.withUninstalledExtensions(L=>delete L[T.toString()]);const O=(await this.scanUserExtensions(!0)).find(L=>s.ExtensionKey.create(L).equals(T))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(T,z){this.logService.trace(`Deleting ${z} extension from disk`,T.identifier.id,T.location.fsPath),await f.Promises.rm(T.location.fsPath),this.logService.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.withUninstalledExtensions(z=>delete z[s.ExtensionKey.create(T).toString()])}async withUninstalledExtensions(T){return this.uninstalledFileLimiter.queue(async()=>{let z;try{z=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(L){if(L.code!=="ENOENT")throw L}let O={};if(z)try{O=JSON.parse(z)}catch{}return T&&(T(O),Object.keys(O).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await f.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(T,z,O,L){this.logService.trace(`Started extracting the extension from ${z} to ${O}`);try{await f.Promises.rm(O)}catch(U){throw new a.ExtensionManagementError(this.joinErrors(U).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(z,O,{sourcePath:"extension",overwrite:!0},L),this.logService.info(`Extracted extension to ${O}:`,T.id)}catch(U){try{await f.Promises.rm(O)}catch{}let V=a.ExtensionManagementErrorCode.Extract;throw U instanceof m.ExtractError&&(U.type==="CorruptZip"?V=a.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(V=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(U.message,V)}}async rename(T,z,O,L){try{await f.Promises.rename(z,O)}catch(U){if(c.isWindows&&U&&U.code==="EPERM"&&Date.now()<L)return this.logService.info(`Failed renaming ${z} to ${O} with 'EPERM' error. Trying again...`,T.id),this.rename(T,z,O,L);throw new a.ExtensionManagementError(U.message||E.localize(2,null,z,O),U.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(T,z){const O=await this.extensionsScannerService.scanExistingExtension(T,z,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(E.localize(3,null,T.path))}async toLocalExtension(T){const z=await this.fileService.resolve(T.location);let O,L;return z.children&&(O=z.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,L=z.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:O,changelogUrl:L,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async removeUninstalledExtensions(){const T=await this.getUninstalledExtensions(),z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const V of z)T[s.ExtensionKey.create(V).toString()]||O.add(V.identifier.id.toLowerCase());const L=(0,s.groupByExtension)(z,V=>V.identifier);await C.Promises.settled(L.map(async V=>{const H=V.sort((X,oe)=>D.rcompare(X.manifest.version,oe.manifest.version))[0];O.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const U=z.filter(V=>T[s.ExtensionKey.create(V).toString()]);await C.Promises.settled(U.map(V=>this.removeUninstalledExtension(V)))}async removeOutdatedExtensions(){const T=await this.extensionsScannerService.scanSystemExtensions({}),z=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],L=await this.extensionsScannerService.getTargetPlatform(),U=(0,s.groupByExtension)(z,V=>V.identifier);for(const V of U)if(V.length>1&&O.push(...V.sort((H,X)=>{const oe=D.rcompare(H.manifest.version,X.manifest.version);return oe!==0?oe:H.targetPlatform===L?-1:1}).slice(1)),V[0].type===0){const H=T.find(X=>(0,s.areSameExtensions)(X.identifier,V[0].identifier));(!H||D.gte(H.manifest.version,V[0].manifest.version))&&O.push(V[0])}await C.Promises.settled(O.map(V=>this.removeExtension(V,"outdated")))}joinErrors(T){const z=Array.isArray(T)?T:[T];return z.length===1?z[0]instanceof Error?z[0]:new Error(z[0]):z.reduce((O,L)=>new Error(`${O.message}${O.message?",":""}${L instanceof Error?L.message:L}`),new Error(""))}};ae=fe([te(1,x.IFileService),te(2,n.IExtensionsScannerService),te(3,G.ILogService)],ae);class N extends g.AbstractExtensionTask{constructor(T,z,O,L,U){super();this.identifier=T,this.source=z,this.options=O,this.extensionsScanner=L,this.logService=U,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(T,z){try{const O=await this.unsetUninstalledAndGetLocal(T.key);if(O)return T.metadata?this.extensionsScanner.updateMetadata(O,T.metadata):O}catch{throw c.isMacintosh?new a.ExtensionManagementError(E.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(E.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(T,z)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const O=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),O}async isUninstalled(T){return!!(await this.extensionsScanner.getUninstalledExtensions())[T.toString()]}async extract({zipPath:T,key:z,metadata:O},L){const U=await this.extensionsScanner.extractUserExtension(z,T,O,L);return this.logService.info("Extracting completed.",z.id),U}}class B extends N{constructor(T,z,O,L,U,V){super(z.identifier,z,O,U,V);this.manifest=T,this.gallery=z,this.extensionsDownloader=L}async doRun(T){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(V=>(0,s.areSameExtensions)(V.identifier,this.gallery.identifier));O&&(this._operation=3);const L={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,b.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,L),metadata:L};const U=await this.downloadExtension(this.gallery,this._operation);try{const V=await this.installExtension({zipPath:U,key:s.ExtensionKey.create(this.gallery),metadata:L},T);return O&&!this.options.profileLocation&&(O.targetPlatform!==V.targetPlatform||D.neq(O.manifest.version,V.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:V,metadata:L}}catch(V){throw await this.deleteDownloadedVSIX(U),V}}async deleteDownloadedVSIX(T){try{await this.extensionsDownloader.delete(h.URI.file(T))}catch(z){this.logService.warn("Error while deleting the downloaded vsix",T.toString(),(0,w.getErrorMessage)(z))}}async downloadExtension(T,z){let O;try{this.logService.trace("Started downloading extension:",T.identifier.id),O=(await this.extensionsDownloader.downloadExtension(T,z)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,O)}catch(L){throw new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(O),O}catch(L){throw await this.deleteDownloadedVSIX(O),new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Invalid)}}}class M extends N{constructor(T,z,O,L,U,V){super({id:(0,s.getGalleryExtensionId)(T.publisher,T.name)},z,O,U,V);this.manifest=T,this.location=z,this.galleryService=L}async doRun(T){const z=new s.ExtensionKey(this.identifier,this.manifest.version),L=(await this.extensionsScanner.scanExtensions(1,void 0)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,T);if(U.isApplicationScoped=(0,b.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||L?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||L?.isBuiltin,L)if(this._operation=3,z.equals(new s.ExtensionKey(L.identifier,L.manifest.version)))try{await this.extensionsScanner.removeExtension(L,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&D.gt(L.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(L);else{const H=await this.unsetUninstalledAndGetLocal(z);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:v.resolve(this.location.fsPath),key:z,metadata:U},T),metadata:U}}async getMetadata(T,z,O){try{let[L]=await this.galleryService.getExtensions([{id:T,version:z}],O);if(L||([L]=await this.galleryService.getExtensions([{id:T}],O)),L)return{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(T,z,O){this.task=T,this.profileLocation=z,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const T=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[T.local,T.metadata]],this.profileLocation),T}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class W extends g.AbstractExtensionTask{constructor(T,z,O){super();this.extension=T,this.options=z,this.extensionsScanner=O}async doRun(T){const z=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const L=s.ExtensionKey.create(this.extension);z.push(...O.filter(U=>L.equals(s.ExtensionKey.create(U))))}else z.push(...O.filter(L=>(0,s.areSameExtensions)(L.identifier,this.extension.identifier)));if(!z.length)throw new Error(E.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...z),this.options.remove)for(const L of z)try{T.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(L)}catch(U){throw new Error(E.localize(9,null,(0,I.toErrorMessage)(U)))}}}class q extends g.AbstractExtensionTask{constructor(T,z,O){super();this.extension=T,this.profileLocation=z,this.extensionsProfileScannerService=O}async doRun(T){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Z[146],ee([0,1,125,3,15,12,2,5,21,18,126,9,124,158]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends A.Disposable{constructor(E,l,u){super();this.environmentService=l,this.logService=u,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,l){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:u,strictSSL:g}=this;let a;try{a=await(0,D.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...a},i=E.agent?E.agent:await(0,h.getProxyAgent)(E.url||"",s,{proxyUrl:u,strictSSL:g});E.agent=i,E.strictSSL=g,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(E,l);return this.logService.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",E.url,n),n}}async getNodeRequest(E){return((0,C.parse)(E.url).protocol==="https:"?await new Promise((g,a)=>{$(["https"],g,a)}):await new Promise((g,a)=>{$(["http"],g,a)})).request}_request(E,l){return I.Promises.withAsyncBody(async(u,g)=>{const a=(0,C.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),i={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,v.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(i.auth=E.user+":"+E.password);const n=s(i,e=>{const r=(0,v.isNumber)(E.followRedirects)?E.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&r>0&&e.headers.location)this._request({...E,url:e.headers.location,followRedirects:r-1},l).then(u,g);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,S.createGunzip)())),u({res:e,stream:(0,w.streamToBufferReadableStream)(o)})}});n.on("error",g),E.timeout&&n.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),l.onCancellationRequested(()=>{n.abort(),g(new R.CancellationError)})})}async resolveProxy(E){}};f=fe([te(0,c.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,P.ILogService)],f),t.RequestService=f}),define(Z[159],ee([0,1,38,3,15,31,12,2,16,14,13,32,10,20,21,117,58,123,18,100,141,22,119,41,48,145,139,11,109,111,46,107,61,62,122,9,113,114,37,143,131,28,47,146,65,127,66,35,130,42,132,133,29,135,25,142]),function($,t,C,I,w,R,A,v,c,d,D,P,h,S,f,m,E,l,u,g,a,s,i,n,e,r,o,p,y,b,k,x,_,G,Q,ne,ce,re,ge,ae,N,B,M,F,W,q,Y,T,z,O,L,U,V,H,X,oe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class le extends v.Disposable{constructor(ie){super();this.argv=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ie,se]=await this.initServices();return ie.invokeFunction(async he=>{const de=he.get(ne.ILogService),Se=he.get(p.IFileService),Le=he.get(u.INativeEnvironmentService),Fe=he.get(s.IExtensionManagementCLIService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(Le,Fe,Se),await Promise.all(se.map(Ue=>{(0,I.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const ie=new _.ServiceCollection,se={_serviceBrand:void 0,...N.default};ie.set(B.IProductService,se);const he=new g.NativeEnvironmentService(this.argv,se);ie.set(u.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(we=>we?S.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(he),Se=[];Se.push(new ce.SpdLogLogger("cli",(0,d.join)(he.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&Se.push(new ne.ConsoleLogger(de));const Le=this._register(new ne.MultiplexLogService(Se));ie.set(ne.ILogService,Le);const Fe=this._register(new y.FileService(Le));ie.set(p.IFileService,Fe);const Ue=this._register(new b.DiskFileSystemProvider(Le));Fe.registerProvider(c.Schemas.file,Ue);const xe=new q.StateService(he,Le,Fe);ie.set(W.IStateService,xe);const j=new H.UriIdentityService(Fe);ie.set(V.IUriIdentityService,j);const K=new oe.UserDataProfilesService(xe,j,he,Fe,Le);ie.set(X.IUserDataProfilesService,K);const J=D.isWindows&&se.win32RegValueName?this._register(new ae.NativePolicyService(se.win32RegValueName)):he.policyFile?this._register(new re.FilePolicyService(he.policyFile,Fe,Le)):new ge.NullPolicyService;ie.set(ge.IPolicyService,J);const ue=this._register(new m.ConfigurationService(K.defaultProfile.settingsResource,Fe,J,Le));ie.set(f.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),K.setEnablement(se.quality!=="stable"||ue.getValue(X.PROFILES_ENABLEMENT_CONFIG)),ie.set(V.IUriIdentityService,new H.UriIdentityService(Fe)),ie.set(M.IRequestService,new k.SyncDescriptor(F.RequestService)),ie.set(E.IDownloadService,new k.SyncDescriptor(l.DownloadService)),ie.set(n.IExtensionsProfileScannerService,new k.SyncDescriptor(n.ExtensionsProfileScannerService)),ie.set(e.IExtensionsScannerService,new k.SyncDescriptor(o.ExtensionsScannerService)),ie.set(r.INativeServerExtensionManagementService,new k.SyncDescriptor(r.ExtensionManagementService)),ie.set(s.IExtensionGalleryService,new k.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),ie.set(s.IExtensionManagementCLIService,new k.SyncDescriptor(i.ExtensionManagementCLIService)),ie.set(G.ILanguagePackService,new k.SyncDescriptor(Q.NativeLanguagePackService));const me=[],Ce=(0,O.isInternalTelemetry)(se,ue);if((0,O.supportsTelemetry)(se,he)){se.aiConfig&&se.aiConfig.ariaKey&&me.push(new L.OneDataSystemAppender(Ce,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:we}=he,Te={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await S.Promises.readFile(he.stateResource.fsPath);be=JSON.parse(De.toString())[T.machineIdKey]}catch(De){De.code!=="ENOENT"&&Le.error(De)}return(0,Y.resolveCommonProperties)(Fe,(0,C.release)(),(0,C.hostname)(),process.arch,se.commit,se.version,be,Ce,we)})(),piiPaths:(0,O.getPiiPathsFromEnvironment)(he)};ie.set(T.ITelemetryService,new k.SyncDescriptor(z.TelemetryService,[Te]))}else ie.set(T.ITelemetryService,O.NullTelemetryService);return[new x.InstantiationService(ie),me]}registerErrorHandler(ie){(0,A.setUnexpectedErrorHandler)(se=>{const he=(0,R.toErrorMessage)(se,!0);!he||ie.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",se=>(0,A.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,A.onUnexpectedError)(se))}async doRun(ie,se,he){if(this.argv["install-source"])return this.setInstallSource(ie,he,this.argv["install-source"]);if(this.argv["list-extensions"])return se.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const de={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return se.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],de,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return se.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return se.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(ie.appRoot,ie.extensionsPath))}}asExtensionIdOrVSIX(ie){return ie.map(se=>/\.vsix$/i.test(se)?h.URI.file((0,d.isAbsolute)(se)?se:(0,d.join)((0,P.cwd)(),se)):se)}async setInstallSource(ie,se,he){await se.writeFile(h.URI.file(ie.installSourcePath),w.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const ie=new le(ve);try{await ie.run()}finally{ie.dispose()}}t.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e3043ebbc6f73fe66beb80ce6312818ae0e66798/core/vs/code/node/cliProcessMain.js.map
